#include 'fivewin.ch'                              
#include 'xbrowse.ch'
	# include "dbinfo.ch"
	# include "set.ch"
	# include "InKey.ch"
	# ifdef __HARBOUR__
	# ifndef __XHARBOUR__
   # include "xhb.ch"               // Harbour\contrib\xhb\xhb.ch
	# endif
	# endif
	#define BS_MULTILINE 8192
	#define GENBLOCK(x)	 &( "{ || " + x + " }" )		// From FiveDbu
	#xtranslate MainFont() =>WndMain():oFont
	#xtranslate MinMax( <xValue>, <nMin>, <nMax> ) => ;
							Min( Max( <xValue>, <nMin> ), <nMax> )
	#xcommand DBG <vars,...> => ;
				 XBrowse( ArrTranspose( \{ \{ <"vars"> \}, Eval( \{ || \{ <vars> \} \} ) \} ), ;
						ProcName(0) + " : Line : " + LTrim( Str( ProcLine(0) ) ),, ;
						{ |o| o:cHeaders := { "Variable", "Value" } } )


REQUEST DBFCDX
EXTERNAL FieldWBlock
#DEFINE EXENAME "xWDBU"
#define COMPILAR(x) &( "{ || " + x + " }" )		 // From FiveDbu
#define HLP_GOTO	 1
//#define HLP_SEEK  2
#define HLP_SKIP	 3
#define HLP_LOCATE 4

static oWndDbu, oDbfWnd, oFont, lDispMemo := .T.
static cYesLogic := "Yes" , cNoLogic := "No"
static g	// Global Hash variable	 , see loadpreferences
static aWorkAreas[255]    // Used while testing
//----------------------------------------------------------------------------//
function Main(...)
**********************
  LOCAL aParams := HB_aParams()
  LOCAL oMsg
  LoadPreferences(@aParams)
  SetBalloon( .t. )
	 xbrNumformat( ,.t. )
	 SET XBROWSE TO TXBrCode()

	 DEFINE FONT oFont NAME 'TAHOMA' SIZE 0,-12

	 DEFINE WINDOW oWndDbu MDI ;
			TITLE 'DBU for Windows' ;
			MENU MainMenu()

	 oWndDbu:SetFont( oFont )
   //'Developed with Harbour and FWH (FiveWin for Harbour/xHarbour)'
  DEFINE MESSAGE BAR oMsg OF oWndDbu PROMPT 'Configuration file : ' + g:cInifile;
               DATE CLOCK KEYBOARD


//2007
  //SET MESSAGE OF oWndDbu TO 'Configuration file : ' + g:cInifile;
  //             2007 DATE CLOCK KEYBOARD
  
  oWndDbu:bInit := {||IIF(LEN(aParams) > 0 , AEVAL(aParams,{|el|NewFile(el)}) , )}

	 ACTIVATE WINDOW oWndDbu MAXIMIZED ;
   ON DROPFILES Files2Brw( nRow, nCol, aFiles );
   VALID (SaveaAlias())

return nil

//----------------------------------------------------------------------------//

INIT PROCEDURE PrgInit

	 SET AUTORDER TO 1
	 SET DELETED OFF
	 SET EXCLUSIVE OFF

	 SET DATE FRENCH
	 SET CENTURY ON

return

//----------------------------------------------------------------------------//

static function MainMenu()

	 local oMenu, URLNAME := "http://www.fivetechsoft.com"

	 MENU oMenu 2007

					MENUITEM "File"

					MENU
							 MENUITEM "&New"+chr(9)+"Ctrl+U" ;
										RESOURCE "NEW" ;
										ACTION	ModiStruct();
										MESSAGE "Create new DBF file" ;
										ACCELERATOR ACC_CONTROL, asc("U") ;
										ENABLED

							 MENUITEM "&Open"+chr(9)+"Ctrl+A" ;
										RESOURCE "OPEN" ;
										ACTION NewFile() ;
										MESSAGE "Open file" ;
										ACCELERATOR ACC_CONTROL, asc("A") ;
										ENABLED
       
							MENUITEM "Recent files"
								MENU
									MRU g:oMruDBFs ;
         FILENAME g:cIniFile           ; //".\XBRDBU.ini"       ; // .INI to manipulate. '\.' for local
         SECTION  "Recent DBF files"   ; // The name of the INI section
									ACTION	 File2Brw( cMruItem	 ) ; //Open( cMruItem ) ;		// cMruItem is automatically provided
         MESSAGE  "Open this file"     ; // The message for all of them
									SIZE		 10
								ENDMENU

							 MENUITEM "C&lose"+chr(9)+"Ctrl+E" ;
										RESOURCE "SAVE" ;
          ACTION oWndDbu:oWnd:End() ;
										MESSAGE "Close file" ;
										ACCELERATOR ACC_CONTROL, asc("E") ;
										ENABLED
							SEPARATOR

							 MENUITEM "&Print"+chr(9)+"Ctrl+T" ;
										RESOURCE "PRINTER" ;
										ACTION MsgInfo( " oDbfWnd:Report() ") ;
										MESSAGE "Print file" ;
										ACCELERATOR ACC_CONTROL, asc("T") ;
										DISABLED

							 MENUITEM "Command &Interpreter" ;
										RESOURCE "DOT" ;
										ACTION MsgInfo( " DotNew()	");
										MESSAGE "Invokes the command interpreter" ;
										DISABLED

							 MENUITEM "&Modify structure"+chr(9)+"Ctrl+M" ;
										WHEN ! Empty(alias());
										RESOURCE "DESIGN" ;
										ACTION	ModiStruct(alias()) ;
										MESSAGE "Modify file structure" ;
										ACCELERATOR ACC_CONTROL, asc("M") ;
										ENABLED

							 MENUITEM "Multi-&file operation" ;
										RESOURCE "MULTFILE" ;
										ACTION MsgInfo( " MultiFile()	 ");
										MESSAGE "&Multi-file operation" ;
										DISABLED

							 MENUITEM "Import from ODBC database" ;
										RESOURCE "IMPORT" ;
										ACTION MsgInfo( " ImportODBC(oWnd)	");
										MESSAGE "Import data from a ODBC database" ;
										DISABLED

							 MENUITEM "&Configuration" ;
										ACTION Preferences();
										RESOURCE "CONFIG" ;
										MESSAGE "Program configuration" ;
										ENABLED

							 SEPARATOR

							 MENUITEM "Specif&y printer" ;
										RESOURCE "PROPERTY" ;
										ACTION	PrinterSetup()	;
										MESSAGE "Printer configuration" ;
										ENABLED

							 MENUITEM "&Map Network Drive" ;
										RESOURCE "NETCONNE" ;
										ACTION	WNetConnect() ;
										MESSAGE "Connect to a network drive" ;
										ENABLED

							 MENUITEM "&Disconnect Network Drive" ;
										RESOURCE "NETDISCO" ;
										ACTION	WNetDisconnectDialog() ;
										MESSAGE "Disconnect from a network drive" ;
										ENABLED

							 MENUITEM "&Exit"+chr(9)+"Alt+F4" ;
										RESOURCE "EXIT" ;
										ACTION oWndDbu:End() ;
										MESSAGE "Exit from the application" ;
										ENABLED
					ENDMENU

					MENUITEM "&Edit" WHEN ! EMPTY(alias())
					MENU
							 MENUITEM "&Copy record"+chr(9)+"Ctrl+C" ;
										RESOURCE "COPY" ;
          ACTION oDbfWnd:CopyRec();
										MESSAGE "Copy record to the Clipboard" ;
										ACCELERATOR ACC_CONTROL, asc("C") ;
										ENABLED

							 MENUITEM "&Paste record"+chr(9)+"Ctrl+V" ;
										WHEN ! EMPTY(alias()) .AND. ! EMPTY(ClipText());
										RESOURCE "PASTE" ;
          ACTION oDbfWnd:PasteRec();
										MESSAGE "Paste record from the Clipboard" ;
										ACCELERATOR ACC_CONTROL, asc("V")

							 SEPARATOR

							 MENUITEM "&Insert record" + chr(9) ;
										RESOURCE "NEW" ;
										WHEN (! Empty(alias()) .AND. OrdCount()=0 );
										ACTION InsertDbf() ;
										MESSAGE "Insert record" ;
										ACCELERATOR ACC_CONTROL, VK_INSERT ;
										ENABLED

							 MENUITEM "Append record"+chr(9)+"Ctrl+Insert" ;
										RESOURCE "NEW" ;
										ACTION oDbfWnd:AppRec();
										MESSAGE "Append record" ;
										ACCELERATOR ACC_CONTROL, VK_INSERT ;
										ENABLED

							 MENUITEM "&Del/Recall record"+chr(9)+"Ctrl+Del" ;
										RESOURCE "DEL" ;
										ACTION oDbfWnd:DelRec() ;
										MESSAGE "Del actual record" ;
										ACCELERATOR ACC_CONTROL, VK_DELETE ;
										ENABLED

							 MENUITEM "&Edit field"+chr(9)+"Enter" ;
										RESOURCE "TEXTBOX" ;
										ACTION MsgInfo( " oDbfWnd:EditFld() ");
										MESSAGE "Edit actual record field" ;
										DISABLED
										//ACCELERATOR ACC_SHIFT, VK_RETURN ;

							 MENUITEM "&Edit record"+chr(9)+"CTRL+Enter" ;
										RESOURCE "EDIT" ;
										ACTION oDbfWnd:EditRec();
										MESSAGE "Edit actual record (all fields)" ;
										ENABLED
										//ACCELERATOR ACC_CONTROL, VK_RETURN ;

					ENDMENU

					MENUITEM "&Navigation" WHEN ! EMPTY(alias())
					MENU
							 MENUITEM "&Search"+chr(9)+"Ctrl+S" ;
										RESOURCE "SEARCH" ;
          WHEN ! EMPTY(alias()) .AND. OrdCount()>0 .AND. ! oDbfWnd:lArray ;
										ACTION oDbfWnd:Seek() ;
										MESSAGE "Search records using the active index" ;
										ACCELERATOR ACC_CONTROL, asc("S") ;
										ENABLED

							 MENUITEM "&Go to"+chr(9)+"Ctrl+G" ;
										ACTION oDbfWnd:GoTo() ;
										MESSAGE "Jump to a record by its Recno()" ;
										ACCELERATOR ACC_CONTROL, asc("G") ;
										ENABLED

							 MENUITEM "S&kip"+chr(9)+"Ctrl+K" ;
										ACTION oDbfWnd:Skip() ;
										MESSAGE "Skip records" ;
										ACCELERATOR ACC_CONTROL, asc("K") ;
										ENABLED

							 SEPARATOR

							 MENUITEM "&Locate"+chr(9)+"F3" ;
										ACTION oDbfWnd:Locate() ;
										MESSAGE "Locate record" ;
										ACCELERATOR ACC_NORMAL, VK_F3 ;
										ENABLED

							 MENUITEM "&Continue"+chr(9)+"F4" ;
										ACTION oDbfWnd:Locate(.T.) ;
										MESSAGE "Locate next record" ;
										ACCELERATOR ACC_NORMAL, VK_F4 ;
										ENABLED
					ENDMENU

					MENUITEM "&Indexes" WHEN ! Empty(alias()) .AND. ! oDbfWnd:lArray
					MENU
							 MENUITEM OemtoAnsi("&Open Index"+chr(9)+"Ctrl+X") ;
										RESOURCE "OPEN" ;
										ACTION OpenMyIndex();
										MESSAGE "Select an index file" ;
										ACCELERATOR ACC_CONTROL, asc("X") ;
										ENABLED
							 MENUITEM OemtoAnsi("&Close Index"+chr(9)+"Ctrl+L") ;
										RESOURCE "SAVE" ;
										WHEN ! Empty(alias()) .AND. (Alias())->(OrdCount())>0 .AND. ! oDbfWnd:lArray;
										ACTION CloseMyIndex() ;
										MESSAGE "Close current index file" ;
										ACCELERATOR ACC_CONTROL, asc("L") ;
										ENABLED
							 MENUITEM "&Index order"+chr(9)+"Ctrl+P" ;
										RESOURCE "PREV" ;
										WHEN ! Empty(alias()) .AND. (Alias())->(OrdCount())>0 .AND. ! oDbfWnd:lArray;
										ACTION MySetOrder();
										MESSAGE "Select index order from list" ;
										ACCELERATOR ACC_CONTROL, asc("P") ;
										ENABLED
							 MENUITEM OemtoAnsi("&Filter by scope"+chr(9)+"Ctrl+F") ;
          RESOURCE "Filter1" ;
          WHEN ! Empty(alias()) .AND. (Alias())->(OrdCount())>0 .AND. (VALTYPE(oDbfWnd)<>"O" .OR. ! oDbfWnd:lArray);
										ACTION MyScopes();
										MESSAGE "Set a scope to filter records, based on the active index" ;
										ACCELERATOR ACC_CONTROL, asc("F") ;
										ENABLED
							 MENUITEM OemtoAnsi("&Change/add index"+chr(9)+"Ctrl+W") ;
										RESOURCE "INDEX" ;
										WHEN ! Empty(alias()) .AND. ! oDbfWnd:lArray;
										ACTION ChangeAddIndex();
										MESSAGE "Change or add new index file or Tag" ;
										ACCELERATOR ACC_CONTROL, asc("W") ;
										ENABLED
					ENDMENU

					MENUITEM "&Utilities" WHEN ! Empty(alias())
					MENU
							 MENUITEM "&More information"+chr(9)+"Ctrl+I" ;
										RESOURCE "PROPERTY" ;
										ACTION MsgInfo( " oDbfWnd:Info() ");
										MESSAGE "Show additional information about the current file" ;
										ACCELERATOR ACC_CONTROL, asc("I") ;
										DISABLED

							 MENUITEM "&Browse Columns"+chr(9)+"Ctrl+B" ;
										RESOURCE "TBROWSE"										;
          ACTION ColumnConfig()       ;
										MESSAGE "Columns Configuration"				;
										ACCELERATOR ACC_CONTROL, asc("B")			;
										ENABLED

							 MENUITEM "&Relations"	;
          RESOURCE "CHAIN"    ;
          ACTION Relations()  ;
          WHEN LEN(aGetWorkAreas()) > 1 ;
										MESSAGE "Establish relations with other databases" ;
										ENABLED

							 MENUITEM "Establish &Filter" ;
          RESOURCE "FILTER"          ;
          ACTION oDbfWnd:Filter()    ;
										MESSAGE "Set the criteria by which to filter records" ;
										ENABLED

        MENUITEM "Coun&t"             ;
          ACTION oDbfWnd:ReplaceFor(4);
										MESSAGE "Count the number of records meeting a certain criteria" ;
										ENABLED

							 MENUITEM "&Statistics";
										WHEN ! EMPTY(alias()) .AND. ASCAN(oDbfWnd:aStruc , {|a|a[2]="N"})>0;
										RESOURCE "STATICS" ;
          ACTION oDbfWnd:ReplaceFor(5);
										MESSAGE "Statistics calculations of all numeric fields" ;
										ENABLED

							 MENUITEM "&Graphics" ;
										RESOURCE "GRAPH" ;
										ACTION MsgInfo( " oDbfWnd:Graphics() ");
										MESSAGE "Graphics based on current data file" ;
										DISABLED

							 SEPARATOR

							 MENUITEM "&Append from..." ;
										RESOURCE "IMPORT" ;
          WHEN EMPTY(alias()) .AND. ! oDbfWnd:lArray ;
          ACTION oDbfWnd:CopyAppend(1) ; 
										MESSAGE "Append records from another file" ;
										ENABLED

							 MENUITEM "&Copy to..." ;
										RESOURCE "COPY" ;
          ACTION oDbfWnd:CopyAppend(2) ; 
										MESSAGE "Copy records to another file" ;
										ENABLED

							 MENUITEM "&Delete..." ;
										RESOURCE "DEL" ;
          ACTION oDbfWnd:ReplaceFor(3);
										MESSAGE "Delete all records matching a certain criteria" ;
										ENABLED

							 MENUITEM "Reca&ll..." ;
          ACTION oDbfWnd:ReplaceFor(2);
										MESSAGE "Recall all records matching a certain criteria" ;
										ENABLED

							 MENUITEM "R&eplace..." ;
          ACTION oDbfWnd:ReplaceFor(1);
										MESSAGE "Replace all records matching a certain criteria" ;
										ENABLED

							 MENUITEM "S&cript process..." ;
										RESOURCE "SCRIPT" ;
										ACTION MsgInfo( " oDbfWnd:Script()	");
										MESSAGE "Process a script file to all records matching a certain criteria" ;
										WHEN .F.;
										DISABLED

							 MENUITEM "Pac&k" ;
          ACTION oDbfWnd:PackZap(1);
										MESSAGE "Eliminate phisically deleted records" ;
										ENABLED

							 MENUITEM "&Zap" ;
          ACTION oDbfWnd:PackZap(2);
										MESSAGE "Delete every record in the database" ;
										ENABLED

							 SEPARATOR

							 MENUITEM "&Oem to Ansi" ;
										ACTION MsgInfo( " oDbfWnd:OtoA(.F.)	 ");
										MESSAGE "Translate from OEM to ANSI" ;
										WHEN .F.;
										DISABLED

							 MENUITEM "A&nsi to Oem" ;
										ACTION MsgInfo( " oDbfWnd:OtoA(.T.)	 ");
										MESSAGE "Translate from ANSI to OEM" ;
										WHEN .F.;
										DISABLED
					ENDMENU

					MENUITEM "&Windows"
					MENU
					MENUITEM "&Cascade" ;
							 RESOURCE "CASCAWND" ;
							 MESSAGE OemToAnsi( "Organize windows on cascade" ) ;
							 ACTION oWndDbu:Cascade()

					MENUITEM "&Vertical mosaic" ;
							 RESOURCE "MOSVRWND" ;
							 MESSAGE OemToAnsi( "Organize windows on vertical mosaic" ) ;
							 ACTION oWndDbu:Tile()

					MENUITEM "&Horizontal mosaic" ;
							 RESOURCE "MOSHRWND" ;
							 ACTION oWndDbu:Tile( .t. );
							 MESSAGE OemToAnsi( "Organize windows on horizontal mosaic" )

					MENUITEM "&Minimize Windows" ;
							 RESOURCE "MINIMWND" ;
							 ACTION oWndDbu:IconizeAll() ;
							 MESSAGE "Minimize all Windows"

					MENUITEM "&Restore all windows" ;
							 RESOURCE "MAXIMWND" ;
							 ACTION Asend( oWndDbu:oWndClient:aWnd,'NORMAL') ;
							 MESSAGE "Restore all windows"

					MENUITEM "C&lose windows" ;
							 RESOURCE "CLOSEWND" ;
							 ACTION oWndDbu:CloseAll() ;
							 MESSAGE "Close all windows"

					MENUITEM "&Organize Icons" ;
							 MESSAGE OemToAnsi( "Organize minimized windows" ) ;
							 ACTION oWndDbu:ArrangeIcons()

					ENDMENU

					MENUITEM "&Help"
					MENU
							 MENUITEM "&Index"+chr(9)+"F1" ;
										RESOURCE "HELP" ;
										ACTION MsgInfo( " HelpIndex()	 ");
										MESSAGE "Shows the Help contents" ;
										DISABLED

							 MENUITEM "&Using Help" ;
										ACTION MsgInfo( " Winhelp.hlp") ;
										MESSAGE "More information about using help" ;
										DISABLED

							 MENUITEM "&Readme text file" ;
										RESOURCE "NOTEPAD" ;
										ACTION	WinExec("Notepad readme.txt") ;
										MESSAGE "Modifications and enhancements not present on the help file" ;
										ENABLED

							 SEPARATOR

							 MENUITEM "&Web page (Internet)" ;
										RESOURCE "INTERNET" ;
										ACTION ShellExecute( oWndDbu:hWnd, "open", URLNAME ) ;
										MESSAGE "Web page on the Internet" ;
										ENABLED

							 MENUITEM "&Send mail" ;
										RESOURCE "MAIL" ;
										ACTION	MsgInfo(" SendMail() ") ;
										MESSAGE "Contact with us via eMail" ;
										DISABLED

							 MENUITEM "&Calculator" ;
										RESOURCE "CALC" ;
										ACTION	WinExec("Calc.exe") ;
										MESSAGE "Windows calculator" ;
										DISABLED

							 SEPARATOR

							 MENUITEM "&About "+EXENAME ;
										RESOURCE "INFO" ;
										ACTION MsgAbout( "DBU for Windows", "(c) FiveTech Software 2011" ) ;
										MESSAGE "More information about the program" ;
										ENABLED
					ENDMENU

ENDMENU

return oMenu

//----------------------------------------------------------------------------//

static function files2brw( nRow, nCol, aFiles )

	 local cFile

	 for each cFile in aFiles
			if Upper( cFileExt( cFile ) ) == 'DBF'
				 File2Brw( cFile )
			else
				 CheckBrwDrop( ClientToScreen( oWndDbu:hWnd, { nRow, nCol } ), cFile)
			endif
	 next

return nil

//----------------------------------------------------------------------------//
# define MSGINI     1
# define MSGRDD     2
# define MSGTAG     3
# define MSGSETDEL  4
# define MSGSHARED  5
# define MSGRECNO   6
# define MSGDELETE  7
static function file2brw( cFile , lDefault)

	 local oWndChild, oBrw , cTitle
	 local cAlias, cFileNoExt
  local oMsgBar , aItem[MSGDELETE] , lOk , OriColor , NewColor
	 local oCol
	 local aArrayData[0] , i , a , c
	 local aHeaders , aCols , aSizes , aPict , aExpr , aShows
  local aIndex , aRelations , cFilter , aScopes
  local lLoadSaveBrw := g:lLoadSaveBrw
  local Self
  DEFAULT lDefault := g:lDefault
	 # ifdef TEST
   //lDefault := .T.
	 # endif
  if ! Open( cFile, @cAlias , lDefault , @lLoadSaveBrw)
     return nil
	 endif
  
  IF lLoadSaveBrw
     (cAlias)->(InitAliasFromh(@aIndex , @aRelations )) //, @cFilter , @aScopes))  // Index , Relations , Filter , scopes
  END
  (cAlias)->(InitColumnsFromh(@aHeaders , @aCols , @aSizes , @aPict , @aExpr , @aShows))
  cTitle := cFileNoExt( cFile )
		cTitle +=	 " , Alias : " + cAlias
	 DEFINE WINDOW oWndChild MDICHILD OF oWndDbu TITLE cTitle
  
  @ 0,0 XBROWSE oBrw OF oWndChild ;
			ALIAS cAlias ;
			COLUMNS aCols;
			SIZES aSizes ;
			HEADERS aHeaders;
			PICTURES aPict;
			AUTOCOLS AUTOSORT FOOTERS LINES CELL NOBORDER

		WITH OBJECT oBrw
      :lEditMode := .T.
      :bChange := {||EVAL(aItem[MSGRECNO]:bMsg),EVAL(aItem[MSGDELETE]:bMsg),oMsgBar:Refresh(),;
											(cAlias)->(SetRowEditType( oBrw ))}


      FOR EACH oCol IN :aCols
          oCol:cExpr    := aExpr[Hb_EnumIndex()]

         // Not needed from FWH 13/01 (bOnPostEdit)
         oCol:bOnPostEdit := { |o,x,n| If( n != VK_ESCAPE .and. Eval( o:oBrw:bLock ),;
																			( o:Value := x, Eval( o:oBrw:bunLock )		 ), ) }
      NEXT
      SetTagColumns(oBrw)
		END
  
  IF ! __ObjHasMethod(oBrw,"IndexRecno")
     __ObjAddMethod(oBrw,"IndexRecno" ,@IndexRecno())
	 END

	__ObjModMethod(oBrw,"BrwFitSize" ,@BrwFitSize())

	 FOR EACH oCol IN oBrw:aCols
     oCol:cCol := oCol:cHeader
     IF oCol:cDataType=="M"
        oCol:bStrData := {||IIF(VALTYPE(oCol:Value)=="A" , "{...}" , oCol:Value)}
     END
	 NEXT

	 oBrw:bPopUp			 := { |o| ColMenu( o ) }

	 oBrw:CreateFromCode()
	 oWndChild:oClient := oBrw

	 BrwBtnBar( oBrw	)


	 DEFINE MESSAGE BAR oMsgBar OF oWndChild PROMPT cFile //2007

  DEFINE MSGITEM aItem[MSGINI] OF oMsgBar ;
     PROMPT "Status file : " + IIF(lLoadSaveBrw , g[cAlias]:cIniFile , "None")  ;
     SIZE 150;
     COLOR OriColor
  
  aItem[MSGINI]:bAction := {|| ShowState(g[cAlias]:cIniFile)}
  
  DEFINE MSGITEM aItem[MSGRDD] OF oMsgBar ;
					PROMPT "RDD : " +	 (cAlias)->(RddName()) ;
					SIZE 100;
					COLOR OriColor

		DEFINE MSGITEM aItem[MSGTAG] OF oMsgBar ;
					PROMPT "Ordered by: "							;
					COLOR CLR_BLACK,CLR_YELLOW				;
					SIZE 150

		aItem[MSGTAG]:bMsg := {||c := "Ordered by: "+IIF(! Empty( (cAlias)->( OrdName() )) ,;
																											(cAlias)->( OrdName() ),;
																											 "Natural order" ),;
																	 c += STR((cAlias)->(IndexOrd()),2) +"/" + STR((cAlias)->(OrdCount()),2) ,;
																	 aItem[MSGTAG]:SetText(c) , oMsgBar:Refresh()}

		EVAL(aItem[MSGTAG]:bMsg)
		aItem[MSGTAG]:bAction := {||MySetOrder() , EVAL(aItem[MSGTAG]:bMsg) }


	 DEFINE MSGITEM aItem[MSGSETDEL] OF oMsgBar ;
					PROMPT IIF(Set( _SET_DELETED ),"NO DELETED","SHOW DELETED") SIZE 90;
					COLOR CLR_BLACK,CLR_YELLOW

	 IF ! __ObjHasMethod(aItem[1] , "SetColor")
     __ObjAddMethod(aItem[1],"SetColor" ,@MsgItemColor())
	 ELSE
     __ObjModMethod(aItem[1],"SetColor" ,@MsgItemColor())
			// Original one (FWH1301) doesn't return colors
	 END
	 IF ! __ObjHasMethod(aItem[1] , "SetBitmap")
			__ObjAddMethod(aItem[1],"SetBitMap",@MsgItemBitMap())
	 END
	 OriColor := aItem[2]:SetColor(CLR_BLACK,CLR_YELLOW)	// Edit item
	 NewColor := {CLR_WHITE , CLR_HRED}
	 aItem[MSGSETDEL]:bMsg		:= {||aItem[MSGSETDEL]:SetText(IIF(Set( _SET_DELETED ),;
																													 "NO DELETED","SHOW DELETED")) }
	 aItem[MSGSETDEL]:bAction := {||lOk := Set( _SET_DELETED)							 ,;
																							Set( _SET_DELETED , ! lOk) ,;
																							oDbfWnd:Readdata()						,;
																							EVAL(aItem[MSGSETDEL]:bMsg) }

	 DEFINE MSGITEM aItem[MSGSHARED] OF oMsgBar;
					PROMPT IIF((cAlias)->(DbInfo(DBI_SHARED)),"Shared","Exclusive");
					SIZE 80

	 aItem[MSGSHARED]:bMsg := {||aItem[MSGSHARED]:SetColor(IIF((cAlias)->(DbInfo(DBI_SHARED)) ,;
																												 OriColor	 , NewColor)) , ;
															 aItem[MSGSHARED]:Settext(IIF((cAlias)->(DbInfo(DBI_SHARED)),;
																												 "Shared","Exclusive")) }

	 DEFINE MSGITEM aItem[MSGRECNO] OF oMsgBar;
					PROMPT STR((cAlias)->(Recno()),6) + "/" + STR((cAlias)->(Reccount()),6);
					SIZE 100 COLOR CLR_WHITE , CLR_HBLUE;
					ACTION oDbfWnd:GoTo()

	 aItem[MSGRECNO]:bMsg := {||aItem[MSGRECNO]:SetText(STR((cAlias)->(Recno()),6) + "/" + STR((cAlias)->(Reccount()),6)) }

	 DEFINE MSGITEM aItem[MSGDELETE] OF oMsgBar;
					PROMPT IIF((cAlias)->(Deleted()),"Deleted","");
					SIZE 80

	 aItem[MSGDELETE]:bMsg := {||aItem[MSGDELETE]:SetColor(IIF((cAlias)->(Deleted()),;
																												 NewColor	 , OriColor)) , ;
															 aItem[MSGDELETE]:Settext(IIF((cAlias)->(Deleted()),;
																												"Deleted","Non Deleted"))}

	 aItem[MSGDELETE]:bAction := {||oDbfWnd:DelRec()}

  oWndChild:bValid := {||IIF((cAlias)->(CheckrelAlias()) , .F. , ((cAlias)->(SaveState(oWndChild)) , testIndexWnd(cFileNoExt(cFile)) ,;
                         (cAlias)->(DbCloseArea()),oWndChild := nil , oDbfWnd := nil , .T.))}

		AEVAL(oBrw:aCols , {|o|IIF(o:cSortOrder<>nil,o:bLClickHeader := {||EVAL(aItem[MSGTAG]:bMsg)},)})
	 ACTIVATE WINDOW oWndChild ON INIT (i := 1 , AEVAL(oBrw:aCols,{|o|IIF(!aShows[i++],o:Hide(),)}),;
																			EVAL(oBrw:bChange,oBrw))
  Self := TDbfWnd():New( oWndChild, oBrw )
  ::aIndex     := aIndex
  ::aRelations := aRelations
  aWorkAreas[Select()] := Self   // Used when testing
return nil
*********************************************************************************
STATIC Func ReadDbf(aCols)
**************************
local Self := oDbfWnd
LOCAL Arr[0]
DBGotop()
DbEval({||AADD(Arr,ReadRec(aCols))})
RETURN Arr
*********************************************************************************
STATIC Func ReadRec(aCols)
**************************
local Arr[LEN(aCols)] , i := 1
AEVAL(aCols,{|b|Arr[i++] := EVAL(b)})
RETURN Arr
*********************************************************************************
STATIC PROC SaveState(oWndChild)
********************
local self := oWndChild:Cargo
local oBrw := ::oBrowse
if g:lLoadSaveBrw
   SaveTohIni(Self)
   Hb_WriteIni(g[::cAlias]:cIniFile , g[::cAlias]:hIni)
endif
hDel(g,::cAlias)
RETURN

*********************************************************************************
	static proc testIndexWnd(cFile)
	*******************************
	local oWnd := SearchWnd("Indexes of " + cFile,"TMDICHILD")
 IF oWnd<>nil
		oWnd:end()
	END
	oWnd := SearchWnd("Relations of " + cFile,"TMDICHILD")
	IF oWnd<>nil
		oWnd:end()
	END
	return
	static func SearchWnd(cTitle,ClassName)
	***************************************
	local aWin := GetAllWin()
	local i , oWnd
	i := ASCAN(aWin,{|o|Valtype(o)=="O" .AND. IIF(PCOUNT()==2,o:ClassName=ClassName,.T.) ;
											.AND. UPPER(o:cTitle)=UPPER(cTitle)})

	IF i > 0
	 oWnd := aWin[i]
	END

	RETURN oWnd
//----------------------------------------------------------------------------//

static function CheckBrwDrop( aPoint, cFile )

	 local ownd, oBrw, nRow, nCol
	 local nColPos, nRowPos

	 if ( oDbfWnd := oWndDbu:oWndActive ) != nil
			oBrw	:= oWnd:oClient
			if oBrw != nil .and. oBrw:IsKindOf( TXBrowse() )
				 aPoint		:= ScreenToClient( oBrw:hWnd, aPoint )
				 nRow			:= aPoint[ 1 ]
				 nCol			:= aPoint[ 2 ]
				 if oBrw:DropFile( nRow, nCol, cFile )
//						MsgInfo( 'handled' )
				 else
						msginfo( 'Not Valid File' )
				 endif
			endif
	 endif

return nil

//----------------------------------------------------------------------------//

function Open( cFileName , cAlias  , lDefault , lLoadSaveBrw )
*********************************************************
local cRDD , lChange := .T. , aMemoExt[2] , aRdd[2] , aIndexExt[2]
local lMemo := .F. , lIndex := .F. , cMemoFile , cIndexFile
local oDlg
local nRdd := 1 , lOk := .F.
local cPath , cFilName, cExtension
local lShared := g:lShared
//local lLoadSaveBrw := g:lLoadSaveBrw
local x , i , j , c , o
local cIniFile  , aStruct
local nRow
local cState , h
DEFAULT lDefault := .F.
DEFAULT cFileName := cGetFile( "*.dbf", "Please select a DBF" )

if Empty( cFileName )
  return .F.
endif

if ! "." $ cFileName
  cFileName += ".dbf"
endif


if ! Upper( cFileExt( cFileName ) ) == 'DBF'
  MsgStop( "File must be a DBF-file")
  return .F.
endif


if ! File( cFileName )
  MsgStop( "File not found: " + cFileName )
  return .F.
endif

Hb_fNameSplit(cFileName,@cPath,@cFilName,@cExtension)
IF EMPTY(cPath)
   cPath   := CurDrive()+":\"+CurDir()+"\"
   cFilName := cPath + cFilName + cExtension
ELSE
   cFilName := cFileName
END
cIniFile  := cFileSetExt( cFileName, "xbr" )
IF g:cDefRdd == "DBFCDX"
		aMemoExt	:= {"FPT","DBT"}
		aIndexExt := {"CDX","NTX"}
		aRdd			:= {"DBFCDX","DBFNTX"}
ELSE
		aMemoExt	:= {"DBT","FPT"}
		aIndexExt := {"NTX","CDX"}
		aRdd			:= {"DBFNTX","DBFCDX"}
END
lMemo := .T.
IF File( cMemoFile := cFileSetExt( cFileName, aMemoExt[1] ))
   cRDD := aRdd[1]
			lChange := .F.
ELSEIF File( cMemoFile := cFileSetExt( cFileName, aMemoExt[2] ))
			cRDD := aRdd[2]
			lChange := .F.
ELSE
			lMemo := .F.
END
lIndex := .T.
IF File( cIndexFile := cFileSetExt( cFileName, aIndexExt[1] ))
   IF ! lMemo
      cRDD := aRdd[1]
      lChange := ! g:lAutopen
   END
ELSEIF File( cIndexFile := cFileSetExt( cFileName, aIndexExt[2] ))
   IF ! lMemo
      cRDD := aRdd[2]
      lChange := ! g:lAutopen
   END
ELSE
   lIndex := .F.
   IF ! lMemo
      cRDD := g:cDefRdd
        lChange := .T.
   END
endif
IF ! lDefault
  DEFINE DIALOG oDlg FONT WndMain():oFont() SIZE 400 ,285 PIXEL TITLE "Open " + cFilName
		@ 10 , 10	 GROUP TO 42 , 60 LABEL "RDD : " PIXEL OF oDlg
		nRDD := ASCAN({"DBFCDX","DBFNTX"},cRdd)
		@ 20 , 20 RADIO nRdd PROMPT "DBFCDX","DBFNTX" OF oDlg PIXEL SIZE 35,10 WHEN lChange
		@ 45 , 28 CHECKBOX lShared PROMPT "Shared" OF oDlg PIXEL SIZE 40,10
  nRow := 15
  IF lIndex
     lIndex := g:lAutopen
     @ nRow , 75 CHECKBOX lIndex PROMPT "Open indexfile : " + cFileNoPath(cIndexFile) OF oDlg PIXEL
		END
		IF lMemo
     nRow += 15
     @ nRow , 75 CHECKBOX lMemo PROMPT "Open Memofile : " + cFileNoPath(cMemoFile) OF oDlg PIXEL WHEN .F.
		END
  IF File(cIniFile)
    h := Hb_ReadIni(cIniFile,.F.)
    
    c := ""
    IF  ("MAIN" IN h) .AND. ("FILTER" IN h:Main)     
       c += "FILTER : " + h["MAIN","FILTER"]
    END
    IF ("COLUMNS" IN h)
       c += CRLF + "COLUMNS : " 
       j := LEN(c)
       FOR EACH i IN h:Columns
         x := TOKEN(i,";",1,1) + IIF(HB_EnumIndex() < LEN(h:Columns) , "," ,"")
         IF LEN(c) + LEN(x) - j <= 47
            c += x 
         ELSE
            j := (47 - LEN(c) + j)
            IF j > 0
               c += LEFT("...",MIN(j,3))
            END
            EXIT
         END
       NEXT
    END
    IF ("ARELATIONS" IN h)
       c += CRLF + "RELATIONS : "
       j := LEN(c)
       FOR EACH i IN h:aRelations
         x := " ON " + TOKEN(i,";",1,1) + " INTO " + TOKEN(i,";",2,1) +;
              IIF(HB_EnumIndex() < LEN(h:aRelations) , " , "  ,"")
         IF LEN(c) + LEN(x) - j <= 47
            c += x 
         ELSE
            j := (47 - LEN(c) + j)
            IF j > 0
               c += LEFT("...",MIN(j,3))
            END
            EXIT
         END
       NEXT
    END 
    IF ("SCOPES" IN h) 
       c += CRLF + "SCOPES : "
       j := LEN(c)
       FOR EACH i IN hGetKeys(h:Scopes)
         x := i + ":" + h:Scopes[i] + IIF(HB_EnumIndex() < LEN(h:Scopes) , " , "  ,"") 
         IF LEN(c) + LEN(x) - j <= 47
            c += x 
         ELSE
            j := (47 - LEN(c) + j)
            IF j > 0
               c += LEFT("...",MIN(j,3))
            END
            EXIT
         END
       NEXT
    END
    IF ("AINDEX" IN h) 
       c += CRLF + "INDEX : " 
       j := LEN(c)
       FOR EACH i IN h:aIndex
         x := TOKEN(i,";",3,1) + IIF(HB_EnumIndex() < LEN(h:aIndex) , "," ,"")
         IF LEN(c) + LEN(x) - j <= 47
            c += x 
         ELSE
            j := (47 - LEN(c) + j)
            IF j > 0
               c += LEFT("...",MIN(j,3))
            END
            EXIT
         END
       NEXT
    END
    
    nRow += 15  
    @ nRow , 75 CHECKBOX lLoadSaveBrw PROMPT "Restore previous state (" + ;
                         cFileNoPath(cIniFile) + ")" OF oDlg PIXEL 
    
    nRow += 20
    @ nRow , 90 BUTTON "View state"  OF oDlg PIXEL SIZE 60,12;
                ACTION ShowState(cIniFile) 
    
    @ 65 , 5 GET c OF oDlg MEMO PIXEL SIZE 190,55
  END
  @ 123 , 50 BUTTON "OK"   OF oDlg PIXEL SIZE 30,15 ;
             ACTION ( lOk := .T. , oDlg:end() ) DEFAULT
  @ 123 , 105 BUTTON "CANCEL" OF oDlg PIXEL SIZE 30,15;
             ACTION oDlg:end()
  
  ACTIVATE DIALOG oDlg CENTERED
ELSE
  lOk := .T.
END
IF lOk
		SET AUTOPEN (lIndex) //(g:lAutopen)
		cAlias	= cGetNewAlias( cFileNoExt( cFileName ) )
		if lShared
     USE ( cFileName ) VIA cRDD NEW SHARED ALIAS ( cAlias )
		else
     USE ( cFileName ) VIA cRDD NEW EXCLUSIVE ALIAS ( cAlias )
		endif
		SET AUTOPEN OFF
		IF EMPTY(Alias())
     MsgStop(cFileName + " can't be opened")
     RETURN .F.
		END
  g[cAlias] := Hash()
		hSetCaseMatch(g[cAlias] , .F.)
		g[cAlias]:cIniFile := cIniFile
  g:oMruDBFs:Save( cFileName )

  IF ! File(g[cAlias]:cIniFile)
    g[cAlias]:hIni      := Hash()
    hSetCaseMatch(g[cAlias]:hIni , .F.)
    HSetAACompatibility(g[cAlias]:hIni , .T.)
    g[cAlias]:hIni["COLUMNS"] := Hash()
    g[cAlias]:hIni["MAIN"]          := Hash()
    g[cAlias]:hIni["MAIN","FILTER"] := ""
    g[cAlias]:hIni["ARELATIONS"]    := Hash()
    g[cAlias]:hIni["SCOPES"]        := Hash()
    g[cAlias]:hIni["AINDEX"]        := Hash()
		ELSE
    g[cAlias]:hIni      := HB_ReadIni(g[cAlias]:cIniFile,.F.)
    IF ! ("COLUMNS" IN g[cAlias]:hIni)
       g[cAlias]:hIni["COLUMNS"] := Hash()       
    END
    IF ! ("MAIN" IN g[cAlias]:hIni)
       g[cAlias]:hIni["MAIN"] := Hash()       
    END
    IF ! ("FILTER" IN g[cAlias]:hIni["MAIN"])
       g[cAlias]:hIni["MAIN","FILTER"] := ""
    END
    IF ! ("ARELATIONS" IN g[cAlias]:hIni)
       g[cAlias]:hIni["ARELATIONS"] := Hash()       
    END
    IF ! ("SCOPES" IN g[cAlias]:hIni)
       g[cAlias]:hIni["SCOPES"] := Hash()       
    END
    IF ! ("AINDEX" IN g[cAlias]:hIni)
       g[cAlias]:hIni["AINDEX"] := Hash()       
    END
		END
  IF LEN(g[cAlias]:hIni:Columns) == 0
    aStruct := (cAlias)->(Dbstruct())
    FOR i := 1 TO (cAlias)->(FCOUNT())
      c := cHeader((cAlias)->(FieldName(i)))
      g[cAlias]:hIni["COLUMNS" , LTRIM(STR(i))] :=  c + " ; FieldBlock('" + c + "');;;.T."
    NEXT
  END
		RETURN .T.
END
RETURN .F.
//----------------------------------------------------------------------------//
static proc NewFile(cDbfFile)
	local cFile
 if cDbfFile <> nil .AND. ! Empty( cDbfFile )
    File2Brw( cDbfFile , .T.)
    Return
 endif

	 if ! Empty( cFile := cGetFile(		"DataFile (*.DBF)|*.dbf|",					;
																		"Select Data File to Browse",1,			;
																		"\fwh\samples" ) )
			File2Brw( cFile )
	 endif

return

//----------------------------------------------------------------------------//


static function BrwbtnBar( oBrw	 )

	 local oBar, oBtn

	 DEFINE BUTTONBAR oBar OF oBrw:oWnd SIZE 56,64 3D 2007

	 DEFINE BUTTON OF oBar ;
			RESOURCE "REPORT" TOP ;
			PROMPT "Report" ;
			MENU ReportMenu( oBrw ) ;
			ACTION This:ShowPopUp() ;
			MESSAGE "Print the browse contents" ;
			TOOLTIP { "Print Report", "Report" }

	 DEFINE BUTTON OF oBar ;
			RESOURCE "EXCEL" TOP ;
			PROMPT "Excel" ;
			ACTION This:ShowPopUp() ;
			MENU ExcelMenu( oBrw ) ;
			MESSAGE "Export browse contents to Excel" ;
			TOOLTIP { "Export to Excel", "Excel" }

   DEFINE BUTTON OF oBar ;
			RESOURCE "CONFIG" TOP ;
			PROMPT "Config" ;
			MENU ConfigMenu( oBrw )	 ;
			ACTION This:ShowPopUp() ;
			MESSAGE "Change background, Style2007, FastEdit option, etc" ;
			TOOLTIP { "Configure", "SetUp",,CLR_BLUE,nRGB(220,230,247) }

	 DEFINE BUTTON OF oBar ;
			RESOURCE 'CODE' TOP ;
			PROMPT 'Source' ;
   ACTION ViewCode( oBrw ) ; 
   TOOLTIP 'Generate program source'

	 DEFINE BUTTON OF oBar ;
			RESOURCE 'DLG' TOP ;
			PROMPT 'Dialog' ;
			ACTION SetBrwInDlg( oBrw ) ;
			TOOLTIP 'View Browse in Dialog'

   DEFINE BUTTON OF oBar ;
      RESOURCE 'BROWSE' TOP ;
      PROMPT 'Columns' ;
      GROUP;
      ACTION ColumnConfig() ;
      TOOLTIP 'View Browse in Dialog'

   DEFINE BUTTON oBtn OF oBar ;
      RESOURCE 'ARRAY' TOP ;
      PROMPT 'Array Browse' ;
      ACTION DbfToArray(.T.,oBtn) ;
      TOOLTIP 'Transform to array / dbf'
   
   DEFINE BUTTON OF oBar ;
      RESOURCE 'FILTER' TOP ;
      PROMPT 'Filter' ;
      GROUP;
      ACTION oDbfWnd:Filter() ;
      TOOLTIP "Set the criteria by which to filter records"

   DEFINE BUTTON OF oBar ;
      RESOURCE 'Filter1' TOP ;
      PROMPT 'Top Bottom Scope'; 
      WHEN  ! Empty(alias()) .AND. (Alias())->(OrdCount())>0 .AND. (VALTYPE(oDbfWnd)<>"O" .OR. ! oDbfWnd:lArray);
      ACTION MyScopes();
      TOOLTIP "Set a scope to filter records, based on the active index" 

   DEFINE BUTTON OF oBar ;
      RESOURCE 'RELATION' TOP ;
      PROMPT 'Relations';
      GROUP;
      WHEN LEN(aGetWorkAreas()) > 1;//LEN(hIndex)>1;
      ACTION Relations();
      TOOLTIP "Set relations between workareas"

   DEFINE BUTTON OF oBar ;
      RESOURCE 'index' TOP ;
      PROMPT 'Indexes';
      MENU IndexMenu( oBrw ) ;
      ACTION This:ShowPopUp() ;
      TOOLTIP "Index management"


return oBar

//----------------------------------------------------------------------------//

static function SetBrwInDlg( oBrw )

	 local oDlg

	 oDbfWnd = oBrw:oWnd

	 DEFINE DIALOG oDlg SIZE 800,600 PIXEL TITLE oDbfWnd:cTitle

	 ACTIVATE DIALOG oDlg ;
			ON INIT InitBrwDlg( oBrw, oDlg ) ;
			VALID ExitBrwDlg( oBrw, oDbfWnd ) ;
			ON RIGHT CLICK ( SetWindowLong( oBrw:hWnd, -20, ;
				 nXor( GetWindowLong( oBrw:hWnd, -20 ), 0x200 ) ) )

return nil

//----------------------------------------------------------------------------//

static function InitBrwDlg( oBrw, oDlg )

	 local oDbfWnd	:= oBrw:oWnd
	 local nColsWidth	 := oBrw:GetDisplayColsWidth() + 24

	 oBrw:oWnd	 := oDlg
	 SetParent( oBrw:hWnd, oDlg:hWnd )
	 oBrw:nTop			:= 20
	 oBrw:nLeft			:= 20
	 oBrw:nHeight		:= oDlg:nHeight - 80
	 oBrw:nWidth		:= oDlg:nWidth - 40
	 if oBrw:nWidth > nColsWidth
			oBrw:nWidth				:= nColsWidth
			oDlg:nWidth				:= oBrw:nWidth + 40
	 endif
	 oBrw:Resize()
	 oDlg:Center()
	 oDbfWnd:Hide()

return .f.

//----------------------------------------------------------------------------//

static function ExitBrwDlg( oBrw, oWnd )

	 oBrw:oWnd := oWnd
	 SetParent( oBrw:hWnd, oWnd:hWnd )
	 oWnd:oClient := oBrw
	 oWnd:Show()
	 oWnd:ReSize()

return .t.

//----------------------------------------------------------------------------//

static function ExcelMenu( oBrw )

	 local oPop

	 MENU oPop POPUP 2007
			MENUITEM "Export to Excel" ACTION oBrw:ToExcel()
			MENUITEM "Export to Excel with Group Totals" ;
				 WHEN ! Empty( oBrw:GetVisibleCols()[1]:cOrder ) ;
				 ACTION oBrw:ToExcel(,1)
	 ENDMENU

return oPop

//----------------------------------------------------------------------------//

static function ReportMenu( oBrw )

	 local oPop

	 MENU oPop POPUP 2007
			MENUITEM "Simple Report" ACTION oBrw:Report()
			MENUITEM "Report with Grouping" ;
				 WHEN ! Empty( oBrw:GetVisibleCols()[1]:cOrder ) ;
				 ACTION oBrw:Report( nil, .t., .t., nil, 1 )
	 ENDMENU

return oPop

//----------------------------------------------------------------------------//

static function ColMenu( ocol )

	 local oPop

	 MENU oPop POPUP 2007
			MENUITEM "Align"
			MENU
				 MENUITEM "Left Align" WHEN oCol:nDataStrAlign > 0 ;
						ACTION ( oCol:SetAlign( AL_LEFT ), oCol:oBrw:SetFocus() )
				 MENUITEM "Center Align" WHEN oCol:nDataStrAlign != AL_CENTER ;
						ACTION ( oCol:SetAlign( AL_CENTER ), oCol:oBrw:SetFocus() )
				 MENUITEM "Right Align" WHEN oCol:nDataStrAlign != AL_RIGHT ;
						ACTION ( oCol:SetAlign( AL_RIGHT ), oCol:oBrw:SetFocus() )
			ENDMENU
			MENUITEM "Freeze" ACTION ( oCol:oBrw:nFreeze := oCol:nPos, oCol:oBrw:Refresh(), oCol:oBrw:SetFocus() )
			MENUITEM "Stretch" ACTION ( oCol:oBrw:nStretchCol := oCol:nCreationOrder, oCol:oBrw:ReSize(), ;
												oCol:oBrw:Refresh(), ;
												oCol:oBrw:SetFocus() )


			MENUITEM "Edit" ACTION (	 oCol:nEditType := If( oCol:nEditType > 0, 0, 1 ), ;
																 oMenuItem:SetCheck( oCol:nEditType > 0 ) )

			MENUITEM 'Inspect' ACTION XBrowse( oCol )
			MENUITEM 'Rptcode' ACTION MsgInfo( oCol:RptCode() )

	 ENDMENU

return oPop

//----------------------------------------------------------------------------//

static function ConfigMenu( oBrw )

	 local oPop

	 MENU oPop POPUP 2007
			MENUITEM "2007" CHECKED ;
				 ACTION ( oBrw:l2007 := !oBrw:l2007, oMenuItem:SetCheck( oBrw:l2007 ), ;
									oBrw:Refresh(), oBrw:SetFocus() )
			MENUITEM "FastEdit" ;
				 ACTION ( oBrw:lFastEdit := !oBrw:lFastEdit, oMenuItem:SetCheck( oBrw:lFastEdit ), ;
									oBrw:SetFocus() )
			MENUITEM "RecordSelector" CHECKED ;
				 ACTION ( oBrw:lRecordSelector := !oBrw:lRecordSelector, ;
									oMenuItem:SetCheck( oBrw:lRecordSelector ),		 ;
									oBrw:Refresh(), oBrw:SetFocus() )
			MENUITEM "HScroll" CHECKED ;
				 ACTION ( oMenuItem:SetCheck( oBrw:SetHScroll( ! oBrw:lHScroll ) ) )

			MENUITEM "Marquee"
			MENU
				 MENUITEM "NoMarquee"		ACTION ( oBrw:nMarqueeStyle := 0, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "DottedCell"	ACTION ( oBrw:nMarqueeStyle := 1, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "SolidCell"		ACTION ( oBrw:nMarqueeStyle := 2, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "HighL cell"	ACTION ( oBrw:nMarqueeStyle := 3, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "HighL RowRC" ACTION ( oBrw:nMarqueeStyle := 4, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "HighL Row"		ACTION ( oBrw:nMarqueeStyle := 5, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "HighL RowMS" ACTION ( oBrw:nMarqueeStyle := 6, oBrw:Refresh(), oBrw:SetFocus() )
			ENDMENU

			MENUITEM "Row LineStyle"
			MENU
				 MENUITEM "No Lines"		ACTION ( oBrw:nRowDividerStyle := 0, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Black"				ACTION ( oBrw:nRowDividerStyle := 1, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Dark Gray"		ACTION ( oBrw:nRowDividerStyle := 2, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "ForeColor"		ACTION ( oBrw:nRowDividerStyle := 3, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Light Gray"	ACTION ( oBrw:nRowDividerStyle := 4, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Inset"				ACTION ( oBrw:nRowDividerStyle := 5, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Raised"			ACTION ( oBrw:nRowDividerStyle := 6, oBrw:Refresh(), oBrw:SetFocus() )
			ENDMENU

			MENUITEM "Col LineStyle"
			MENU
				 MENUITEM "No Lines"		ACTION ( oBrw:nColDividerStyle := 0, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Black"				ACTION ( oBrw:nColDividerStyle := 1, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Dark Gray"		ACTION ( oBrw:nColDividerStyle := 2, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "ForeColor"		ACTION ( oBrw:nColDividerStyle := 3, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Light Gray"	ACTION ( oBrw:nColDividerStyle := 4, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Inset"				ACTION ( oBrw:nColDividerStyle := 5, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Raised"			ACTION ( oBrw:nColDividerStyle := 6, oBrw:Refresh(), oBrw:SetFocus() )
				 SEPARATOR
				 MENUITEM "ColDividerComplete" CHECKED ACTION ( ;
						oBrw:lColDividerComplete	 := ! oBrw:lColDividerComplete,		;
						oMenuItem:SetCheck( oBrw:lColDividerComplete ),							;
						oBrw:Refresh(), oBrw:SetFocus() )
			ENDMENU

			MENUITEM "BackGround"
			MENU
				 MENUITEM "None"		 ACTION ( oBrw:SetBackGround(), oBrw:SetFocus() )
				 SEPARATOR
				 MENUITEM "Paper"		 ACTION ( oBrw:SetBackGround( "PAPER" ), oBrw:SetFocus() )
				 MENUITEM "Stone"		 ACTION ( oBrw:SetBackGround( "STONE" ), oBrw:SetFocus() )
				 MENUITEM "FiveBack" ACTION ( oBrw:SetBackGround( "FIVEBACK" ), oBrw:SetFocus() )
				 SEPARATOR
				 MENUITEM "Select Image" ACTION SetBmpBack( oBrw )
				 MENUITEM "ImageMode"
				 MENU
						MENUITEM "Tiled"		WHEN ! Empty( oBrw:oBrush:hBitmap ) ;
																ACTION ( oBrw:SetBackGround( , BCK_TILED ) )
						MENUITEM "Stretch"	WHEN ! Empty( oBrw:oBrush:hBitmap ) ;
																ACTION ( oBrw:SetBackGround( , BCK_STRETCH ) )
						MENUITEM "Fill"			WHEN ! Empty( oBrw:oBrush:hBitmap ) ;
																ACTION ( oBrw:SetBackGround( , BCK_FILL ) )
				 ENDMENU
			ENDMENU

			MENUITEM "Font"				 ACTION ( oBrw:SelFont(), oBrw:SetFocus() )
			MENUITEM "Stretch"
			MENU
				 MENUITEM "None"		 ACTION ( oBrw:nStretchCol := STRETCHCOL_NONE, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Last"		 ACTION ( oBrw:nStretchCol := STRETCHCOL_LAST, oBrw:Refresh(), oBrw:SetFocus() )
				 MENUITEM "Widest"	 ACTION ( oBrw:nStretchCol := STRETCHCOL_WIDEST, oBrw:Refresh(), oBrw:SetFocus() )
			ENDMENU
			MENUITEM "NoFreeze"		 WHEN ( oBrw:nFreeze > 0 ) ;
														 ACTION ( oBrw:nFreeze := 0, oBrw:Refresh(), oBrw:SetFocus() )

	 ENDMENU

return oPop
//----------------------------------------------------------------------------//

static function IndexMenu( oBrw )
  
  local oPop

     MENU oPop POPUP 2007
        MENUITEM OemtoAnsi("&Open Index"+chr(9)+"Ctrl+X") ;
          RESOURCE "OPEN" ;
          ACTION OpenMyIndex();
          MESSAGE "Select an index file" ;
          ACCELERATOR ACC_CONTROL, asc("X") ;
          ENABLED
        MENUITEM OemtoAnsi("&Close Index"+chr(9)+"Ctrl+L") ;
          RESOURCE "SAVE" ;
          WHEN ! Empty(alias()) .AND. (Alias())->(OrdCount())>0 .AND. (VALTYPE(oDbfWnd)<>"O" .OR. ! oDbfWnd:lArray);
          ACTION CloseMyIndex() ;
          MESSAGE "Close current index file" ;
          ACCELERATOR ACC_CONTROL, asc("L") ;
          ENABLED
        MENUITEM "&Index order"+chr(9)+"Ctrl+P" ;
          RESOURCE "PREV" ;
          WHEN ! Empty(alias()) .AND. (Alias())->(OrdCount())>0 .AND. (VALTYPE(oDbfWnd)<>"O" .OR. ! oDbfWnd:lArray);
          ACTION MySetOrder();
          MESSAGE "Select index order from list" ;
          ACCELERATOR ACC_CONTROL, asc("P") ;
          ENABLED
        MENUITEM OemtoAnsi("&Filter by scope"+chr(9)+"Ctrl+F") ;
          RESOURCE "Filter1" ;
          WHEN ! Empty(alias()) .AND. (Alias())->(OrdCount())>0 .AND. (VALTYPE(oDbfWnd)<>"O" .OR. ! oDbfWnd:lArray);
          ACTION MyScopes();
          MESSAGE "Set a scope to filter records, based on the active index" ;
          ACCELERATOR ACC_CONTROL, asc("F") ;
          ENABLED
        MENUITEM OemtoAnsi("&Change/add index"+chr(9)+"Ctrl+W") ;
          RESOURCE "INDEX" ;
          WHEN ! Empty(alias()) .AND. (VALTYPE(oDbfWnd)<>"O" .OR. ! oDbfWnd:lArray);
          ACTION ChangeAddIndex();
          MESSAGE "Change or add new index file or Tag" ;
          ACCELERATOR ACC_CONTROL, asc("W") ;
          ENABLED
     ENDMENU
RETURN opop
//----------------------------------------------------------------------------//

static function SetBmpBack( oBrw )

	 local cImage

	 if ! Empty( cImage := cGetFile( "Image File (*.bmp,jpg,png)|*.bmp;*.png;*.jpg|", ;
																 "Select Image file ", 1, ;
																 "\fwh\bitmaps" ) )
			oBrw:SetBackGround( cImage )
	 endif
	 oBrw:SetFocus()

return nil

//----------------------------------------------------------------------------//

static function ViewCode( oBrw )

	 local aCode		:= Array( 4 )
	 local aGet			:= Array( 4 )
	 local oDlg, oFolder
	 local oFont

#define DLGWD  350 
#define DLGHT	 250

	 aCode := oBrw:PrgCode()

	 DEFINE FONT oFont NAME 'LUCIDA CONSOLE' SIZE 0,-12
	 DEFINE DIALOG oDlg SIZE DLGWD*2, DLGHT*2 PIXEL ;
			TITLE oBrw:oWnd:cTitle + " ( Source)" ;
			FONT oWndDbu:oFont

	 @ 05,05 FOLDER oFolder ;
			PROMPTS 'ListBox Style', 'CommandStyle', 'Oops Style', 'Report Code' ;
			SIZE DLGWD - 10, DLGHT - 27 PIXEL ;
			OF oDlg ; // ADJUST
			FONT oWndDbu:oFont

	 @ 10,10 GET aGet[ 1 ] VAR aCode[ 1 ] TEXT ;
			SIZE DLGWD-30,DLGHT-57 PIXEL ;
			OF oFolder:aDialogs[ 1 ] ;
			FONT oFont

	 @ 10,10 GET aGet[ 2 ] VAR aCode[ 2 ] TEXT ;
			SIZE DLGWD-30,DLGHT-57 PIXEL ;
			OF oFolder:aDialogs[ 2 ] ;
			FONT oFont

	 @ 10,10 GET aGet[ 3 ] VAR aCode[ 3 ] TEXT ;
			SIZE DLGWD-30,DLGHT-57 PIXEL ;
			OF oFolder:aDialogs[ 3 ] ;
			FONT oFont

	 @ 10,10 GET aGet[ 4 ] VAR aCode[ 4 ] TEXT ;
			SIZE DLGWD-30,DLGHT-57 PIXEL ;
			OF oFolder:aDialogs[ 4 ] ;
			FONT oFont


	 @ DLGHT-20,05 BUTTONBMP BITMAP 'COPY3' SIZE 16,16 PIXEL OF oDlg ;
			ACTION CopyToClip( aCode[ oFolder:nOption ] )
	 @ DLGHT-20,23 BUTTONBMP BITMAP 'SAVE2' SIZE 16,16 PIXEL OF oDlg ;
			ACTION SaveCode( aCode[ oFolder:nOption ] )
	 @ DLGHT-20,41 BUTTONBMP BITMAP 'RUN'		SIZE 16,16 PIXEL OF oDlg ;
			ACTION CompileAndRun( aCode[ oFolder:nOption ] )

	 @ DLGHT-20,DLGWD-21 BUTTONBMP BITMAP 'CLOSE2' ;
			SIZE 16,16 PIXEL OF oDlg ;
			ACTION oDlg:End()

	 ACTIVATE DIALOG oDlg CENTERED

	 RELEASE FONT oFont

return nil

//----------------------------------------------------------------------------//
static function CopyToClip( cText )

	 local oClip

	 oClip := TClipBoard():New()
	 if oClip:Open()
			oClip:SetText( cText )
			oClip:Close()
	 endif
	 oClip:End()

return nil
//----------------------------------------------------------------------------//

static function SaveCode( cText )

	 local cFile

	 if ! Empty( cFile := cGetFile(		"Prg File (*.PRG)|*.PRG|",					;
																		"Select PRG File to Save",			 ;
																		CurDir(), .t. ) )


			if ! MemoWrit( cFile, cText )
				 MsgInfo( 'Write Failure' )
			endif

	 endif

return nil
//----------------------------------------------------------------------------//

static function CompileAndRun( cText )

#ifdef __XHARBOUR__
	 MemoWrit( 'test_x.prg', cText )
	 WinExec( 'buildx.bat test_x' )
#else
	 MemoWrit( 'test_x.prg', cText )
	 WinExec( 'buildh.bat test_x' )
#endif

return nil

//----------------------------------------------------------------------------//

CLASS TDbfWnd

	 DATA	 oBrowse, oWnd, oFont
	 DATA	 cAlias, cIndex, cSeekExpr
	 DATA	 lExclusive INIT .F.
  DATA  cLocate    INIT ""
  DATA  aColumns   INIT {}
  DATA  aStruc     INIT {}
	 DATA	 lAnsiTrans INIT .F.
  DATA  lExpress   INIT .F.
  DATA  cFilter    INIT ""
  DATA  lArray     INIT .F.
  DATA  aRelations INIT {}
  DATA  aIndex     INIT {}
	 METHOD New( oWndChild, oBrw )
	 METHOD DelRec()
	 METHOD EditRec()
	 METHOD AppRec()
	 METHOD Refresh() INLINE ::oBrowse:Refresh()
	 METHOD GoTo( nRow, nCol )
	 METHOD Seek()
	 METHOD Skip()
	 METHOD Locate(lReady)
	 METHOD CopyRec()
	 METHOD PasteRec()
	 METHOD Filter()
	 METHOD CopyAppend(n)
	 METHOD ReplaceFor(n)
	 METHOD PackZap(n)
	 METHOD SetRecord()
	 METHOD ReadData()
  METHOD CheckRel()
ENDCLASS

METHOD New( oWndChild, oBrw ) CLASS TDbfWnd

  local n , c , x , y
  local c1 , c2
  local aRelations := {}
  local bIndKey
  ::oWnd   = oWndChild
	 ::oBrowse = oBrw
	 ::oWnd:Cargo = Self
	 ::cAlias = Alias()
  ::oWnd:bGotFocus = { || IIF(SELECT(::cAlias)>0,DbSelectArea(::cAlias),) , oDbfWnd := ::oWnd:Cargo , ::CheckRel()}
	 ::oFont = oWndChild:oFont
  
  for n = 1 to FCount()
      AAdd( ::aStruc, { FieldName( n ), FieldType( n ), FieldSize( n ), FieldDec( n ) } )
	 next
  
  for n = 1 to FCount() //Len( ::oBrowse:aCols )
      AAdd( ::aColumns, TDbfCol():New( Self, n ) )
	 next
  
  ::aIndex := (::cAlias)->(LoadhIndex())
  
  oDbfWnd = Self

return Self
******************************************************************************************
METHOD DelRec() CLASS TDbfWnd
*****************************
		 DbSelectArea(::cAlias)
		 IF ! ::lExclusive

					IF !(::cAlias)->(DbRLock())

							 MsgRun({|| SysWait(1) }, "Record lock error")

							 RETU NIL

					ENDIF

		 ENDIF

		 IF Deleted()
					DbRecall()
		 ELSE
					DbDelete()
		 ENDIF

		 IF ! ::lExclusive
				( ::cAlias )->( DbUnlock() )
		 ENDIF

		 IF Set( _SET_DELETED )
					DO WHILE Deleted() .AND. !Bof()
							 DbSkip( -1 )
					ENDDO
					::Refresh()
		 ENDIF

		 EVAL(::oBrowse:bChange)
		 ::oBrowse:Setfocus()



return nil

//----------------------------------------------------------------------------//

METHOD EditRec()	CLASS TDbfWnd

	 local oWnd, aRecord , oBar, oBrw, oMsgBar
	 local cAlias := ::cAlias , oBtnSave, nRecNo
	 local oMsgDeleted , oMsgRecno
	 local OriColor , NewColor
	 DbSelectArea(::cAlias)
	 aRecord := LoadRecord()
	 nRecNo	 := RecNo()
	 DEFINE WINDOW oWnd TITLE "Edit " + cAlias MDICHILD

	 ::oWnd:oBar:AEvalWhen()

	 DEFINE BUTTONBAR oBar OF oWnd 2010 SIZE 70, 70

	 DEFINE BUTTON oBtnSave OF oBar PROMPT "Save" RESOURCE "save" ;
			ACTION ( ( cAlias )->( SaveRecord( aRecord, nRecNo ) ), oBtnSave:Disable() )

	 oBtnSave:Disable()

	 DEFINE BUTTON OF oBar PROMPT "Prev" RESOURCE "prev" ;
			ACTION ( cAlias )->( GoPrevRecord( oBrw, aRecord, oMsgDeleted ) ) GROUP

	 DEFINE BUTTON OF oBar PROMPT "Next" RESOURCE "next" ;
			ACTION ( cAlias )->( GoNextRecord( oBrw, aRecord, oMsgDeleted ) )

	 DEFINE BUTTON OF oBar PROMPT "Go To" RESOURCE "GOTO" ;
			ACTION (cAlias)->(GoToRecord( oBrw, aRecord, oMsgDeleted))


	 DEFINE BUTTON OF oBar PROMPT "Report" RESOURCE "report" ;
			ACTION oBrw:Report() GROUP


	 DEFINE BUTTON OF oBar PROMPT "Exit" RESOURCE "exit" ;
			ACTION oWnd:End() GROUP

	 @ 0, 0 XBROWSE oBrw OF oWnd ARRAY aRecord AUTOCOLS LINES ;
			HEADERS "FieldName", "Value" COLSIZES 150, 400 FASTEDIT ;
			ON CHANGE ( ( cAlias )->( SetEditType( oBrw ) ), oBrw:DrawLine( .T. ),;
									 EVAL(oMsgDeleted:bMsg) , EVAL(oMsgRecno:bMsg) , oMsgBar:Refresh() )
	 oBrw:nEditTypes = EDIT_GET
	 oBrw:aCols[ 1 ]:nEditType = 0 // Don't allow to edit first column
	 oBrw:aCols[ 2 ]:bOnChange = { || oBtnSave:Enable() }
	 oBrw:aCols[ 2 ]:lWillShowABtn = .T.
	 oBrw:nMarqueeStyle = MARQSTYLE_HIGHLROW
	 oBrw:bClrStd = { || If( oBrw:KeyNo() % 2 == 0, ;
												 { CLR_BLACK, RGB( 198, 255, 198 ) }, ;
												 { CLR_BLACK, RGB( 232, 255, 232 ) } ) }
	 oBrw:bClrSel = { || { CLR_WHITE, RGB( 0x33, 0x66, 0xCC ) } }
	 oBrw:SetColor( CLR_BLACK, RGB( 232, 255, 232 ) )
	 oBrw:CreateFromCode()
	 oBrw:SetFocus()

	 oWnd:oClient = oBrw

  DEFINE MSGBAR oMsgBar

	 DEFINE MSGITEM oMsgDeleted OF oMsgBar ;
					PROMPT If( ( cAlias )->( Deleted() ), "DELETED", "NON DELETED" ) ;
					SIZE 130 ;
					ACTION (oDbfWnd:DelRec() ,;
									oMsgDeleted:settext(If( ( cAlias )->( Deleted())	, "DELETED", "NON DELETED" )) ,;
									oMsgDeleted:setColor(If( ( cAlias )->( Deleted()) , NewColor , OriColor ))			,;
									oMsgDeleted:Refresh() )

	 DEFINE MSGITEM oMsgRecno OF oMsgBar PROMPT STR((cAlias)->(Recno()),6) + "/" + STR((cAlias)->(Reccount()),6) SIZE 100 COLOR CLR_WHITE , CLR_HBLUE;
																			ACTION (cAlias)->(GoToRecord( oBrw, aRecord, oMsgDeleted , oMsgRecno))

	 OriColor := oMsgDeleted:SetColor()
	 NewColor := {CLR_WHITE , CLR_HRED}
	 IF ( cAlias )->( Deleted())
		oMsgDeleted:nClrText := CLR_WHITE
		oMsgDeleted:nClrPane := CLR_HRED
	 END
	 oMsgDeleted:bMsg := {||oMsgDeleted:setColor(If( ( cAlias )->( Deleted()) , NewColor , OriColor )) ,;
													oMsgDeleted:settext(If( ( cAlias )->( Deleted())	, "DELETED", "NON DELETED" ))}

	 oMsgRecno:bMsg		:= {||oMsgRecno:Settext(AllTrim( Str( ( cAlias )->( RecNo() ) ) ) + "/" + AllTrim( Str( ( cAlias )->( RecCount() ) ) ))}

	 ACTIVATE WINDOW oWnd

	 RETURN NIL

//----------------------------------------------------------------------------//

function LoadRecord()

	 local aRecord := {}, n

	 for n = 1 to FCount()
			if FieldType( n ) != "M"
				 AAdd( aRecord, { FieldName( n ), FieldGet( n ) } )
			else
				 AAdd( aRecord, { FieldName( n ), If( ! Empty( FieldGet( n ) ), "<Memo>", "<memo>" ) } )
			endif
	 next

return aRecord

//----------------------------------------------------------------------------//

function GoPrevRecord( oBrw, aRecord, oMsgDeleted , oMsgRecno )

	 DbSkip( -1 )

	 oBrw:SetArray( aRecord := LoadRecord() )
	 oBrw:SetFocus()
	 Eval( oBrw:bChange )

return nil

//----------------------------------------------------------------------------//

function GoNextRecord( oBrw, aRecord, oMsgDeleted , oMsgRecno)

	 DbSkip( 1 )

	 If Eof()
			DbSkip( -1 )
	 else
			oBrw:SetArray( aRecord := LoadRecord() )
			oBrw:SetFocus()
			Eval( oBrw:bChange )
	 endif

return nil

//----------------------------------------------------------------------------//

function GoToRecord( oBrw, aRecord, oMsgDeleted , oMsgRecno )

	 oDbfWnd:GoTo()

			oBrw:SetArray( aRecord := LoadRecord() )
			oBrw:SetFocus()
			Eval( oBrw:bChange )

return nil

//----------------------------------------------------------------------------//

function SetEditType( oBrw )

	 local cType := VALTYPE(oBrw:aRow[2]) //FieldType( oBrw:nArrayAt )
	 local cAlias := Alias()

	 do case
			case cType == "M"
					 oBrw:aCols[ 2 ]:nEditType = EDIT_BUTTON
					 oBrw:aCols[ 2 ]:bEditBlock = { || ( cAlias )->( EditMemo( oBrw ) ) }

			case cType == "D"
					 oBrw:aCols[ 2 ]:nEditType = EDIT_BUTTON
					 oBrw:aCols[ 2 ]:bEditBlock = { || If( ! Empty( oBrw:aRow[ 2 ] ) .and. ;
																								 ! AllTrim( DtoC( oBrw:aRow[ 2 ] ) ) == "/	/",;
																								 MsgDate( oBrw:aRow[ 2 ] ),;
																								 MsgDate( Date() ) ) }

			case cType == "L"
					 oBrw:aCols[ 2 ]:nEditType = EDIT_LISTBOX
					 oBrw:aCols[ 2 ]:aEditListTxt		= { ".T.", ".F." }

			otherwise
					 oBrw:aCols[ 2 ]:nEditType = EDIT_GET
	 endcase

return nil

//----------------------------------------------------------------------------//

function SetRowEditType( oBrw )

	 local cType
	 local cAlias := Alias()
	 local oCol , Value
	 FOR EACH oCol IN oBrw:aCols
			cType := VALTYPE(Value := EVAL(oCol:bEditValue))
			do case
				case cType == "M"
					oCol:nEditType = EDIT_BUTTON
					oCol:bEditBlock = { || ( cAlias )->( RowEditMemo( oCol , EVAL(oCol:bEditValue) ) ) }
			case cType == "D"
					oCol:nEditType = EDIT_DATE
			case cType == "L"
					 oCol:nEditType := EDIT_LISTBOX
					 oCol:aEditListTxt	 := { ".T.", ".F." }
			otherwise
					 oCol:nEditType := EDIT_GET
	 endcase

	 NEXT
return nil


//----------------------------------------------------------------------------//

/*
function View( cFileName, oWnd )

	 local cExt := Lower( cFileExt( cFileName ) )

	 do case
			case cExt == "bmp"
					 WinExec( "mspaint" + " " + cFileName )

			case cExt == "txt"
					 WinExec( "notepad" + " " + cFileName )

			otherwise
					 ShellExecute( oWnd:hWnd, "Open", cFileName )
	 endcase

return nil
*/
//----------------------------------------------------------------------------//

function EditMemo( oBrw )

	 local cAlias := Alias()
	 local cOld		:= ( cAlias )->( FieldGet( oBrw:nArrayAt ) )
	 local cTemp	:= cOld
	 if MemoEdit( @cTemp, ( cAlias )->( FieldName( oBrw:nArrayAt ) ) )
			if ! cTemp == cOld
				 if ( cAlias )->( DbRlock() )
						( cAlias )->( FieldPut( oBrw:nArrayAt, cTemp ) )
						( cAlias )->( DbUnlock() )
						MsgInfo( "Updated memo field" )
				 endif
			endif
	 endif

return If( ! Empty( ( cAlias )->( FieldGet( oBrw:nArrayAt ) ) ),;
					 "<Memo>", "<memo>" )

//----------------------------------------------------------------------------//

function RowEditMemo( oCol , cOld)

	 local oBrw := oCol:oBrw
	 local cAlias := Alias()
	 local cTemp	:= cOld
	 if MemoEdit( @cTemp,oCol:cHeader	 )
			if ! cTemp == cOld .AND. ( cAlias )->( DbRlock() )
				( cAlias )->( EVAL(oCol:bEditValue , cTemp ) )
				( cAlias )->( DbUnlock() )
			endif
	 endif

return cTemp

//----------------------------------------------------------------------------//

function SaveRecord( aRecord, nRecNo )

	 local n

	 ( Alias() )->( DbGoTo( nRecNo ) )

	 if ( Alias() )->( DbRLock( nRecNo ) )
			for n = 1 to Len( aRecord )
				 ( Alias() )->( FieldPut( n, aRecord[ n ][ 2 ] ) )
			next
			( Alias() )->( DbUnLock() )
			MsgInfo( "Record updated" )
	 else
			MsgAlert( "Record in use, please try it again" )
	 endif

return nil

//----------------------------------------------------------------------------//

METHOD AppRec() CLASS TDbfWnd

		 local cMem
		 DbSelectArea(::cAlias)
		 IF OrdCount()==0
			IF ! MsgYesNo("A record can be inserted at " + LTRIM(STR(Recno())) + " or a record can be appended. Append a record ?" )
				InsertDbf()
				Return nil
			END
		 END
		 cMem := OrdSetFocus(0)
		 APPEND BLANK
		 ::Editrec()
		 IF NetErr()
					MsgRun({|| SysWait(1) },;
								 "Record append error")
					OrdSetFocus(cMem)
					RETU NIL
		ENDIF
		 ::oBrowse:GoBottom()
		 OrdSetFocus(cMem)
		 ::oBrowse:refresh()
RETURN NIL

//----------------------------------------------------------------------------//

METHOD GoTo( nRow, nCol ) CLASS TDbfWnd

		 LOCAL oDlg, oOk
		 LOCAL aPoint
		 LOCAL nGoto, nLast, nRadio
		 LOCAL lOk

		 lOk		:= .F.
		 nGoto	:= (::cAlias)->(Recno())
		 nLast	:= (::cAlias)->(LastRec())
		 nRadio := 3

		 DbSelectArea(::cAlias)

		 DEFINE DIALOG oDlg RESOURCE "GOTO" TITLE "Jump to..." FONT MainFont()

		 REDEFINE BUTTON oOk ID 1 OF oDlg ACTION (lOk := .T., oDlg:End())

		 REDEFINE BUTTON ID 2 OF oDlg ACTION oDlg:End()

		 REDEFINE RADIO nRadio ID 101, 102, 103 OF oDlg ;
					ON CHANGE iif(nRadio<3, oOk:Click(), )

		 REDEFINE GET nGoto ID 104 OF oDlg ;
					VALID (nGoto > 0 .AND. nGoto <= nLast ) ;
					WHEN nRadio == 3

		 oDlg:nHelpId := HLP_GOTO

		 IF nRow != NIL .AND. nCol != NIL

					aPoint := {nRow, nCol}

					ClientToScreen(::oWnd:oMsgBar:hWnd, aPoint)

					ACTIVATE DIALOG oDlg ;
							 ON INIT ::Move(aPoint[1]-::nHeight ,;
															aPoint[2]-::nWidth	,;
															::nWidth						,;
															::nHeight						 )

		 ELSE
					ACTIVATE DIALOG oDlg CENTERED
		 ENDIF

		 IF lOk
					DO CASE
					CASE nRadio == 1
							 ::oBrowse:Gotop()
					CASE nRadio == 2
							 ::oBrowse:GoBottom()
					CASE nRadio == 3
							 (::cAlias)->(DbGoto(nGoto))
							 IF ::lArray
           ::SetRecord()
							 END
							 ::Refresh()
					ENDCASE
		 ENDIF

		 EVAL(::oBrowse:bChange)
		 ::oBrowse:SetFocus()

RETURN NIL
***********************************************************************************************
METHOD Seek() CLASS TDbfWnd
***************************
		 LOCAL oDlg , oGet , oCheck
		 LOCAL cIndexKey := (::cAlias)->(IndexKey())
		 LOCAL nRow := 27 , nCol := 32 , nHeight := 74*2 , nWidth := 307*2
		 LOCAL lSoftseek := .F. , lFindLast := .F. , lUpperCase := .F.

		 IF ::cIndex = "<None>"
					MessageBeep()
					::oBrowse:Setfocus()
					RETU NIL
		 ENDIF

		 DEFAULT ::cSeekExpr := ""

		 ::cSeekExpr := PAd(::cSeekExpr,80)

		 DbSelectArea(::cAlias)

DEFINE DIALOG oDlg FONT WndMain():oFont() TITLE "Text to Search";
	 FROM nRow , nCol TO nRow + nHeight , nCol + nWidth PIXEL

@ 3 , 5	 GROUP TO 40 , 290 LABEL "Search for : " PIXEL OF oDlg
@ 17 , 8 GET oGet VAR ::cSeekExpr OF oDlg PIXEL SIZE 210,10 PICTURE "@K"
@	 7 , 235 CHECKBOX lFindLast	 PROMPT "Find Last"			 OF oDlg PIXEL SIZE 50,10
@ 17 , 235 CHECKBOX lUpperCase PROMPT "Upper Case"		 OF oDlg PIXEL SIZE 50,10
@ 27 , 235 CHECKBOX lSoftSeek	 PROMPT "Soft Seek"			 OF oDlg PIXEL SIZE 50,10

@ 45 , 5	GROUP TO 75 , 220 LABEL "Index Expression : " PIXEL OF oDlg
@ 55 , 8 SAY cIndexKey OF oDlg PIXEL SIZE 210,10;
					PICTURE "@!" ;
					COLOR CLR_HBLUE, CLR_HGRAY

@ 45 , 235 BUTTON "&Search" OF oDlg PIXEL SIZE 50,12;
									ACTION (IIF(lUpperCase,(oGet:Varput(UPPER(oGet:Varget())) , oGet:Refresh() ) , ),;
												 MakeSeek(Self,lFindLast,lUpperCase,lSoftSeek),														 ;
												 oGet:Refresh(),																													 ;
												 oGet:SetFocus())																													 ;
									DEFAULT

@ 60 , 235 BUTTON "&Cancel" OF oDlg PIXEL SIZE 50,12 ACTION oDlg:End()


ACTIVATE DIALOG oDlg CENTERED 

RETURN nil
*********************************************************************************************
STATIC FUNCTION MakeSeek(Self,lFindLast,lUpperCase,lSoftSeek)
*************************************************************
		 LOCAL xSearch
		 LOCAL cValType
		 LOCAL nRecno
		 LOCAL lFound
		 LOCAL cGet := Trim(::cSeekExpr)
		 IF lUpperCase
			cGet := UPPER(cGet)
		 END
		 nRecno		:= (::cAlias)->(Recno())

		 if ! Empty( (::cAlias)->(OrdKey()) )
				cValType := ValType(&((::cAlias)->(OrdKey())))
		 ENDIF

		 DO CASE
		 CASE cValType == "N"
					xSearch := Val(cGet)
		 CASE cValType == "D"
					xSearch := CtoD(cGet)
		 CASE cValType == "L"
					xSearch := ( cGet == ".T."	.OR. ;
											 cGet == upper(Alltrim(cYesLogic)) )
		 OTHERWISE
					xSearch := cGet
		 ENDCASE

		 lFound := (::cAlias)->(DbSeek(xSearch,lSoftseek,lFindLast))

		 IF !lSoftSeek	.AND. !lFound
					(::cAlias)->(DbGoto(nRecno))
					Tone(100,.1)
					RETU .F.
		 ENDIF

		 IF (::cAlias)->(Recno()) != nRecno
					::Refresh()
		 ENDIF

RETURN .T.
*****************************************************************
METHOD Skip() CLASS TDbfWnd
***************************
		 LOCAL oDlg
		 LOCAL nSkip
		 LOCAL lOk

		 lOk := .F.
		 nSkip := 1

		 DbSelectArea(::cAlias)

		 DEFINE DIALOG oDlg RESOURCE "SKIP" TITLE "Skip..." FONT MainFont()

		 REDEFINE BUTTON ID 1 OF oDlg ACTION (lOk := .T., oDlg:End())

		 REDEFINE BUTTON ID 2 OF oDlg ACTION oDlg:End()

		 REDEFINE GET nSkip ID 101 OF oDlg

		 oDlg:nHelpId := HLP_SKIP

		 ACTIVATE DIALOG oDlg CENTERED

		 IF lOk
					(::cAlias)->(DbSkip(nSkip))
					::Refresh()
		 ENDIF

		 EVAL(::oBrowse:bChange)
		 ::oBrowse:SetFocus()

RETURN NIL
*********************************************************************************
METHOD Locate(lReady) CLASS TDbfWnd
************************************
		 LOCAL bExpression
		 LOCAL cLocate
		 LOCAL nRecno

		 DEFAULT lReady := .F.

		 DbSelectArea(::cAlias)

		 IF !lReady
					::oWnd:nHelpId := HLP_LOCATE
					cLocate := ExpBuilder("","Locate...","L")
					IF empty(cLocate)
							 RETU NIL
					ELSE
							 ::cLocate := cLocate
					ENDIF
		 ELSE
					cLocate := ::cLocate
		 ENDIF

		 nRecno := (::cAlias)->(Recno())

		 if Empty( cLocate )
				return NIL
		 endif

		 bExpression := COMPILAR(cLocate)

		 IF Eval(bExpression) .AND. !(::cAlias)->(Eof())
					(::cAlias)->(DbSkip())
		 ENDIF

		 CursorWait()

		 (::cAlias)->(__dbLocate(bExpression,,,,.T.))

		 CursorArrow()

		 IF !(::cAlias)->(Found())
					(::cAlias)->(DbGoto(nRecno))
					MsgRun("No records found meeting the condition" , , {|| SysWait(1)})
		 ENDIF

		 ::Refresh()
		 EVAL(::oBrowse:bChange)
		 ::oBrowse:SetFocus()
RETURN NIL
****************************************************************************************************
METHOD CopyRec() CLASS TDbfWnd
******************************
local oBrw := ::oBrowse
local nMem := oBrw:nMarqueeStyle
oBrw:nMarqueeStyle := 4
oBrw:Copy()
oBrw:nMarqueeStyle := nMem
/*
local oClip		 := TClipBoard():New()
if oClip:Open()
	cText		 := ::oBrowse:ClpRow( .t. )
	oClip:SetText( cText )
	oClip:end()
endif
*/
RETURN nil
*******************************
METHOD PasteRec() CLASS TDbfWnd
*******************************
::oBrowse:nColsel := 1
::oBrowse:Paste()
RETURN nil
*******************************************************************************************************
PROC ColumnConfig()
*******************
local self := oDbfWnd
LOCAL oDlg , oDdlg , oBrow
local a , el
LOCAL aHeaders , aWidth
LOCAL cTitle := "Column configuration from " //+ cIniFile
LOCAL bShow
LOCAL nCol := GetSysMetrics(0)/2 - 300
LOCAL nRow := GetSysMetrics(1)/2 - 170
LOCAL aCols[0] , aMemCols
LOCAL oBut[4] // oButEdit , oButIns , oButAp , oButDel
LOCAL oButOk , oButCancel
LOCAL aTxt	:= {"EDIT" + CRLF + "COLUMN" , "INSERT AT" + CRLF + "COLUMN" , ;
								"APPEND" + CRLF + "COLUMN" , "DELETE" + CRLF + "COLUMN"}
LOCAL i , c , bIns	:= {||i := 1 , Aeval(oBut,{|o|c := aTxt[i]+IIF(i<>3,STR(oBrow:nArrayAt,3),""),;
																									o:SetText(c),o:Refresh(),i++})}
LOCAL aSource
	aSource	 := aClone(::oBrowse:aCols)
	IF ::lArray
    i := ASCAN(aSource , {|o|UPPER(o:cExpr)="RECNO()"})
		aDel(aSource,i,.T.)
	END

FOR EACH el IN aSource
		WITH OBJECT el
			a := Array(5)
			a[1] := :cHeader
			a[2] := :cExpr
			a[3] := :nWidth
			a[4] := :cEditPicture
			a[5] := !:lHide
		END
    AADD(aCols,a)
NEXT
aMemCols := aClone(aCols)
DEFINE DIALOG oDlg FONT WndMain():oFont() TITLE cTitle;
	 FROM nRow , nCol TO nRow + 340 , nCol + 630 PIXEL

aHeaders := {"Nr","Header","Expression","nWidth","Picture","Show"}
aWidth	 := {20,70,180,45,90,35}

@ 5,5 XBROWSE oBrow OF oDlg ;
	SIZE 250,135;
	ARRAY aCols;
	COLUMNS {{||oBrow:nArrayAt},1,2,3,4,5};
	HEADERS aHeaders;
	COLSIZES aWidth;
	PIXEL AUTOCOLS LINES

__ObjModMethod(oBrow,"BrwFitSize" ,@BrwFitSize())


WITH OBJECT oBrow
	:lRecordSelector := .F.
  :bLDblClick := {||EditConfigCol(oBrow, 1 )}
  :bPastEof   := {||EditConfigCol(oBrow, 3 )}
  :bkeyDown   := {|nkey|IIF(nkey==13 , EditConfigCol(oBrow, 1 )   , IIF(nkey==VK_DELETE , EditConfigCol(oBrow, 4 ) ,  ) ) }
	:lhScroll := .F.
	:nMarqueeStyle := MARQSTYLE_HIGHLCELL
	:bChange			 := {||EVAL(bIns)}
	:bClrSel			 := { || { CLR_WHITE, CLR_BLUE } }
	:bClrSelFocus	 := {||{ CLR_WHITE, CLR_HBLUE } }
	:bClrStd			 := {||{ CLR_BLACK, CLR_WHITE }}
	:oCol("Show"):SetCheck()
END

oBrow:CreateFromCode()
@ 142 ,15 BUTTON oBut[1] PROMPT "EDIT" OF oDlg PIXEL SIZE 40 , 25;
          ACTION EditConfigCol(oBrow, 1 )
oBut[1]:nStyle	:= NOR( oBut[1]:nStyle, BS_MULTILINE )

@ 142 ,70 BUTTON oBut[2] PROMPT "test" OF oDlg PIXEL SIZE 40 , 25;
          ACTION EditConfigCol(oBrow, 2 )
oBut[2]:nStyle	:= NOR( oBut[2]:nStyle, BS_MULTILINE )

@ 142 ,125 BUTTON oBut[3] PROMPT "APPEND" + CRLF + "COLUMN" OF oDlg PIXEL SIZE 40 , 25;
          ACTION EditConfigCol(oBrow, 3 )

oBut[3]:nStyle	:= NOR( oBut[3]:nStyle, BS_MULTILINE )

@ 142 ,180 BUTTON oBut[4] PROMPT "DELETE" + CRLF + "COLUMN" OF oDlg PIXEL SIZE 40 , 25;
          ACTION EditConfigCol(oBrow, 4 )

oBut[4]:nStyle	:= NOR( oBut[4]:nStyle, BS_MULTILINE )

c := "Save in table"
@ 30 ,250 BUTTON oButOk PROMPT c OF oDlg PIXEL SIZE 60 , 25;
          ACTION SaveConfigCol(oBrow,aMemCols)

oButOk:nStyle	 := NOR( oButOk:nStyle, BS_MULTILINE )


@ 80 ,250 BUTTON oButCancel PROMPT "Cancel"	 OF oDlg PIXEL SIZE 60 , 25;
					ACTION oDlg:End()

ACTIVATE DIALOG oDlg ;
				 ON INIT ( oBrow:nRowSel := oBrow:nArrayAt := 1	 , oBrow:BrwFitSize(.T.) , EVAL(oBrow:bChange,oBrow) )


hDel(g,"hIni")
RETURN

****************************************************************************************

STATIC PROC EditConfigCol( oBrw , n    )
********************************************************
local self := oDbfWnd
local oDdlg
local oGet[4]
local oDlg := oBrw:oWnd
local nColSel := MAX(1 , oBrw:nColSel - 1)
local nRow , nCol , aPoint
local nAt := oBrw:nArrayAt
local aRow := oBrw:aRow
local cHeader := PAD(aRow[1] , 20)
local cExpr		:= PAD(aRow[2] , 80)
local nWidth	:= aRow[3]
local cPict		:= PAD(aRow[4] , 20)
local cTitle
local oButOk , oButCancel
local a , nCreation , cCol , i , j
IF oBrw:nColSel == 6
	oBrw:aArrayData[nAt,5] := ! oBrw:aArrayData[nAt,5]
	oBrw:RefreshCurrent()
	RETURN
END
IF n == 4
	IF MsgNoYes("Delete column " + LTRIM(STR(nAt)) + " ?")
		aDel(oBrw:aArrayData,nAt,.T.)
		IF nAt > LEN(oBrw:aArrayData)
			oBrw:GoBottom()
		END
		oBrw:Refresh()
		EVAL(oBrw:bChange)
		oBrw:BrwFitSize(.T.)
	END
	RETURN
END

IF n == 3
	oBrw:GoBottom()
END
nRow := oBrw:nRowSel * oBrw:nRowHeight	+ oBrw:HeaderHeight()
nCol := oBrw:oCol("Nr"):nDisplayCol
aPoint	 := ClientToScreen( oBrw:hWnd, { nRow, nCol } )
nRow		 := aPoint[ 1 ]
nCol		 := aPoint[ 2 ]

IF n == 1
	cTitle := "Edit Column " + LTRIM(STR(nAt))
ELSE
	nColSel := 1
	cHeader := SPACE(20)
	cExpr		:= SPACE(80)
	nWidth	:= 0
	cPict		:= SPACE(20)
	IF n == 2
		cTitle := "Insert At Column " + LTRIM(STR(nAt))
	ELSEIF n == 3
		cTitle := "New Column : " + LTRIM(STR(LEN(oBrw:aArrayData)+1))
	END
END
IF nWidth == nil
	nWidth := 0
END
IF cPict == nil
	cPict := ""
END
cPict	 := PAD(cPict,20)

DEFINE DIALOG oDDlg OF oBrw:oWnd FROM nRow +2, nCol TO nRow + 130, nCol + 370;
	PIXEL FONT WndMain():oFont();
 TITLE cTitle
@ 2,5		SAY "Header" OF oDdlg PIXEL
@ 2,36	SAY ":" OF oDdlg PIXEL
@ 2,40	GET oGet[1] VAR cHeader OF oDdlg PIXEL
@ 14,5	 SAY "Expression" OF oDdlg PIXEL
@ 14,36	 SAY ":" OF oDdlg PIXEL
@ 14,40	 GET oGet[2] VAR cExpr OF oDdlg PIXEL PICTURE "@KS40" ACTION ExpBuilder(@cExpr,"Column expression");
         VALID ChKExpr(cExpr,.F.) .AND. ! (UPPER(cExpr) = "RECNO")
@ 26,5	 SAY "nWidth" OF oDdlg PIXEL
@ 26,36	 SAY ":" OF oDdlg PIXEL
@ 26,40	 GET oGet[3] VAR nWidth OF oDdlg PIXEL PICTURE "999"
@ 38,5	 SAY "Picture" OF oDdlg PIXEL
@ 38,36	 SAY ":" OF oDdlg PIXEL
@ 38,40	 GET oGet[4] VAR cPict OF oDdlg PIXEL
@ 28,140 BUTTON oButOk		 PROMPT "OK" OF oDdlg PIXEL SIZE 40 , 15 ;
				 WHEN ! Empty(cHeader) .AND. ! EMPTY(cExpr);
         ACTION (WriteConfigCol(oBrw,{cHeader,cExpr,nWidth,cPict,.T.},n) , oDDlg:end())
@ 48,140 BUTTON oButCancel PROMPT "CANCEL" OF oDdlg PIXEL SIZE 40 , 15;
								 ACTION oDdlg:end()
ACTIVATE DIALOG oDDlg ON INIT oGet[nColSel]:Setfocus()
RETURN
****************************************************************************************
PROC WriteConfigCol(oBrw,a,n)
*************************************
local self := oDbfWnd
local nAt
aSize(a,5)
DO CASE
	CASE n == 1
		nAt := oBrw:nArrayAt
		a[5] := oBrw:aArrayData[nAt,5]
		oBrw:aArrayData[nAt] := a
	CASE n == 2
		aIns(oBrw:aArrayData,oBrw:nArrayAt,a,.T.)
	CASE n == 3
		aAdd(oBrw:aArrayData,a)
ENDCASE
oBrw:BrwFitSize(.T.)
oBrw:Refresh()
RETURN
*******************************************************************************************
STATIC PROC SaveConfigCol(oBrow , aMemCols)
****************************************************************
local self := oDbfWnd
LOCAL a , o , i , cKey , hTxt , c , b
LOCAL oCol
local aCols[0] , Arr
local lBuildArray := .F.
IF ::lArray
  IF LEN(aMemCols) == LEN(oBrow:aArraydata) 
     FOR EACH a IN oBrow:aArrayData
         i := Hb_EnumIndex()
         IF a[2] <> aMemcols[i,2]
            lBuildArray := .T.
            EXIT
         END
     NEXT
  ELSE
     lBuildArray := .T.    
  END
  AADD(oBrow:aArrayData , {"Recno","Recno()",0,"",.T.})
  AEVAL(oBrow:aArrayData,{|a|b := &(a[2]) , c := IIF(VALTYPE(b)<>"B",&("{||"+a[2]+"}"), b) ,;
												 AADD(aCols,c)})
  IF lBuildArray
     ::oBrowse:aCols := {}     
     ::oBrowse:SetArray((::cAlias)->(ReadDbf(aCols)),.T.)
  END
ELSE
    ::oBrowse:aCols := {}    
END
FOR EACH a IN oBrow:aArrayData
			IF ::lArray
				i := Hb_EnumIndex()
				oCol					 := ::oBrowse:aCols[i]
				oCol:nArrayCol := i
			ELSE
				oCol := ::oBrowse:AddCol()
			END
			oCol:cHeader		:= TRIM(a[1])
      oCol:cExpr      := TRIM(a[2])
			IF ! ::lArray
        b := &(TRIM(a[2]))
        IF VALTYPE(b) <> "B"
          b := &("{||"+TRIM(a[2])+"}")
				END

        oCol:bEditValue := b
			END
			IF a[3] == 0
				a[3] := nil
			END
			oCol:nWidth := a[3]
			oCol:cEditPicture := a[4]
			IF ! a[5]
				oCol:Hide()
			END
			IF ::lArray
				oCol:bLClickHeader := {||EVAL(::oWnd:oMsgBar:aItems[MSGTAG]:bMsg)}
				IF oCol:cOrder$"AD"
					EVAL(oCol:bLClickHeader)
				END
			END
			oCol:Adjust()
		NEXT
		IF ! ::lArray
			SetTagColumns(::oBrowse)
			AEVAL(::oBrowse:aCols , {|o|IIF(o:cSortOrder<>nil,o:bLClickHeader := {||EVAL(::oWnd:oMsgBar:aItems[MSGTAG]:bMsg)},)})

		end
	::oBrowse:Adjust()
	::oBrowse:Refresh()
	SysRefresh()
oBrow:oWnd:end()
RETURN
*************************************************************************************
METHOD Filter() CLASS TDbfWnd
*****************************
		 LOCAL cFilter

		 DbSelectArea(::cAlias)
		 cFilter := ExpBuilder(::cFilter,"Filter...","L")
		 IF UPPER(cFilter)==UPPER(::cFilter)
      RETURN nil
		 END
		 IF empty(cFilter)
      ::cFilter := ""
      dbClearFilter(NIL)
      IF ::oWnd:oMsgBar:aItems[LEN(::oWnd:oMsgBar:aItems)]:cMsg = "Filter Active"
         aDel(::oWnd:oMsgBar:aItems,LEN(::oWnd:oMsgBar:aItems),.T.)
         ::oWnd:oMsgBar:Refresh()
      END
      ::ReadData()
      ::Refresh(.T.)
      ::oBrowse:SetFocus()
      RETU NIL
		 ELSE
      ::cFilter := cFilter
		 ENDIF
		 DbSetFilter(COMPILAR(::cFilter),::cFilter)
   ::oBrowse:Gotop()
   DEFINE MSGITEM OF ::oWnd:oMsgBar PROMPT "Filter Active";
          SIZE 100 COLOR CLR_BLACK,CLR_YELLOW
		 ::oWnd:oMsgBar:aItems[LEN(::oWnd:oMsgBar:aItems)]:bAction := {||::Filter()}
		 ::ReadData()
   IF Deleted() .AND. Set( _SET_DELETED )
      ::oBrowse:Eval({||::oBrowse:skip()},,{||Deleted() .AND. ! Eof()})
   END
   ::Refresh()
		 ::oBrowse:SetFocus()
RETURN NIL

*************************************************************************************
METHOD ReplaceFor(n) CLASS TDbfWnd
**********************************

		local oDlg
		local cPath , cFileName , cExtension
		local aFlds[(::cAlias)->(FCOUNT())]
		local cFor	 := SPACE(80)
		local cWhile := SPACE(80)
		local i
		local nRw := 10 , nStep := 12
		local oBrw , aItem[0]
		local aTag[0] , cTag , oCombo , oSayTag , nTag
		local aScope := {"All","Next","Record","Rest"} , cScope := "All" , oScope
		local oSayRec , oGetRec , nRecords := 0 , oGetRepl , nRepl := 0
		local oButRepl , oButCancel , oButCount
		local TxtBut := {"REPLACE","RECALL","DELETE","" , "CALCULATE"}
  local lOnoff  
		DEFAULT n := 1 // REPLACE			2 : RECALL		 3 : DELETE			4:COUNT				5:STATISTICS
		IF n == 2
			lOnoff := set(_SET_DELETED,.F.)
			cFor	 := PAD("Deleted()",80)
			EVAL(::oBrowse:bChange)
		END

		DbSelectArea(::cAlias)

		Hb_fNameSplit(DbInfo(DBI_FULLPATH),@cPath,@cFileName,@cExtension)

		IF n == 1
			DEFINE DIALOG oDlg FONT WndMain():oFont();
			FROM 0 , 0 TO 340 , 600 PIXEL
			oDlg:cTitle := "REPLACE RECORDS FROM " + UPPER(cFileName) +;
										 "	:		 FIELD ... WITH EXPRESSION ... "
			i := 1
			Aeval(aFlds,{||aFlds[i] := FieldName(i),i++})
			FOR i := 1 TO 5
				AADD(aItem , {Space(10) , Space(80) } )
			NEXT
			@ 5,5 XBROWSE oBrw OF oDlg ;
			SIZE 290,60;
			ARRAY aItem;
			HEADERS "Field","Expression";
			COLSIZES 80 , 440;
			PIXEL AUTOCOLS LINES

			WITH OBJECT oBrw
				:lhScroll := .F.
				:lFastEdit										:= .T.
				:nMoveType		 := MOVE_FAST_RIGHT
				:nMarqueeStyle := MARQSTYLE_HIGHLCELL
				:oCol("Field"):nEditType := 4
				:oCol("Field"):aEditListTxt := :oCol("Field"):aEditListTxt := aFlds
				:oCol("Field"):bEditValid		:= {||ASCAN(aFlds,UPPER(oBrw:aRow[1]))>0}
				:oCol("Expression"):nEditType	 := 3
				:oCol("Expression"):bEditBlock := {||IIF(! EMPTY(oBrw:aRow[1]) , ;
																							 ExpBuilder(oBrw:aRow[2],"For expression",;
																													ValType(EVAL(FieldBlock(oBrw:aRow[1])))),)}
				:oCol("Expression"):bEditWhen	 := {||! EMPTY(oBrw:aRow[1])}
			END
			oBrw:CreateFromCode()
			nRw := 70
		ELSE
			DEFINE DIALOG oDlg FONT WndMain():oFont();
			FROM 0 , 0 TO 200 , 600 PIXEL
			IF n == 2
				oDlg:cTitle := "RECALL RECORDS FROM " + UPPER(cFileName)
			ELSEIF n == 3
				oDlg:cTitle := "DELETE RECORDS FROM " + UPPER(cFileName)
			ELSEIF n == 4
				oDlg:cTitle := "RECORD COUNTER FROM " + UPPER(cFileName)
			ELSE
				oDlg:cTitle	 := "STATISTICS FROM " + UPPER(cFileName)
				oDlg:nBottom := 310
			END
			nRw := 5
		END
		@ nRw	 , 5 SAY "For Condition : " SIZE 50 , 10 PIXEL RIGHT
		@ nRw	 , 55	 GET cFor SIZE 240,10 PIXEL ACTION ExpBuilder(@cFor,"For expression","L");
								 VALID ChKExpr(cFor,.F.,"L")
		nRw += nStep

		@ nRw	 , 5 SAY "While Condition : " SIZE 50 , 10 PIXEL RIGHT
		@ nRw	 , 55	 GET cWhile SIZE 240,10 PIXEL;
								 ACTION ExpBuilder(@cWhile,"While expression","L") ;
								 VALID ChKExpr(cWhile,.F.,"L") .AND. ;
											 (ShowOrHide({oSayTag , oCombo} , ! Empty(cWhile) ) ,.T.)
		i := 1
		IF ::lArray
			aTag := Array(LEN(::oBrowse:aCols))
			AEVAL(::oBrowse:aCols,{|o|aTag[i] := o:cHeader , IIF(o:cOrder$"AD",nTag := i,),i++})
			cTag := aTag[nTag]
		ELSE
			IF OrdCount() > 0
				aTag := Array(OrdCount())
				AEVAL(aTag,{||aTag[i] := OrdName(i),i++})
				nTag := IndexOrd()
				cTag := aTag[nTag]
			END
		ENDIF
		nRw += nStep
		@ nRw	 , 55	 SAY oSayTag VAR "Index tag : "	 SIZE 50,10 PIXEL RIGHT
		@ nRw , 105 COMBOBOX oCombo VAR cTag ITEMS aTag OF oDlg PIXEL VALID ! EMPTY(cTag)
		nRw += nStep*1.5
		@ nRw , 5	 SAY "Scope : " OF oDlg SIZE 50 , 10 PIXEL RIGHT
		@ nRw , 55 COMBOBOX oScope VAR cScope ITEMS aScope OF oDlg PIXEL;
								 ON CHANGE ShowOrHide({oSayRec , oGetRec} , cScope$"NextRecord" ) ;

		@ nRw , 95	SAY oSayRec VAR "Records : " OF oDlg SIZE 35 , 10 PIXEL RIGHT
		@ nRw , 135 GET oGetRec VAR nRecords OF oDlg PIXEL SIZE 30,10 RIGHT

		@ nRw	 , 180 SAY "Records processed : "	 SIZE 55,10 PIXEL RIGHT
		@ nRw , 235 SAY oGetRepl VAR nRepl OF oDlg PIXEL SIZE 30,10 RIGHT

		IF n < 5
			nRw += nStep*2
			@ nRw , 45 BUTTON oButCount PROMPT "Count"	 OF oDlg SIZE 45, 13 PIXEL ;
							 ACTION CountRepl( ,cFor,cWhile,cTag,cScope,nRecords,oGetRepl,4)

			IF n < 4
				@ nRw , 127 BUTTON oButRepl PROMPT TxtBut[n] OF oDlg SIZE 45, 13 PIXEL	;
							 ACTION CountRepl(oBrw,cFor,cWhile,cTag,cScope,nRecords,oGetRepl,n)
			END
			@ nRw , 210 BUTTON oButCancel PROMPT "Cancel" OF oDlg SIZE 45, 13 PIXEL ;
							 ACTION oDlg:end()
		ELSE
			nRw += nStep*2
			i := 1
			aFlds := {}
			Aeval(::aStruc,{|a|IIF(a[2]="N",AADD(aFlds,{a[1],0,0,0,0,0}),)})

			@ nRw,5 XBROWSE oBrw OF oDlg ;
			SIZE 290,60;
			ARRAY aFlds;
			HEADERS "Name","Sum","Minimum","Maximum","Average","Deviation";
			COLSIZES 80 , 90 , 90 , 90 , 90 , 90;
			PIXEL AUTOCOLS LINES

			WITH OBJECT oBrw
				:lhScroll				 := .F.
				:lRecordSelector := .F.
				:nMarqueeStyle	 := MARQSTYLE_HIGHLROW
			END
			oBrw:CreateFromCode()

			nRw += 65
			@ nRw , 90 BUTTON oButRepl PROMPT TxtBut[n] OF oDlg SIZE 40, 15 PIXEL	 ;
							 ACTION CountRepl(oBrw,cFor,cWhile,cTag,cScope,nRecords,oGetRepl,n)
			@ nRw , 150 BUTTON oButCancel PROMPT "Cancel" OF oDlg SIZE 40, 15 PIXEL ;
							 ACTION oDlg:end()

		ENDIF
		ACTIVATE DIALOG oDlg CENTER ON INIT (ShowOrHide({oSayTag , oCombo , oSayRec , oGetRec},.F.))
		IF n == 2
			set(_SET_DELETED,lOnOff)
		END
		EVAL(::oBrowse:bChange,::oBrowse)
		RETURN nil

*************************************************************************************
		STATIC PROC ShowOrHide(aObj,lOn)
		********************************
		DEFAULT lOn := .T.
		AEVAL(aObj,{|o|IIF(lOn,o:Show(),o:Hide())})
		RETURN

*************************************************************************************
		STATIC PROC CountRepl(oBrw,cFor,cWhile,cTag,cScope,nRecords,oGetRepl,nmode)
		***************************************************************************
		local bRepl , bWhile , bFor , next , rec , lRest := .F.
		local cMem	, i , nMem , el
		local cRepl , aRepl
		local Self := oDbfWnd
		local oCol
		local bWhil , bRep
		local n
		nMem := ::oBrowse:KeyNo()
		cMem := OrdName()
		IF ::lArray
			ASCAN(::oBrowse:aCols,{|o|IIF(o:cOrder$"AD" , (oCol := o ,.T.) , .F.)})
			IF oCol == nil
				oCol := ::oBrowse:aCols[1]
			END
			cMem := oCol:cHeader
			IF cMem <> cTag
				ASCAN(::oBrowse:aCols,{|o|IIF(o:cHeader==cTag , (oCol := o ,.T.) , .F.)})
				IF oCol <> nil
					oCol:cOrder := ""
					oCol:SortArrayData()
					::oBrowse:Refresh(.T.)
				END
			END
		END
		IF ( ::cAlias )->( DbInfo( DBI_SHARED ) ) .AND. nMode < 4 .AND. ! FLOCK()
			MsgInfo("File can not be locked")
			RETURN
		END
		IF nmode == 1
			aRepl := oBrw:aArrayData
			bRepl := {||n++}
			IF aRepl <> nil
    cRepl := "{||"
				FOR EACH el IN aRepl
					IF ! (Empty(el[1])	.or. empty(el[2]))
						cRepl += "_FIELD->"+el[1]+ " := " + el[2] + " , "
					END
				NEXT
				cRepl := SUBSTR(cRepl,1,LEN(cRepl) - 3) + "}"
				bRep := &( cRepl )
				bRepl := {||n++,EVAL(bRep)}
			END
		ELSEIF nmode == 2
			bRepl := {||n++,DbRecall()}
		ELSEIF nmode == 3
			bRepl := {||n++,DbDelete()}
		ELSEIF nMode == 4
			bRepl := {||n++}
		ELSE
			FOR EACH el IN oBrw:aArrayData
				FOR i := 2 TO 6
					el[i] := 0
				NEXT
			NEXT
			bRepl := {||n++,Calcul(oBrw:aArrayData,1)}
		END
		IF ! Empty(cFor)
			bFor := COMPILAR(cFor)
		END
		IF ! Empty(cWhile)
			bWhile := COMPILAR(cWhile)
			IF ! ::lArray .AND. cMem <> cTag
					(::cAlias)->(OrdSetFocus(cTag))
					::oBrowse:Refresh(.T.)
			END
			IF ! EVAL(bWhile)
				DO WHIL ! EVAL(bWhile) .AND. ! ::oBrowse:Eof()
					::oBrowse:Skip()
				END
			END
			nMem := ::oBrowse:KeyNo()
		end
		n := 0
		IF cScope == "All"
		ELSEIF cScope == "Next"
			Next := nRecords
		ELSEIF cScope == "Record"
			Rec	 := nRecords
		ELSE
			lRest := .T.
		ENDIF
		IF ::lArray
			IF VALTYPE(Rec) <> "N"
				IF bWhile == nil
					bWhile := {||DbGoto(ATAIL(::oBrowse:aArrayData[i++])),.T.}
				ELSE
					bWhil	 := bWhile
					bWhile := {||DbGoto(ATAIL(::oBrowse:aArrayData[i++])),EVAL(bWhil)}
				ENDIF
			END
			i := nMem
			DbGoto(::oBrowse:IndexRecNo())
		end
		n := 0
		DBEval( bRepl , bFor , bwhile, next , rec , lRest )
		oGetRepl:Varput(n)
		oGetRepl:Refresh()
		IF nMode == 5
			::oBrowse:KeyNo(nMem)
			FOR EACH el IN oBrw:aArrayData
				el[5] := el[2]/n
			NEXT
			bRepl := {||Calcul(oBrw:aArrayData,2)}
			DBEval( bRepl , bFor , bwhile, next , rec , lRest )
			FOR EACH el IN oBrw:aArrayData
				IF n > 1
					el[6] := SQRT(el[6]/n-1)
				END
			NEXT
			oBrw:Refresh()
		END
		::oBrowse:KeyNo(nMem)
		IF ! ::lArray
			OrdSetFocus(cMem)
		END
		DbUnlock()

		RETURN

*************************************************************************************
		PROC Calcul(aNumFields,nMode)
		*****************************
		local cField , el , x
		FOR EACH el IN aNumFields
			cField := el[1]
			x := Fieldget(Fieldpos(cField))
			IF nMode == 1
				el[2] += x
				el[3] := Min(x,el[3])
				el[4] := Max(x,el[4])
			ELSE
				el[6] += (x - el[5])*(x - el[5])
			ENDIF
		NEXT
		RETURN
**************************************************************************************
METHOD PackZap(nMode) CLASS TDbfWnd
***********************************
local oDlg
local cAlias := ::cAlias
local cPath,cFileName,cExtension
local nDel := 0 , nCount
local oButOk , oButCancel , Txt
local nMem	 := (::cAlias)->(Recno())
local lOnoff := set(_SET_DELETED,.F.)
local cTitle := IIF(nMode == 1 , "PACK RECORDS FROM " , "DELETE ALL RECORDS FROM ")
local bAction
local MemColor , NewColor
local lShared := .F.
local cRdd := (cAlias)->(RddName())
Hb_fNameSplit(DbInfo(DBI_FULLPATH),@cPath,@cFileName,@cExtension)
IF EMPTY(cPath)
	cPath := CurDrive()+":\"+CurDir()
END
IF Right(cPath,1) <> "\"
	cPath += "\"
END
cFileName := UPPER(cPath+cFileName+cExtension)
IF (cAlias)->(DbInfo(DBI_SHARED))
	lShared := .T.
	IF ! MsgYesNo(cFileName + " must be opened exclusively. Open exclusively ?" )
		RETURN nil
	END
	SELECT (cAlias)
	USE
	TRY
		dbUseArea( .F., cRdd , cFileName , cAlias, .F., .f. )
	CATCH
		MsgInfo( cFileName + CRLF + 'can not be opened exclusively' )
		return nil
	END
	EVAL(::oWnd:oMsgBar:aItems[MSGSHARED]:bMsg)
END
IF nMode == 1
	(cAlias)->(DbGotop())
	(cAlias)->(DbEval({||nDel++},{||(cAlias)->(Deleted())}))
END

Hb_fNameSplit((cAlias)->(DbInfo(DBI_FULLPATH)),@cPath,@cFileName,@cExtension)
cTitle += cFileName

DEFINE DIALOG oDlg FONT WndMain():oFont();
		FROM 0 , 0	TO 140 , 300 PIXEL
		oDlg:cTitle := cTitle

IF nMode == 1
	bAction := {||(cAlias)->(__dbPack()) , (cAlias)->(DbUnlock()) , oDlg:end() }
	@ 5 , 5	 SAY		"Total records : " + STR(nCount := (cAlias)->(Reccount()),6);
					 OF oDlg SIZE 70 , 10 PIXEL RIGHT

	@ 20 , 5 SAY "Deleted records : " + STR(nDel,6) OF oDlg SIZE 70 , 10 PIXEL RIGHT

	@ 5 , 80 SAY LTRIM(STR(nDel)) + " records will be removed from " +;
							 cFileName OF oDlg SIZE 60 , 30 PIXEL BORDER

	Txt := "PACK TO " + LTRIM(STR((cAlias)->(Reccount())-nDel)) + " RECORDS"
ELSE
	bAction := {||msginfo("ZAP") , __dbZap() , oDlg:end()}
	@ 5 , 20 SAY "All records ("+ LTRIM(STR((cAlias)->(Reccount()))) + ;
								") will be removed from " + cFileName OF oDlg SIZE 120 , 30 PIXEL BORDER
	Txt := "REMOVE " + LTRIM(STR((cAlias)->(Reccount()))) + " RECORDS"
END

@ 40 , 10 BUTTON oButOk PROMPT Txt OF oDlg SIZE 45, 20 PIXEL
oButok:nStyle	 := NOR( oButok:nStyle, BS_MULTILINE )
oButOk:bAction := bAction

@ 40 , 100 BUTTON oButCancel PROMPT "Cancel" OF oDlg SIZE 45, 20 PIXEL;
					 ACTION oDlg:end()

ACTIVATE DIALOG oDlg CENTER

SELECT (cAlias)
IF lShared
	USE
	TRY
		dbUseArea( .F. , cRdd	 , cFileName , cAlias , .T. , .F. )
	CATCH
		MsgInfo( cFileName + CRLF + 'can not be opened (shared)' )
		return nil
	END
	EVAL(::oWnd:oMsgBar:aItems[MSGSHARED]:bMsg)
END
set(_SET_DELETED , lOnoff)
(cAlias)->(DbGoto(nMem))
RETURN nil

******************************************************************************************
METHOD CopyAppend(nMode) CLASS TDbfWnd
**************************************
local oDlg , oGr , oGrFld
local oRadF , oDelim , cDelim := '"'
local oRadFld , nFld := 1
local cAlias := ::cAlias
local cPath,cFileName,cExtension
local cTitle
local nFormat := 1
local nRow , cFor , cWhile , cTag , cScope , nRecords
local oSayTag , oCombo , oSayRec , oGetRec , oGetRepl
local oButCount , oButOk , Txt , oButCancel
local nStep := 12 , i
local nTag , aTag
local oScope , nRepl
local aScope := {"All","Next","Record","Rest"}
cFor := cWhile := space(80)
cTag := space(20)
Hb_fNameSplit((cAlias)->(DbInfo(DBI_FULLPATH)),@cPath,@cFileName,@cExtension)
IF EMPTY(cPath)
	cPath := CurDrive()+":\"+CurDir()
END
IF nMode == 1
	Txt := "APPEND FROM "
ELSE
	Txt := "COPY TO "
ENDIF
cTitle := IIF(nMode == 1 , "APPEND FROM ..."	, "COPY (from " + cFileName +") TO	... ")
cFileName := UPPER(cPath+cFileName+cExtension)
DEFINE DIALOG oDlg FONT WndMain():oFont() TITLE cTitle ;
FROM 0 , 0 TO 340 , 600 PIXEL

@ 2 ,2	GROUP oGr TO 28 , 185 LABEL "Format" PIXEL OF oDlg
@ 15 ,10 RADIO oRadF VAR nFormat;
				 ITEMS "DBF","SDF","Delimited by : ","Clipboard";
				 OF oDlg PIXEL
@ 14 , 113 GET oDelim VAR cDelim OF oDlg PIXEL SIZE 10,8;
					 WHEN nFormat == 3
@	 5 , 215 GROUP oGrFld TO 28 , 280 LABEL "Fields" PIXEL OF oDlg
@ 15 ,220	 RADIO oRadFld VAR nFld ITEMS "All","Visible" OF oDlg PIXEL;
					 WHEN ! (nFormat == 4)
@ 40 , 5	SAY "FileName : " OF oDlg PIXEL RIGHT SIZE 50,10
cFileName := Space(60)

@ 40 , 55 GET cFileName OF oDlg PIXEL ;
					ACTION cFileName := cGetFile(		"DataFile (*.DBF)|*.dbf|",;
																		"Select Data File to append from",1,;
																		cPath ) ;
					WHEN ! (nMode==1 .AND. nFormat == 4);
					VALID (cAlias)->(CheckFile(cFileName , Txt , oButOk))

nRow := 60

cScope	 := "All"
nRecords := 0
nRepl		 := 0

@ nRow	, 5 SAY "For Condition : " SIZE 50 , 10 PIXEL RIGHT
@ nRow	, 55	GET cFor SIZE 240,10 PIXEL ACTION ExpBuilder(@cFor,"For expression","L");
              WHEN ! (nMode==1 .AND. nFormat == 4);
              VALID ChKExpr(cFor,.F.,"L")
nRow += nStep

@ nRow	, 5 SAY "While Condition : " SIZE 50 , 10 PIXEL RIGHT
@ nRow	, 55	GET cWhile SIZE 240,10 PIXEL;
							ACTION ExpBuilder(@cWhile,"While expression","L");
							WHEN ! (nMode==1 .AND. nFormat == 4);
							VALID ChKExpr(cWhile,.F.,"L") .AND. (ShowOrHide({oSayTag , oCombo} ,;
									 ! Empty(cWhile) .AND. nMode == 2 ) ,.T.)
i := 1
IF (cAlias)->(OrdCount()) > 0
	aTag := Array((cAlias)->(OrdCount()))
	AEVAL(aTag,{||aTag[i] := (cAlias)->(OrdName(i)),i++})
	nTag := (cAlias)->(IndexOrd())
	cTag := aTag[nTag]
END
nRow += nStep
@ nRow	, 55	SAY oSayTag VAR "Index tag : "	SIZE 50,10 PIXEL RIGHT
@ nRow , 105 COMBOBOX oCombo VAR cTag ITEMS aTag OF oDlg PIXEL VALID ! EMPTY(cTag);
						 WHEN (cAlias)->(OrdCount()) > 0

nRow += nStep*1.5
@ nRow , 5	SAY "Scope : " OF oDlg SIZE 50 , 10 PIXEL RIGHT
@ nRow , 55 COMBOBOX oScope VAR cScope ITEMS aScope OF oDlg PIXEL;
					 ON CHANGE ShowOrHide({oSayRec , oGetRec} , cScope$"NextRecord" );
					 WHEN ! (nMode==1 .AND. nFormat == 4)

@ nRow , 95	 SAY oSayRec VAR "Records : " OF oDlg SIZE 35 , 10 PIXEL RIGHT
@ nRow , 135 GET oGetRec VAR nRecords OF oDlg PIXEL SIZE 30,10 RIGHT VALID nRecords>0 ;
						 WHEN ! (nMode==1 .AND. nFormat == 4);

@ nRow	, 180 SAY "Records processed : "	SIZE 55,10 PIXEL RIGHT
@ nRow , 235 SAY oGetRepl VAR nRepl OF oDlg PIXEL SIZE 30,10 RIGHT

nRow += nStep*2

IF nMode == 2
	@ nRow , 45 BUTTON oButCount PROMPT "Count"		OF oDlg SIZE 45, 13 PIXEL ;
							 ACTION (cAlias)->(Copy_Append(nMode,0,cDelim,::oBrowse,nFld,cFileName,;
																						 cFor,cWhile,cTag,cScope,nRecords,oGetRepl))
END																									// nFormat : 0 COUNT !!!!!!
@ nRow , 127 BUTTON oButOk PROMPT Txt OF oDlg SIZE 45, 24 PIXEL	 ;
							 ACTION (cAlias)->(Copy_Append(nMode,nFormat,cDelim,::oBrowse,nFld,cFileName,;
																						 cFor,cWhile,cTag,cScope,nRecords,oGetRepl))
oButok:nStyle	 := NOR( oButok:nStyle, BS_MULTILINE )

@ nRow , 210 BUTTON oButCancel PROMPT "Cancel" OF oDlg SIZE 45, 13 PIXEL ;
							 ACTION oDlg:end()

ACTIVATE DIALOG oDlg CENTERED ON INIT ( RadMenuTo(oRadF:aItems , oRadFld:aItems) ,;
																				ShowOrHide({oSayTag , oCombo , oSayRec , oGetRec},.F.) )
RETURN nil

************************************************************************************************
STATIC FUNC CheckFile(cFileName , Txt , oBut)
*********************************************
local cPath,cFile,cExtension
Hb_fNameSplit(cFileName,@cPath,@cFile,@cExtension)

Txt += CRLF + ALLTRIM(cFile)
oBut:setText(Txt)
oBut:Refresh()
RETURN .T.

************************************************************************************************
STATIC PROC RadMenuTo(aItems , aFld)
************************************
aItems[1]:nLeft	 := 10
aItems[1]:nTop	 := 22
aItems[1]:nWidth := 40
aItems[2]:nLeft	 := 70
aItems[2]:nTop	 := 22
aItems[2]:nWidth := 40
aItems[3]:nLeft	 := 130
aItems[3]:nTop	 := 22
aItems[3]:nWidth := 90
aItems[4]:nLeft	 := 280
aItems[4]:nTop	 := 22
aItems[4]:nWidth := 80
aFld[1]:nLeft		 := 440
aFld[2]:nLeft		 := 500
aFld[1]:nTop		 := 22
aFld[1]:nWidth	 := 40
aFld[2]:nTop		 := 22
aFld[2]:nWidth	 := 50
RETURN

***********************************************************************************************************
STATIC PROC Copy_Append(nMode,nFormat,cDelim,oBrw,nFld,cFileName,cFor,cWhile,cTag,cScope,nRecords,oGetRepl)
***********************
LOCAL aFld , oCol
LOCAL bFor , bWhile , nNext , nRec , lRest
LOCAL bWhil
LOCAL cMem , nMem , n , nCount
LOCAL cText , cLine
local oClip
local i
nMem := EVAL(oBrw:bKeyNo)
cMem := OrdName()
IF nMode == 2 .AND. oDbfWnd:lArray
	ASCAN(oBrw:aCols,{|o|IIF(o:cOrder$"AD" , (oCol := o ,.T.) , .F.)})
	IF oCol == nil
		oCol := oBrw:aCols[1]
	END
	cMem := oCol:cHeader
	IF cMem <> cTag
		ASCAN(oBrw:aCols,{|o|IIF(o:cHeader==cTag , (oCol := o ,.T.) , .F.)})
		IF oCol <> nil
			oCol:cOrder := ""
			oCol:SortArrayData()
			oBrw:Refresh(.T.)
		END
	END
END

aFld := {}
IF nFld == 2
	WITH OBJECT oBrw
		aFld := {}
		FOR EACH oCol IN oBrw:aCols
			IF ! oCol:lHide .AND. FieldNum(oCol:cHeader) > 0
				AADD(aFld,oCol:cHeader)
			END
		NEXT
	END
END
lRest := .F.
IF cScope <> "All"
	IF cScope=="Next"
		nNext := nRecords
	ELSEIF cScope == "Record"
		nRec	:= nRecords
	ELSE
		lRest := .T.
	END
END
IF ! EMPTY(cFileName)
	cFileName := ALLTRIM(cFileName)
END
IF ! EMPTY(cFor)
	bFor := COMPILAR(cFor)
END
IF nMode == 2 .AND. ! EMPTY(cWhile)
	bWhile := COMPILAR(cWhile)
	IF ! oDbfWnd:lArray .AND. cMem <> cTag
		OrdSetFocus(cTag)
		oBrw:Refresh(.T.)
	END
	IF ! EVAL(bWhile)
		DO WHIL ! EVAL(bWhile) .AND. ! oBrw:Eof()
			oBrw:Skip()
		END
	END
	nMem := oBrw:KeyNo()
END
IF nMode == 2
	// Count
	IF oDbfWnd:lArray
		IF VALTYPE(nRec) == "N"
		ELSE
			IF bWhile == nil
				bWhile := {||DbGoto(ATAIL(oBrw:aArrayData[i++])),.T.}
			ELSE
				bWhil	 := bWhile
				bWhile := {||DbGoto(ATAIL(oBrw:aArrayData[i++])),EVAL(bWhil)}
			ENDIF
		END
		i := nMem
		DbGoto(oBrw:IndexRecNo())
	END
	n := 0
	DbEval( {||n++} , bFor , bwhile, nNext , nRec , lRest )
	i := nMem
	oBrw:KeyNo( nMem )
	IF oDbfWnd:lArray
		DbGoto(oBrw:IndexRecNo())
	END
ELSEIF nFormat < 4
 nCount := EVAL(oBrw:bKeyCount) 
ELSE
	oClip := TClipBoard():New()
	if oClip:Open()
		cText := oClip:GetText
		oClip:Clear()
	endif
	oClip:end()
	n := Numtoken(cText,CRLF)
END
IF nFormat == 1
	// Dbf
	IF nMode == 1
		// Append
		__dbApp( cFileName , aFld , ;
									bFor , bWhile , nNext , nRec , lRest) //, <rdd>, <conn>, <cp> )
	ELSE
		// Copy
		__dbCopy( cFileName , aFld , ;
									bFor , bWhile , nNext , nRec , lRest) //, <rdd>, <conn>, <cp> )
	ENDIF
ELSEIF nFormat == 2

	__dbSDF( nMode == 2 , cFileName , aFld , ;
									bFor , bWhile , nNext , nRec , lRest) //, <rdd>, <conn>, <cp> )

ELSEIF nFormat == 3
	// Delimited
	__dbDelim( nMode == 1 , cFileName , cDelim , aFld , ;
									bFor , bWhile , nNext , nRec , lRest)

ELSEIF nFormat == 4
	// Clipboard
	IF nMode == 1
		FOR n := 1 TO Numtoken(cText,CRLF)
			cLine := token(cText,CRLF,n)
			DbAppend()
			IF NetErr()
			ELSE
				oDbfWnd:oBrowse:Refresh()
				oDbfWnd:oBrowse:Paste(cLine)
				DbCommit()
				DbUnlock()
			END
		NEXT
	ELSE
		// Copy
		cText := ""
		DBEval( {||cText += oDbfWnd:oBrowse:ClpRow( .t. ) + CRLF } ,;
						bFor , bwhile, nNext , nRec , lRest )
		oClip := TClipBoard():New()
		if ! EMPTY(cText) .AND. oClip:Open()
			cText := LEFT(cText,LEN(cText)-2)
			oClip:SetText( cText )
		endif
		oClip:end()
		oBrw:KeyNo( nMem )
	END
ENDIF
IF nMode == 1 .AND. nFormat < 4
	n := Reccount() - nCount
END
oGetRepl:Varput(n)
oGetRepl:Refresh()
oBrw:KeyNo( nMem )
IF oDbfWnd:lArray
	DbGoto(oBrw:IndexRecNo())
ELSE
	OrdSetFocus(cMem)
END
EVAL(oBrw:bChange)
RETURN
***********************************************
METHOD SetRecord(nRec) CLASS TDbfWnd
**********************
local cAlias := ::cAlias
local oBrw	 := ::oBrowse
local i , oCol , lOk := .F.
IF ::lArray
	IF PCOUNT() == 1
		(cAlias)->(DbGoto(nRec))
	END
	nRec := (cAlias)->(Recno())
	ASCAN(oBrw:aCols , {|o|oCol := o , o:cOrder$"AD"})
	oBrw:nArrayAt := 1
	IF oBrw:oCOl("Recno")==oCol .AND. oCol:cOrder=="A"
		IF nRec > 0 .AND. nRec <= LEN(oBrw:aArrayData)
			oBrw:nArrayAt := nRec
			lOk := .T.
		END
	ELSE
		i := ASCAN(oBrw:aArrayData , {|a|ATAIL(a)==nRec})
		IF i > 0
			oBrw:nArrayAt := i
			lOk := .T.
		END
	END
  
  oBrw:Refresh()
  EVAL(oBrw:bChange)
END
RETURN self
*************************************************
METHOD ReadData() CLASS TDbfWnd
*****************
local cAlias := ::cAlias
local oBrw	 := ::oBrowse
local oCol
local aArrayData[0]
local nRecord := (cAlias)->(Recno())
local aCols[0]
IF ::lArray
  AEVAL(::oBrowse:aCols,{|o|IIF(o:cOrder$"AD" , oCol := o , ) , AADD(aCols,bExpr(o:cExpr))})
  (cAlias)->(DbGotop())
  (cAlias)->(DbEval({||AADD(aArrayData,ReadRec(aCols))}))
  oBrw:aArrayData := aArrayData
  oBrw:nArrayAt := 1 
  oCol:cOrder := ""
  oCol:SortArrayData()
  ::SetRecord(nRecord)
  oBrw:Refresh()
END
RETURN self
******************************************************************************************
METHOD CheckRel() CLASS TDbfWnd
*******************************
LOCAL i , a
IF ! VALTYPE(::aRelations) == "A"
   RETURN
END
FOR EACH a IN ::aRelations
    IF ! EMPTY(a[4]) .AND. SELECT(a[2]) > 0
       IF ( a[4] IN aTags(::cAlias) )
          (a[2])->(OrdSetFocus(a[4]))
       END
    END    
NEXT
RETURN self
******************************************************************************************
STATIC FUNC CheckrelTag(cTag)
*****************************
LOCAL cAlias := Alias() , c
LOCAL Self , o
LOCAL lOk := .T.
FOR EACH o IN oWndDbu:oWndClient:aWnd
    Self := o:Cargo
    
    IF VALTYPE(Self) == "O" .AND. __ObjHAsData(Self , "aRelations") .AND.;
       UPPER(::cAlias) <> UPPER(cAlias)
       IF ASCAN(::aRelations,{|a|UPPER(TRIM(a[4]))=UPPER(TRIM(cTag))}) > 0
          lOk := .F.
          EXIT
       END
    END

NEXT
RETURN lOk
******************************************************************************************
STATIC FUNC CheckrelAlias()
***************************
LOCAL cAlias := Alias() , c
LOCAL Self , o
LOCAL lOk := .F.
FOR EACH o IN oWndDbu:oWndClient:aWnd
    Self := o:Cargo
    IF VALTYPE(Self) == "O" .AND. __ObjHAsData(Self , "aRelations") .AND.;
       UPPER(::cAlias) <> UPPER(cAlias)
       IF ASCAN(::aRelations,{|a|UPPER(TRIM(a[2]))=UPPER(TRIM(cAlias))}) > 0
          lOk := .T.
          EXIT
       END
    END

NEXT
RETURN lOk
******************************************************************************************
FUNCTION ChkExpr(xExpr,lDisplay, cType)
***************************************

		 LOCAL xRet
		 LOCAL bOldError, bNewError
		 LOCAL cExpr
		 LOCAL lOk
   local bexpr
		 IF Valtype(xExpr) == "O"
					cExpr := xExpr:cText()
		 ELSE
					cExpr := xExpr
		 ENDIF
		 DEFAULT lDisplay := .T.

		 IF empty(cExpr)
					RETU .T.
		 ENDIF

   lOk := CheckExpression(cExpr,@xRet)

   IF lOk .AND. cType != NIL .AND. ;
					!Valtype(xRet)$cType
					MsgAlert("The expression should return a value of type ["+cType+"]",;
					"Expression Error")
					IF Valtype(xExpr) == "O"
							 xExpr:cText(Space(len(cExpr)))
					ENDIF
					RETU .F.
		 ENDIF
				IF lOk
					IF lDisplay
						MsgRun("Correct expression" , cExpr ,{|| SysWait(1) })
					END
				ELSE
					 MsgRun("Incorrect expression" , cExpr ,{|| SysWait(3) })
				END
		 IF !lOk .AND. Valtype(xExpr) == "O"
					xExpr:cText(Space(len(cExpr)))
		 ENDIF

RETURN lOk

STATIC FUNCTION ErrorHandler(oError,lLocalError)

		 IF lLocalError
		BREAK oError
	ENDIF

RETURN NIL

//----------------------------------------------------------------------------//

CLASS TDbfCol

		 CLASSDATA nColumns																			 AS NUMERIC

		 DATA oDbfWnd																						 AS OBJECT
		 DATA bData, bExpress																		 AS BLOCK
		 DATA cAlias, cType, cHeader, cPicture, cField					 AS CHARACTER
		 DATA nField, nSize, nDec, nWidth												 AS NUMERIC
		 DATA lJustify, lExpress, lError												 AS LOGICAL

		 METHOD New(oDbfWnd, nField) CONSTRUCTOR

		 METHOD FromExp(oDbfWnd, cExpression) CONSTRUCTOR

		 METHOD SetText(cPicture)
		 METHOD Check()

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New(oDbfWnd,nField,lArray) CLASS TDbfCol

		 LOCAL aStruc
		 LOCAL uVal
		 DEFAULT lArray := .F.
		 ::nColumns := ::nColumns + 1

		 aStruc := oDbfWnd:aStruc
		 uVal		:= (oDbfWnd:cAlias)->(FieldGet(nField))

		 ::oDbfWnd	:= oDbfWnd
		 ::nField		:= nField
		 ::cAlias		:= oDbfWnd:cAlias
		 IF lArray
			::cHeader	 := "Recno"
			::cField	 := "Recno"
			::cType		 := "N"
			::nSize		 := 6
			::nDec		 := 0
			::bExpress := {||Recno()}
		 ELSE
			::cHeader	 := aStruc[nField][1]
			::cField	 := aStruc[nField][1]
			::cType		 := aStruc[nField][2]
			::nSize		 := aStruc[nField][3]
			::nDec		 := aStruc[nField][4]
			::bExpress := {|| FieldGet(::nField)}
		 END
		 ::cPicture := ""
		 ::nWidth		:= GetTextWidth(0,Replicate("B",Max(::nSize,len(::cHeader))+1),;
															 oDbfWnd:oFont:hFont)
		 ::lJustify := (::cType == "N")
		 ::SetText()

RETURN Self

//----------------------------------------------------------------------------//

METHOD FromExp(oDbfWnd, cHeader, cExpression) CLASS TDbfCol

		 LOCAL uVal

		 cHeader		:= Alltrim(cHeader)

		 ::oDbfWnd	:= oDbfWnd
		 ::lExpress := .T.
		 ::cField		:= cExpression

		 ::Check()

		 uVal := Eval(::bExpress)

		 ::cType := Valtype(uVal)

		 DO CASE
		 CASE ::cType == "C"
		 ::nSize := len(uVal)
		 CASE ::cType == "N"
		 ::nSize := 10
		 CASE ::cType == "D"
		 ::nSize := 8
		 CASE ::cType == "L"
		 ::nSize := 1
		 OTHERWISE
					MsgAlert("The expression should be Character, Numeric, Date or Logical",;
									 "Error on expression")
					RETU NIL
		 ENDCASE

		 ::nColumns := ::nColumns + 1
		 ::nField		:= 0
		 ::cAlias		:= ""
		 ::cHeader	:= cHeader
		 ::cType		:= Valtype(uVal)
		 ::nDec			:= 0
		 ::cPicture := ""
		 ::nWidth		:= GetTextWidth(0,Replicate("B",Max(::nSize,len(::cHeader))+1),;
															 oDbfWnd:oFont:hFont)
		 ::lJustify := (::cType == "N")
		 ::SetText()

RETURN NIL

//----------------------------------------------------------------------------//

METHOD SetText(cPicture) CLASS TDbfCol

		 DEFAULT cPicture := ::cPicture

		 ::cPicture := trim(cPicture)

		 DO CASE
		 CASE ::cType == "N"
					IF !empty(cPicture)
							 ::bData := {|| Transform(Eval(::bExpress),::cPicture)}
					ELSE
							 ::bData := {|| str(Eval(::bExpress),::nSize,::nDec)}
					ENDIF

		 CASE ::cType == "C"
					IF !empty(::cPicture)
							 IF ::oDbfWnd:lAnsiTrans
										::bData := {|| Transform(OemtoAnsi(Eval(::bExpress)),::cPicture)}
							 ELSE
										::bData := {|| Transform(Eval(::bExpress),::cPicture)}
							 ENDIF
					ELSE
							 IF ::oDbfWnd:lAnsiTrans
										::bData := {|| OemtoAnsi(Eval(::bExpress))}
							 ELSE
										::bData := {|| Eval(::bExpress)}
							 ENDIF
					ENDIF

		 CASE ::cType == "D"
					::bData := {|| dtoc(Eval(::bExpress))}

		 CASE ::cType == "M"
					IF lDispMemo
							 ::bData := {|| Memo2Txt(::bExpress)}
					ELSE
							 ::bData := {|| "	 <Memo>	 "}
					ENDIF

		 CASE ::cType == "L"
					::bData := {|| iif(Eval(::bExpress),cYesLogic, cNoLogic) }

		 ENDCASE

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Check() CLASS TDbfCol

		 LOCAL lNeedRefresh := ::lError

		 IF !::lExpress
					RETU .F.
		 ENDIF

		 IF !ChkExpr(::cField, .F.)
					::lError	 := .T.
					::bExpress := {|| "ERROR: "+::cField}
					::cType		 := "C"
					::SetText()
		 ELSE
					::lError	 := .F.
					::bExpress := COMPILAR(::cField)
					::cType		 := Valtype(Eval(::bExpress))
					::SetText()
		 ENDIF

RETURN (lNeedRefresh != ::lError)

//----------------------------------------------------------------------------//

FUNCTION Memo2Txt(bExpr)

		 LOCAL xExpr
		 LOCAL cValtype

		 xExpr := Eval(bExpr)
		 cValtype := Valtype(xExpr)

		 DO CASE
		 CASE cValType == "A"
					 RETU "< Array: ["+ltrim(str(len(xExpr)))+"] >"

		 CASE cValType == "N"
					RETU "< Number: "+lTrim(Str(xExpr))+" >"

		 CASE cValType == "C"
					IF empty(xExpr)
							 RETU "< Empty string >"
					ELSE
							 RETU StrTran(HardCR(Left(xExpr, 255)),CRLF,"$")
					ENDIF

		 CASE cValType == "D"
					RETU	"< Date: "+dtoc(xExpr)+" >"

		 CASE cValType == "L"
					RETU "< Logical: "+iif(xExpr,cYesLogic, cNoLogic)+" >"

		 ENDCASE

RETURN ""

********************************************************************************************************
********************************************************************************************************

# DEFINE CKEY					1
# DEFINE CFILENAME		2
# DEFINE CTAG					3
# DEFINE CFOR					4
# DEFINE CWHILE				5
# DEFINE LUNIQUE			6
# DEFINE LDESCEND			7
# DEFINE LTEMPORARY		8
# DEFINE LSUBINDEX		9
# DEFINE CSUBINDEX	 10
# DEFINE CSCOPE			 11
# DEFINE NRECORD		 12
# DEFINE NSTART			 13
# DEFINE NCOUNT			 14

STATIC FUNC LoadhIndex()
************************************
LOCAL i
LOCAL cPath , cFileName , cExtension
LOCAL lTemporary := .F. , lSubIndex	 := .F.
LOCAL cSubIndex	 := Space(10)
LOCAL cScope := "All" , nRec := 0
LOCAL nStart
LOCAL cWhile := Space(80)
LOCAL aIndex
LOCAL cAlias := Alias()
aIndex := {}
IF (cAlias)->(OrdCount()) > 0
   FOR i := 1 TO (cAlias)->(OrdCount())
       Hb_fNameSplit((cAlias)->(DbOrderInfo(DBOI_FULLPATH ,, i)),@cPath,@cFileName,@cExtension)
       cFileName := UPPER(cFileName+cExtension)
       (cAlias)->(AADD(aIndex,{PAD((cAlias)->(OrdKey(i)),80),PAD(cFileName,80),;
           PAD((cAlias)->(OrdName(i)),20),PAD((cAlias)->(OrdFor(i)),80),cWhile,;
           (cAlias)->(OrdIsUnique(i)),(cAlias)->(OrdDescend(i)),lTemporary,lSubIndex,;
            cSubIndex,cScope,nRec,nStart,(cAlias)->(OrdkeyCount(i))}))
   NEXT
END
RETURN aIndex

***********************************************************************
PROC CheckIndex(aIndex,hIndex)
******************************
LOCAL Self := oDbfWnd
LOCAL ahIndex[LEN(hIndex)]
LOCAL cKey , hTxt
LOCAL a , i
LOCAL lBuildReg , lBuildTemp , nReg
LOCAL cAlias := Alias()
local bTmp := {|Inp|! Empty(Inp[CWHILE]) .OR. Inp[LTEMPORARY] ;
            .OR. Inp[LSUBINDEX] .OR. Inp[CSCOPE]<>"All"}
local iToCheck := {1,2,3,4,6,7} , j 
IF LEN(hIndex) == 0
   RETURN
END
FOR EACH cKey IN hGetKeys(hIndex)
    hTxt := hIndex[cKey]
    a := Hb_aTokens(hTxt,";")
    // 6-9 : Logical
    FOR i := 1 TO 5
        a[i] := PAD(UPPER(a[i]),IIF(i==3,20,80))
    NEXT        
    FOR i := 6 TO 9
        a[i] := (ALLTRIM(a[i])=".T.")
    NEXT        
    a[10] := PAD(UPPER(a[10]),10)
    // 12-14 : Numeric
    FOR i := 12 TO 14
        a[i] := VAL(ALLTRIM(a[i]))
    NEXT        
    aHindex[Val(cKey)] := a
NEXT

nReg := ASCAN(aHindex,{|a|EMPTY(a[2])})
lBuildReg := .F.
IF LEN(aIndex) == IIF(nReg==0,LEN(aHindex),nReg-1)
   FOR i := 1 TO LEN(aIndex)
       IF UPPER(aIndex[i,1]) <> UPPER(aHindex[i,1])
          lBuildReg := .T.
          EXIT
       END
       FOR EACH j IN iToCheck   // Regular index !
           IF aIndex[i,j]<>aHindex[i,j]
              lBuildReg := .T.
              EXIT
           END
       NEXT
       IF lBuildReg
          EXIT
       END        
   NEXT
ELSE
   lBuildReg := .T.
ENDIF
lBuildTemp := (nReg > 0)
aIndex := aHindex
IF lBuildReg .OR. lBuildTemp
   (cAlias)->(BuildIndex(aHindex ,! lBuildReg .AND. lBuildTemp))
END
RETURN

**********************************************************
PROC OpenMyIndex()
******************
LOCAL Self := oDbfWnd
LOCAL cFile
LOCAL cPath,cFileName,cExtension
LOCAL oBrw   := ::oBrowse
LOCAL cAlias := oBrw:cAlias
LOCAL cText , lExist := .F.
IF EMPTY(cAlias)
	RETURN
END
Hb_fNameSplit((cAlias)->(DbInfo(DBI_FULLPATH)),@cPath,@cFileName,@cExtension)
IF EMPTY(cPath)
	cPath := CurDrive()+":\"+CurDir()
ELSE
	IF Right(cPath,1) == "\"
		cPath := LEFT(cPath,LEN(cPath)-1)
	END
END
IF (cAlias)->(RddName()) == "DBFCDX"
	cText	 := "IndexFile (*.CDX)|*.cdx|"
	lExist := File(cFileName := cPath+"\"+cFileName+".cdx")
ELSE
	cText := "IndexFile (*.NTX)|*.ntx|"
	lExist := File(cFileName := cPath+"\"+cFileName+".ntx")
END
IF lExist
	cFile :=	cGetFile(		cText , "Select Index file",1,		 ;
																		 cPath , , , , cFileName)
ELSE
	cFile :=	cGetFile(		cText ,					 ;
																		"Select Index file",1,		 ;
																		 cPath)
END

IF ! Empty(cFile)
 IF (cAlias)->(OrdCount())==0 .AND. LEN(::aIndex) > 0
  ::aIndex := {}
	END
	(cAlias)->(DbSetIndex(cFile))
 ::aIndex := (cAlias)->(LoadhIndex(cAlias))
	SetTagColumns(oBrw)
END
RETURN
************************************************************************************
PROC SetTagColumns(oBrw)
******************************
LOCAL aStruct
LOCAL nFor , n
LOCAL cAlias := oBrw:cAlias
aStruct := (cAlias)->(DbStruct())
(cAlias)->( OrderTagInfo( aStruct, 8 ) )
WITH OBJECT oBrw
   for nFor := 1 to Len( :aCols )
       if ( n := AScan( aStruct, { |a| a[ 1 ] == Upper( :aCols[ nFor ]:cHeader ) } ) ) > 0
          :aCols[ nFor ]:cSortOrder   := aStruct[ n ][ 8 ]
          :aCols[ nFor ]:cOrdBag    := ( cAlias )->( OrdBagName( :aCols[ nFor ]:cSortOrder ) )
       else
          :aCols[ nFor ]:cSortOrder   := nil
          :aCols[ nFor ]:cOrdBag    := nil
       endif
   next nFor
END
RETURN
************************************************************************************
PROC CloseMyIndex()
*******************
LOCAL Self   := oDbfWnd
LOCAL oBrw   := ::oBrowse
LOCAL cAlias := ::cAlias
LOCAL oCol
(cAlias)->(OrdListClear())
FOR EACH oCol IN oBrw:aCols
	oCol:cSortOrder := nil
	oCol:cOrder			:= nil
	oCol:cOrdBag		:= nil
NEXT
EVAL(::oWnd:oMsgBar:aItems[MSGTAG]:bMsg)
::aIndex := {}//(cAlias)->(LoadhIndex(cAlias))

RETURN
************************************************************************************
PROC MySetOrder()
**********************
LOCAL oBrw	 := oDbfWnd:oBrowse
LOCAL cAlias := oBrw:cAlias
LOCAL oCol , i , j
LOCAL aIndex[0] , ColName , nCol
LOCAL GehOrd	, aRow

IF oDbfWnd:lArray
   FOR EACH oCol IN oBrw:aCols
       i := Hb_EnumIndex()
       IF oCol:cOrder$"AD"
          j := i
       END
       (cAlias)->(AADD(aIndex,{i,oCol:cHeader}))
   NEXT
   XBROWSER aIndex TITLE "Select index" ;
      SETUP (cAlias)->(fSetup(oBrw,1,j));
      SELECT (aRow := oBrw:aRow)
   IF aRow <> nil
      i := aRow[1]
      IF i > 0
         oBrw:nColsel := i
         oBrw:aCols[i]:SortArrayData()
         oBrw:Refresh()
         SysRefresh()
      END
   END
   oBrw:Setfocus()
   RETURN
END

IF EMPTY(cAlias) .OR. (cAlias)->(OrdCount()) == 0
   RETURN
END

GehOrd := (cAlias)->(UPPER(OrdSetFocus()))
aIndex := {{0,"Natural","Creation order",0,SPACE(8)}}

FOR i := 1 TO (cAlias)->(OrdCount())
    ColName := Space(8)
    j := 0
    FOR EACH oCol IN oBrw:aCols
        IF oCol:cSortOrder <> nil .AND. UPPER(TRIM(oCol:cSortOrder)) == UPPER(TRIM((cAlias)->(OrdName(i))))
           ColName := UPPER(oCol:cHeader)
           j := oCol:nCreationOrder
           IF UPPER((cAlias)->(OrdName(i))) = GehOrd
              nCol := Hb_EnumIndex()
           END
           EXIT
        END
    NEXT
   (cAlias)->(AADD(aIndex,{i,OrdName(i),OrdKey(i),j,ColName}))
NEXT

XBROWSER aIndex TITLE "Select index" ;
				SETUP (cAlias)->(fSetup(oBrw,2));
				SELECT (aRow := oBrw:aRow)

IF aRow <> nil
   i := aRow[4]
   IF i > 0
      oBrw:nColsel := i
      oBrw:aCols[i]:SetOrder()
      oBrw:Refresh()
      IF ! EMPTY(aRow[5])
         EVAL(oDbfWnd:oWnd:oMsgBar:aItems[MSGTAG]:bMsg)
      END
      SysRefresh()
   ELSE
      IF aRow[1] > 0
         OrdSetFocus(aRow[2])
      ELSE
         DbSetOrder(0)
      END
      oBrw:Refresh()
   END
END

oBrw:Setfocus()

RETURN
***********************************************************************************
PROC fSetup(oBrw,n,j)
*********************
	oBrw:nMarqueeStyle := MARQSTYLE_HIGHLROW

 IF n == 1
    oBrw:nArrayAt := j
    oBrw:aCols[1]:cHeader := "Nr"
    oBrw:aCols[2]:cHeader := "Column name"
    oBrw:oWnd:bInit := {||oBrw:oWnd:aControls[ BUTTON_PRINT ]:Hide(),;
												oBrw:oWnd:aControls[ BUTTON_SHEET ]:Hide(),;
												HideWildSeek(oBrw:oWnd)}
 ELSEIF n == 2
    oBrw:nArrayAt := IndexOrd()
    oBrw:aCols[1]:cHeader := "Nr"
    oBrw:aCols[2]:cHeader := "Order Name"
    oBrw:aCols[3]:cHeader := "Expression"
    oBrw:aCols[4]:cHeader := "Nr"
    oBrw:aCols[5]:cHeader := "Name"
    oBrw:SetGroupHeader( "Column",4,5)
    oBrw:oWnd:bInit := {||oBrw:oWnd:aControls[ BUTTON_PRINT ]:Hide(),;
												oBrw:oWnd:aControls[ BUTTON_SHEET ]:Hide(),;
												HideWildSeek(oBrw:oWnd)}
 ELSE
    oBrw:nArrayAt := j
    oBrw:aCols[1]:cHeader := "Init file"
    oBrw:aCols[2]:cHeader := "Date"
    oBrw:aCols[3]:cHeader := "aAlias"
    oBrw:oWnd:bInit := {||oBrw:oWnd:aControls[ BUTTON_PRINT ]:Hide(),;
            oBrw:oWnd:aControls[ BUTTON_SHEET ]:Hide(),;
            HideWildSeek(oBrw:oWnd)}
 END

RETURN
**************************************************************************************
PROC HideWildSeek(oDlg)
***********************
LOCAL Obj
FOR EACH Obj IN oDlg:aControls
   IF Obj:ClassName == "TCHECKBOX"
     Obj:Hide()
     EXIT
   END
NEXT
RETURN

***************************************************************************************
PROC MyScopes(oBrw)
*******************
LOCAL Self := oDbfWnd
LOCAL oDlg , oDdlg , oBrow , oBut[2]
LOCAL aHeaders , aWidth
LOCAL cTitle
LOCAL aIndex[0] , i
LOCAL nOrder , nRecord
LOCAL bIndKey
LOCAL cAlias
LOCAL bShow
LOCAL		nCol := GetSysMetrics(0)/2 - 300
LOCAL		nRow := GetSysMetrics(1)/2 - 170

IF PCOUNT() == 0
   cAlias := ::cAlias
   oBrw   := ::oBrowse
   SELECT (cAlias)
END

cAlias := Alias()

IF OrdCount() == 0
   RETURN
END

IF IndexOrd()==0
   DbSetOrder(1)
END

nOrder := IndexOrd()
nRecord := RecNo()
aSize(aIndex,OrdCount())

FOR i := 1 TO LEN(aIndex)
   aIndex[i] := {OrdName(i) , , , , , }
   AddScopes(aIndex[i],i) // Top , Bottom , nCount
NEXT

DEFINE DIALOG oDlg FONT WndMain():oFont();
	 FROM nRow , nCol TO nRow + 340 , nCol + 600 PIXEL

oDlg:cTitle := cTitle
aHeaders := {"Nr","TagName","Top Scope","Bottom Scope","Count"}
aWidth	 := {20,70,185,185,50}

@ 5,5 XBROWSE oBrow OF oDlg ;
 SIZE 290,140;
	ARRAY aIndex;
	COLUMNS {{||oBrow:nArrayAt},1,2,3,4};
	HEADERS aHeaders;
	COLSIZES aWidth;
	PIXEL AUTOCOLS LINES
WITH OBJECT oBrow
	:lhScroll := .F.
	:lFastEdit										:= .T.
	:nMoveType		 := MOVE_FAST_RIGHT
	:lColChangeNotify := .T.
	:nMarqueeStyle := MARQSTYLE_HIGHLCELL
	bShow					 := {||(cAlias)->(EditTest(@oDDlg , GetSysMetrics(1)/2 - 65 , nCol + 600	, oBrow)) ,;
																			SetActiveWindow(oDlg:hWnd) , .T. }
	:bChange			 := {|oBrw,lRow|oBrw:nColsel := MinMax(oBrw:nColsel,3,4) ,;
																IIF(lRow , EVAL(bShow) , oBrw:Refresh())	}
	:oCol("Top Scope"):nEditType(1)
	:oCol("Bottom Scope"):nEditType(1)
	:bClrSel								 := { || { CLR_WHITE, CLR_BLUE } }
	:oCol("Nr"):bClrSel			 := { || IIF(oBrow:nArrayAt==IndexOrd() ,;
																			 { CLR_BLACK, CLR_YELLOW } , { CLR_WHITE, CLR_BLUE }) }
	:bClrSelFocus						 := {||{ CLR_WHITE, CLR_HBLUE } }
	:oCol("Nr"):bClrSelFocus := { || IIF(oBrow:nArrayAt==IndexOrd() ,;
																			 { CLR_BLACK, CLR_YELLOW } , { CLR_WHITE, CLR_HBLUE }) }

	:bClrStd								 := { || { CLR_BLACK, CLR_WHITE }}
	:oCol("Nr"):bClrStd			 := { || IIF(oBrow:nArrayAt==IndexOrd() ,;
																			 { CLR_BLACK, CLR_YELLOW } , { CLR_BLACK, CLR_WHITE }) }
END
oBrow:CreateFromCode()

@ 150 ,10 BUTTON oBut[1] PROMPT "Save in table" OF oDlg PIXEL SIZE 40 , 15;
          ACTION (SetScopes(oBrow) , oDlg:End())

@ 150 ,260 BUTTON oBut[2] PROMPT "Cancel"  OF oDlg PIXEL SIZE 40 , 15;
     ACTION oDlg:End()

ACTIVATE DIALOG oDlg ;
     ON INIT ( oBrow:nRowSel := oBrow:nArrayAt := MAX(1,nOrder) , EVAL(oBrow:bChange,oBrow,.T.) );
				 VALID ( IIF(oDdlg<>nil,oDdlg:end(),) , .T.)

 DbSetOrder(nOrder)
 DbGoto(nRecord)
 oBrw:Refresh()
RETURN

***************************************************************************************
STATIC PROC AddScopes(Arr,i)
*********************
LOCAL nOrder := IndexOrd()
LOCAL xTop , xBot , xFirst , xLast , nCount
LOCAL bIndKey
DbSetOrder(i)
bIndKey := &("{||"+IndexKey()+"}")
xTop := OrdScope(0)
xBot := OrdScope(1)
OrdScope(0,nil)
DbGoTop()
xFirst := EVAL(bIndKey)
IF EMPTY(xTop)
	xTop := xFirst
END
OrdScope(1,nil)
DbGoBottom()
xLast := EVAL(bIndKey)
IF EMPTY(xBot)
	xBot := xLast
END
nCount := OrdKeyCount()
Arr[2] := xTop
Arr[3] := xBot
Arr[4] := nCount
Arr[5] := xFirst
Arr[6] := xLast
OrdScope(0,xTop)
OrdScope(1,xBot)
DbSetOrder(nOrder)
RETURN

***************************************************************************************
STATIC PROC EditTest( oDdlg , nRow, nCol, oBrw )
************************************************
# define MOVEINDLG
LOCAL Self := oDbfWnd
local oDlg := oBrw:oWnd
local nAt := oBrw:nArrayAt
local aRow := oBrw:aRow
local calias := Alias()
local Txt
local hRow   := ::aIndex[nAt]
local cTag   := aRow[1] , oCol
local cTitle := "Index Tag : " + cTag


  # ifdef MOVEINDLG
  // If not defined this dialog is placed outside the dialog
  local aPoint
  nRow := oBrw:nRowSel * oBrw:nRowHeight + oBrw:HeaderHeight()
  nCol := oBrw:oCol("Top Scope"):nDisplayCol
  aPoint  := ClientToScreen( oBrw:hWnd, { nRow, nCol } )
  nRow   := aPoint[ 1 ] + 5
  nCol   := aPoint[ 2 ] + IIF(oBrw:oCol("Top Scope"):nDisplayCol==0,119,0)
  # endif

IF oDdlg<>nil .AND. oDdlg:ClassName == "TDIALOG"
	oDdlg:end()
END
FOR EACH oCol IN ::oBrowse:aCols
    IF VALTYPE(oCol:cSortOrder) == "C" .AND. UPPER(oCol:cSortOrder) = UPPER(cTAG)
       cTitle += " , Column : " + oCol:cHeader + "(" + LTRIM(STR(Hb_EnumIndex())) + ")" 
       EXIT   
    END
NEXT
DEFINE DIALOG oDDlg OF oBrw:oWnd FROM nRow +2, nCol TO nRow + 130, nCol + 370;
   PIXEL FONT WndMain():oFont();
   TITLE cTitle 
@ 2,5  SAY "First record" OF oDdlg PIXEL
@ 2,56	SAY ":	" + cValToChar(oBrw:aRow[5])	 OF oDdlg PIXEL
@ 12,5 SAY "Last record"     OF oDdlg PIXEL
@ 12,56 SAY ":	" + cValToChar(oBrw:aRow[6])	 OF oDdlg PIXEL
@ 22,5	SAY	 "Index expression"		 OF oDdlg PIXEL
@ 22,56 SAY	 ":	 " + OrdKey(nAt)	 OF oDdlg PIXEL
@ 32,5	SAY	 "For expression"			 OF oDdlg PIXEL
@ 32,56 SAY	 ":	 " + OrdFOr(nAt)	 OF oDdlg PIXEL
@ 42,5	SAY	 "While expression"			 OF oDdlg PIXEL
@ 42,56 SAY	 ":	 " + hRow[CWHILE]		OF oDdlg PIXEL
@ 52,5	SAY	 "Scope"			OF oDdlg PIXEL
Txt := hRow[CSCOPE]
IF hRow[CSCOPE] $ "NextRecord"
	Txt += " " + LTRIM(STR(hRow[NRECORD]))
END
@ 52,56 SAY	 ":	 " + Txt OF oDdlg PIXEL
IF hRow[LDESCEND]
	@ 52,100 SAY	"		" + IIF(hRow[LDESCEND],"Descending","") OF oDdlg PIXEL
END
ACTIVATE DIALOG oDDlg NOWAIT ON INIT Move_Dlg(oDdlg,nRow,nCol)
RETURN

**************************************************************************************
STATIC PROC SetScopes(oBrw)
***************************
LOCAL Self := oDbfWnd
LOCAL el
FOR EACH el IN oBrw:aArrayData
    OrdSetFocus(el[1])
    IF el[2] > el[5]
       OrdScope(0,el[2])
       ::oBrowse:GoTop()
    ELSE
       OrdScope(0,nil)
    ENDIF 
    IF el[3] < el[6]
       OrdScope(1,el[3])
       ::oBrowse:GoBottom()
    ELSE
       OrdScope(1,nil)
    ENDIF 
NEXT
::oBrowse:Refresh()
RETURN
**************************************************************************************
STATIC PROC Move_Dlg(oDdlg,nRow,nCol)
***********************************
local x := MIN( GetSysmetrics(0) - (nCol + oDdlg:nWidth) , 0 )
oDDlg:Move(nRow	 , nCol + x ,		,	 , .T.)
RETURN

***************************************************************************************
STATIC PROC ChangeAddIndex()
**********************
local Self := oDbfWnd
local oWnd, oBar, oBrw, oMsgBar , oBut[7]
LOCAL oBrwAct    := ::oBrowse
LOCAL cAlias     := ::cAlias
local nOrder
local cPath, cFileName, cExtension
local bClrStd
IF (cAlias)->(IndexOrd())==0 .AND. (cAlias)->(OrdCount()) > 0
	(cAlias)->(DbSetOrder(1))
END
nOrder := (cAlias)->(IndexOrd())
Hb_fNameSplit((cAlias)->(DbInfo(DBI_FULLPATH)),@cPath,@cFileName,@cExtension)

IF (oWnd := SearchWnd("Indexes of " + cFileName,"TMDICHILD")) <> nil
	oWnd:Normal()
	RETURN
ENDIF

DEFINE WINDOW oWnd TITLE "Indexes of " + cFileName MDICHILD	 ;
	 FROM 1 , 1 TO 35 , 95

	 DEFINE BUTTONBAR oBar OF oWnd 2010 SIZE 70, 70

	 DEFINE BUTTON oBut[1] OF oBar PROMPT "Add" RESOURCE "add" ;
			ACTION ( (cAlias)->(NewIndex(oBrw)),					 ;
        (cAlias)->(IndexBuilder(oBrw,.T.)) ,;
							 oBrw:Refresh(),;
							 SetButText(oBut,oBrw),;
							 oBrw:SetFocus(),;
							 oWnd:oBar:AevalWhen())

	 DEFINE BUTTON oBut[2] OF oBar PROMPT "Edit" RESOURCE "edit32" ;
   ACTION ( (cAlias)->(IndexBuilder(oBrw)),;
								oBrw:Refresh(),;
								oBrw:SetFocus(),;
								oWnd:oBar:AevalWhen() )

	 DEFINE BUTTON oBut[3] OF oBar PROMPT "Del" RESOURCE "del32" ;
				 ACTION If( MsgYesNo( "Want to delete this tag ?" ),;
        ( ( cAlias )->( DelTag(oBrw) ), oBrw:Refresh() ),)

	 DEFINE BUTTON oBut[4] OF oBar PROMPT "Rebuild All" RESOURCE "buildall" ;
   ACTION ( (cAlias)->(BuildAllIndex(oBrw)) )

	 DEFINE BUTTON oBut[5] OF oBar PROMPT "Select Order" RESOURCE "goto";
		 ACTION ( (cAlias)->(MySetOrder()) , nOrder := (cAlias)->(IndexOrd()) );
		 GROUP

	 DEFINE BUTTON oBut[6] OF oBar PROMPT "Scope:Top Bottom" RESOURCE "Tiled" ;
		 ACTION ( (cAlias)->(MyScopes(oBrw))	)

	 DEFINE BUTTON OF oBar PROMPT "Report" RESOURCE "report" ;
			ACTION oBrw:Report() GROUP

	 DEFINE BUTTON OF oBar PROMPT "Exit" RESOURCE "exit" ;
			ACTION oWnd:End() GROUP

  @ 0, 0 XBROWSE oBrw OF oWnd ARRAY ::aIndex AUTOCOLS LINES ;
	 HEADERS "Order", "TagName", "Expression", "For", "BagName", "Count" ;
	 COLUMNS {||oBrw:nArrayAt},CTAG,CKEY,CFOR,;
       {||Hb_fNameSplit(::aIndex[oBrw:nArrayAt,CFILENAME],;
															 @cPath,@cFileName,@cExtension),cFileName+cExtension},NCOUNT;
	 COLSIZES 40, 90, 200, 200 , 100, 50
	 WITH OBJECT oBrw
			:nMarqueeStyle = MARQSTYLE_HIGHLROW
			:bChange		:= {||SetButText(oBut,oBrw)}
			:bkeyDown		:= { | nkey | IIF(nkey==13 , EVAL(oBut[2]:bAction)	,;
																							 IIF(nkey==VK_DELETE .AND. EVAL(oBut[3]:bWhen) ,;
																									 EVAL(oBut[3]:bAction)	,	 )	)}
			:bPastEof		:= {||IIF(EVAL(oBut[1]:bWhen) , EVAL(oBut[1]:bAction) , )}
			:bLDblClick := {||EVAL(oBut[2]:bAction) }

			bClrStd := :bClrStd := { || If( oBrw:KeyNo() % 2 == 0, ;
														{ CLR_BLACK, RGB( 198, 255, 198 ) }, ;
														{ CLR_BLACK, RGB( 232, 255, 232 ) } ) }
   :oCol("Order"):bClrStd   := { || IIF(oBrw:nArrayAt==(cAlias)->(IndexOrd()) ,;
																							{ CLR_BLACK, CLR_YELLOW } , EVAL(bClrStd) ) }
			:bClrSel = :bClrSelFocus := { || { CLR_WHITE, RGB( 0x33, 0x66, 0xCC ) } }
			:oCol("Order"):bClrSel			:= { || IIF(oBrw:nArrayAt==(cAlias)->(IndexOrd()) ,;
																							{ CLR_BLACK, CLR_YELLOW } , { CLR_WHITE, RGB( 0x33, 0x66, 0xCC ) }) }
			:oCol("Order"):bClrSelFocus := { || IIF(oBrw:nArrayAt==(cAlias)->(IndexOrd()) ,;
																							{ CLR_BLACK, CLR_YELLOW } , { CLR_WHITE, RGB( 0x33, 0x66, 0xCC ) }) }
			:SetColor( CLR_BLACK, RGB( 232, 255, 232 ) )
			:nDatalines := 2
			:CreateFromCode()
			:SetFocus()
		END
	 oWnd:oClient = oBrw
  oBut[1]:bWhen := {||(cAlias)->(OrdCount())== LEN(oBrw:aArrayData)}
  oBut[4]:bWhen := {||(cAlias)->(OrdCount())== LEN(oBrw:aArrayData)}
	 DEFINE MSGBAR oMsgBar 2010
	 ACTIVATE WINDOW oWnd ON INIT (DlgMove(oWnd,oBrwAct,1),EVAL(oBrw:bChange))
return

//----------------------------------------------------------------------------//
PROC DlgMove(oDlg , oBrwAct , nMode)
*********************************
// Moves right from the browse (when possible) , otherwise Right (nmode == 1) or midle (nmode == 2)
LOCAL		nWd , x
DEFAULT nMode := 1	// 1 RIGHT FROM SCREEN
IF nMode == 1
	nWd := WndMain():nRight - oDlg:nWidth
ELSE
	nWd := GetSysMetrics(0)/2 - oDlg:nWidth/2
END
x := 35 + oBrwAct:oWnd:nLeft
x += oBrwAct:GetDisplayColsWidth()
nWd := MIN(x , nWd)
oDlg:Move(	, nWd ,		,	 , .T.)
RETURN

*******************************************************************************************************
PROC SetButText(oBut,oBrw)
***************************
LOCAL Nr := STR(oBrw:nArrayAt,2)
oBut[2]:SetText("Edit"+CRLF + "Order " + Nr)
oBut[2]:Refresh()
oBut[3]:SetText("Del"+CRLF + "Order " + Nr)
oBut[3]:Refresh()
RETURN

*******************************************************************************************************
function IndexBuilder(oBrw  , lCreate)
***********************
  local Self := oDbfWnd
  local oBrwAct := ::oBrowse
  local oDlg
  local cAlias := ::cAlias
	 local aSubIndex[0] , i
	 local o[NSTART] , Inp[NSTART]	// NSTART , 12 , last inputfield
	 local oBut[1] , oSay[4]
	 local oPgr, nMeter := 0 , nStep := 10
	 local nAt := oBrw:nArrayAt
	 local nRow := oBrw:nRowSel * oBrw:nRowHeight	 + oBrw:HeaderHeight() - 3
	 local nCol := oBrw:oCol("Order"):nDisplayCol
	 local aPoint		:= ClientToScreen( oBrw:hWnd, { nRow, nCol } )
	 LOCAL nTo
	 local bTmp := {|Inp|! Empty(Inp[CWHILE]) .OR. Inp[LTEMPORARY] ;
											 .OR. Inp[LSUBINDEX] .OR. Inp[CSCOPE]<>"All"}
	 local nRw := 4 , nSt := 16
	 local lRegular := .T.
	 local aReg := {CKEY,CFILENAME,CTAG,CFOR,LUNIQUE,LDESCEND}
	 local aTmp := {CWHILE,LTEMPORARY,LSUBINDEX,CSUBINDEX,CSCOPE,NRECORD,NSTART}
	 local bRegular := {||AEVAL(aTmp,{|x|IIF(lRegular,o[x]:Hide(),o[x]:Show())}) ,;
																					 ShowHide(o,oSay,lRegular) , .T.}
  local lFirst
  DEFAULT lCreate := .F.
  IF nAt > (cAlias)->(OrdCount())
     lCreate := .T.
	 END
  lRegular := ! EVAL(bTmp , oBrw:aRow)
  lFirst := lRegular // NEW regular can be changed in non regular
                     // Non regular can not
  
  i := 1
	 AEVAL(oBrw:aArrayData,{|a|IIF(i++<>nAt,AADD(aSubIndex , a[CTAG]),)})
	 nRow		 := aPoint[ 1 ]
	 nCol		 := aPoint[ 2 ]
	 nTo := nRow+400
	 DEFINE DIALOG oDlg OF oBrw:oWnd FROM nRow +2, nCol TO nTo , nCol + oBrw:nWidth*3/4;
												 PIXEL TITLE "Index builder order " + LTRIM(STR(nAt))

	 @ nRw , 100 CHECKBOX lRegular PROMPT "Regular index" OF oDlg SIZE 50 , 10 PIXEL;
        WHEN lCreate .AND. lFirst;
							 ON CHANGE ( EVAL(bRegular) , (cAlias)->(TestProd(o,lRegular,oBrw)) )

	 nRw += nSt
	 @ nRw +2 , 7 SAY "Expression:" OF oDlg SIZE 40, 8 PIXEL RIGHT
	 Inp[CKEY] := SPACE(80)
	 @ nRw , 50	 GET o[CKEY] VAR Inp[CKEY] OF oDlg SIZE 200, 12 PIXEL;
							 ACTION ExpBuilder( o[CKEY] ,"Index key expression") ;
							 VALID If( ! Empty( Inp[CKEY] ), CheckExpression( Inp[CKEY] ), .F. )

	 nRw += nSt
	 @ nRw + 2 , 7 SAY "To:" OF oDlg SIZE 40, 8 PIXEL RIGHT
	 Inp[CFILENAME] := SPACE(80)
	 @ nRw , 50 GET o[CFILENAME] VAR Inp[CFILENAME] OF oDlg SIZE 200, 12 PIXEL;
      PICTURE "@K!" WHEN lRegular VALID ! EMPTY(Inp[CFILENAME]) .AND.;
                                        !(UPPER(Inp[CFILENAME]) = UPPER(Getenv("TEMP")))

	 nRw += nSt
	 @ nRw + 2 , 7 SAY "Tag:" OF oDlg SIZE 40, 8 PIXEL RIGHT

  (cAlias)->(CheckrelTag("Postnr")) //Inp[CTAG]))
  Inp[CTAG] := SPACE(20)
	 @	nRw , 50 GET o[CTAG] VAR Inp[CTAG] OF oDlg SIZE 100, 11 PIXEL;
			PICTURE "@K!";
   WHEN EMPTY(Inp[CTAG]) .OR. (cAlias)->(CheckrelTag(Inp[CTAG]));   // Tagname can not change when it is used in a relation
   VALID ! EMPTY(Inp[CTAG])  // To avoid problems with CSUBINDEX

	 nRw += nSt
	 @ nRw + 2 , 7	SAY "For:" OF oDlg SIZE 40, 8 PIXEL RIGHT

	 @ nRw , 50 GET o[CFOR] VAR Inp[CFOR] OF oDlg SIZE 200, 11 PIXEL;
							ACTION ExpBuilder(o[CFOR],"For expression","L") ;
							VALID If( ! Empty( Inp[CFOR] ), CheckExpression( Inp[CFOR] ) , .T. )

	 nRw += nSt
	 @ nRw + 2 , 7 SAY oSay[3] VAR "While:" OF oDlg SIZE 40, 8 PIXEl RIGHT

	 @ nRw , 50	 GET o[CWHILE] VAR Inp[CWHILE] OF oDlg SIZE 200, 11 PIXEL;
							 ACTION ExpBuilder(o[CWHILE],"While expression","L") ;
        VALID If( ! Empty( Inp[CWHILE] ), IIF(CheckExpression( Inp[CWHILE] ) ,;
          ( Inp[LSUBINDEX] := .T. , o[LSUBINDEX]:Refresh() , .T.) , .F.), .T. )

	 nRw += nSt + 2
	 @ nRw , 50	 CHECKBOX o[LUNIQUE] VAR Inp[LUNIQUE] PROMPT "&Unique";
							 OF oDlg SIZE 50, 8 PIXEL

	 @ nRw , 100 CHECKBOX o[LDESCEND] VAR Inp[LDESCEND] PROMPT "&Descending";
							 OF oDlg SIZE 50, 8 PIXEL

	 @ nRw , 150 CHECKBOX o[LTEMPORARY] VAR Inp[LTEMPORARY] PROMPT "&Memory";
							 OF oDlg SIZE 50, 8 PIXEL

	 @ nRw , 200 CHECKBOX o[LSUBINDEX] VAR Inp[LSUBINDEX] PROMPT "&SubIndex";
							 OF oDlg SIZE 58, 8 PIXEL;
							 ON CHANGE ShowHide(o,oSay)

	 @ nRw+10 , 200 COMBOBOX o[CSUBINDEX] VAR Inp[CSUBINDEX] ITEMS aSubIndex;
									OF oDlg PIXEL VALID ! EMPTY(Inp[CSUBINDEX])

	 nRw += nSt
	 @ nRw , 50	 SAY oSay[4] VAR "Scope:" OF oDlg SIZE 40, 8 PIXEL
	 @ nRw , 100 SAY oSay[1] VAR "Record:" OF oDlg SIZE 40, 8 PIXEL
	 @ nRw , 150 SAY oSay[2] VAR "StartRecord:" OF oDlg SIZE 40, 8 PIXEL

	 nRw += nSt - 6
	 @ nRw , 50	 COMBOBOX o[CSCOPE] VAR Inp[CSCOPE];
							 ITEMS { "All", "Next", "Record", "Rest" } OF oDlg PIXEL;
							 ON CHANGE ShowHide(o,oSay)


	 @ nRw , 100 GET o[NRECORD] VAR Inp[NRECORD] OF oDlg SIZE 30, 10 PIXEL


	 @ nRw , 150 GET o[NSTART] VAR Inp[NSTART] OF oDlg SIZE 30, 10 PIXEL

	 nRw += nSt
	 @ nRw , 50	 SAY "Progress:" OF oDlg SIZE 40, 8 PIXEL

	 nRw += nSt - 6
	 @ nRw , 50 PROGRESS oPgr OF oDlg SIZE 200, 10 PIXEL

	 nRw += nSt
	 IF lCreate
			oBrw:aRow[NSTART] := (cAlias)->(Recno())
			@ nRw , 75 BUTTON oBut[1] PROMPT "Create" OF oDlg SIZE 45, 13 PIXEL;
				WHEN ! EMPTY(Inp[CKEY]) .AND. ! EMPTY(Inp[CTAG])					 ;
				ACTION ( SetBrwValues(o,oBrw) ,												 ;
        (cAlias)->(CreateIndex(oBrw:aRow,;
														{ || nMeter += nStep, oPgr:SetPos( nMeter ), SysRefresh() })),;
								oDlg:end())
	 ELSE
			@ nRw , 75 BUTTON oBut[1] PROMPT "Save" OF oDlg SIZE 45, 13 PIXEL;
				WHEN ! EMPTY(Inp[CKEY]) .AND. ! EMPTY(Inp[CTAG])					;
				ACTION ( SetBrwValues(o,oBrw) , oDlg:end() )
	 END

  @ nRw , 175 BUTTON "&Cancel" OF oDlg SIZE 45, 13;
              ACTION (IIF(lCreate,aDel(::aIndex,LEN(::aIndex),.T.),),oDlg:End());
              CANCEL PIXEL


	 ACTIVATE DIALOG oDlg ON INIT (SetDlgValues(o,oBrw,oSay) , EVAL(bRegular) , MoveDlg(oDlg) )

return nil

************************************************************************************
STATIC PROC SetDlgValues(o,oBrow,oSay)
*******************************
LOCAL i
LOCAL aIndex := oBrow:aRow
FOR i := 1 TO LEN(o)
	o[i]:Varput(aIndex[i])
	o[i]:Refresh()
 IF i == LSUBINDEX .AND. ! aIndex[i]
  //o[CSUBINDEX]:Hide()
	END
NEXT
ShowHide(o,oSay)
RETURN

************************************************************************************
STATIC FUNC ShowHide(o,oSay,lRegular)
*************************************
LOCAL cScope		:= o[CSCOPE]:Varget()
LOCAL lSubIndex := o[LSUBINDEX]:Varget()
IF lRegular <> nil .AND. lRegular
	oSay[1]:Hide()
	oSay[2]:Hide()
	oSay[3]:Hide()
	oSay[4]:Hide()
	o[CSUBINDEX]:Hide()
	o[NRECORD]:Hide()
	o[NSTART]:Hide()
	RETURN .T.
END
oSay[3]:Show()
oSay[4]:Show()
IF lSubIndex
 //o[CSUBINDEX]:Show()
ELSE
 //o[CSUBINDEX]:Hide()
END
IF (cScope IN {"All"})
	oSay[1]:Hide()
	oSay[2]:Hide()
	o[NRECORD]:Hide()
	o[NSTART]:Hide()
ELSE
	IF (cScope IN {"Next","Record"})
		oSay[1]:Show()
		o[NRECORD]:Show()
	END
	oSay[2]:Show()
	o[NSTART]:Show()
END
RETURN .T.

************************************************************************************
STATIC PROC SetBrwValues(o,oBrow)
********************************
LOCAL i
FOR i := 1 TO LEN(o)
	oBrow:aRow[i] := o[i]:Varget()
NEXT
oBrow:Refresh()
RETURN

***************************************************************************************
STATIC PROC NewIndex(oBrow)
***************************
local Self   := oDbfWnd
local nOrder := IndexOrd()
LOCAL lTemporary := .F. , lSubIndex  := .F.
LOCAL cSubIndex  := Space(10)
LOCAL cScope := "All" , nRec := 0 , nStart
LOCAL cFileName := cIndFileName()
LOCAL lRegular  := .T.
IF LEN(oBrow:aArrayData) > 1
   lRegular  := !(UPPER(ATAIL(::aIndex)[CFILENAME])= UPPER(Getenv("TEMP")))
   IF ! lRegular
      cFileName := GetEnv("TEMP") + "\" + DTOS(DATE()) + "." +;
                   CharOnly("0123456789",Time()) + (::cAlias)->(OrdBagExt())
      lSubIndex := lTemporary := .T.
   END
END
AADD(::aIndex , {Space(80),PAD(cFileName,80),Space(20),Space(80),Space(80),;
             .F.,.F.,lTemporary,lSubIndex,cSubIndex,cScope,nRec,nStart,0})

IF nOrder > 0
   Atail(::aIndex)[CSUBINDEX] := ::aIndex[nOrder,CTAG]
END

oBrow:nArrayAt:=LEN(oBrow:aArrayData)
oBrow:Refresh()
RETURN
***************************************************************************************
STATIC FUNC cIndFileName()
***************************
local Self   := oDbfWnd
local cPath,cFileName,cExtension
local a , i

Hb_fNameSplit((::cAlias)->(DbInfo(DBI_FULLPATH)),@cPath,@cFileName,@cExtension)
cExtension := (::cAlias)->(OrdBagExt())
cFileName := UPPER(cFileName+cExtension)
IF LEN(::aIndex) > 0 
  a := aClone(::aIndex)
  aSort(a,{|x,y|a[2,x]<a[2,y]})
  i := ASCAN(a,{|x|UPPER(x[2])=UPPER(GetEnv("TEMP"))}) - 1
  IF i > 0
     cFilename := a[i,CFILENAME]
  END
END
RETURN cFileName

***************************************************************************************
STATIC PROC BuildIndex(aIndex,lBuildTemp)
*****************************************
LOCAL a , i , nReg
local nLen   := LEN(aIndex)
local nOrder := Indexord()
local cAlias := Alias()
DEFAULT lBuildTemp := .F.

nReg := ASCAN(aIndex,{|a|EMPTY(a[2])})

IF OrdCount() > 0
   FOR i := OrdCount() TO IIF(lBuildTemp,nReg,1) STEP -1
       OrdDestroy(i)
   NEXT

   IF ! lBuildTemp
      OrdListClear()
   END
END

FOR i := IIF(lBuildTemp,nReg,1) TO nLen
    (cAlias)->(MsgMeter( { | oMeter, oText, oDlg, lEnd | ;
       (cAlias)->(BCdxIndex( oMeter , oText , oDlg, @lEnd , aIndex[i] )) } ,;
            "IndexKey : " + aIndex[i,CKEY] , "Order : " + STR(i,2) + " " + aIndex[i,CTAG] ))
     
     DbSelectArea(cAlias)
     
     DbSetOrder(i)
     aIndex[i,NCOUNT] := OrdKeyCount()
NEXT
DbSetOrder(nOrder)
RETURN

STATIC PROC BuildAllIndex(oBrw,lBuildTemp)
****************************************************
LOCAL Self    := oDbfWnd
LOCAL oBrwAct := ::oBrowse
LOCAL cAlias  := ::cAlias
LOCAL a , i , nReg
LOCAL aIndex := oBrw:aArrayData
local nLen   := LEN(aIndex)
local aScopes := Array(nLen)
local lCOunt := .F.
local nOrder := Indexord()
DEFAULT lBuildTemp := .F.

nReg := ASCAN(aIndex,{|a|EMPTY(a[2])})
IF ! lBuildTemp
   FOR i := 1 TO LEN(aScopes)
       IF i <= OrdCount()
          aScopes[i] := {OrdName(i) , , , , , }
          AddScopes(aScopes[i],i)  //  , Top , Bottom , nCount , xFirst , xLast
       ELSE
          aScopes[i] := { , , , , , }
       END
   NEXT
END
FOR i := OrdCount() TO IIF(lBuildTemp,nReg,1) STEP -1
    OrdDestroy(i)
NEXT
IF ! lBuildTemp
   OrdListClear()
END
FOR i := IIF(lBuildTemp,nReg,1) TO nLen
    (cAlias)->(MsgMeter( { | oMeter, oText, oDlg, lEnd | ;
       BCdxIndex( oMeter , oText , oDlg, @lEnd , oBrw:aArrayData[i] ) } ,;
            "IndexKey : " + aIndex[i,CKEY] , "Order : " + STR(i,2) + " " + aIndex[i,CTAG] ))
  lCount := .F.
		DbSetOrder(i)
  IF ! lBuildTemp
     IF aScopes[i,2]<>nil .AND. aScopes[i,2] > aScopes[i,5]
        OrdScope(0,aScopes[i,2])
        lCOunt := .T.
     END
     IF aScopes[i,3]<>nil .AND. aScopes[i,3] < aScopes[i,6]
        OrdScope(1,aScopes[i,3])
        lCount := .T.
     END
     IF lCount 
        oBrw:aArrayData[i,NCOUNT] := OrdKeyCount()
     END
  END
NEXT
DbSetOrder(nOrder)
IF oBrw <> nil
   oBrw:Refresh()
END
EVAL(::oWnd:oMsgBar:aItems[MSGTAG]:bMsg)
RETURN

**********************************************************************************
STATIC PROC BCdxIndex( oMeter , oText, oDlg , lEnd , aIndex )
****************************************************************************
LOCAL cAlias := Alias()
oMeter:nTotal = RecCount()
(cAlias)->(CreateIndex(aIndex,{||(oMeter:Set(RecNo() ),SysRefresh(),! lEnd )}))
DbSelectArea(cAlias)
RETU

***************************************************************************************
STATIC PROC CreateIndex(a,bEval)
**********************************************
local cAlias := Alias() //   := ::cAlias //oBrwAct:cAlias
local nOrder := (cAlias)->(IndexOrd())
LOCAL cFor , bFor , cWhile , cSubIndex
LOCAL lAll , bWhile , nInterval := 10 , nStart , nNext	, nRecord , lRest ,;
			lDescend	, lAdditive , lCurrent , lCustom , lNoOptimize , lTemporary := .F.
LOCAL cOrderBagName , cOrderName , ckey , bkey , lUnique

CursorWait()

IF EMPTY(a[CFILENAME])
   a[CFILENAME] := GetEnv("TEMP") + "\" + DTOS(DATE()) + "." +;
                   CharOnly("0123456789",Time()) + (cAlias)->(OrdBagExt())
END

IF EMPTY(a[CTAG]) .OR. EMPTY(a[CKEY])
  RETURN
END

IF ! EMPTY(a[CFILENAME])
		cOrderBagName := a[CFILENAME]
END

lCurrent := a[LSUBINDEX]
cSubIndex := a[CSUBINDEX]

IF ! EMPTY(a[CFOR])
		cFor := ALLTRIM(a[CFOR])
		bFor := COMPILAR(cFor)
END

lAll := (a[CSCOPE] == "All")

IF ! EMPTY(a[CWHILE])
		cWhile := ALLTRIM(a[CWHILE])
		bWhile := COMPILAR(cWhile)
END

IF lCurrent .AND. ! EMPTY(cSubIndex)
		(cAlias)->(OrdSetFocus(cSubIndex))
		IF ! EMPTY(cWhile) .AND. ! a[CSCOPE]$"NextRest"
     (cAlias)->(DbGotop())
     DO WHIL ! (cAlias)->(EVAL(bWhile)) .AND. ! (cAlias)->(Eof())
        (cAlias)->(DbSkip())
     END
		END
END

lDescend := a[LDESCEND]
nStart  := (cAlias)->(RECNO())

IF ! lAll
		IF (a[CSCOPE] IN "RestNext")
     DEFAULT a[NSTART] := (cAlias)->(RECNO())
     nStart := a[NSTART]
     IF a[CSCOPE] = "Rest"
        lRest := .T.
     ELSE
        nNext  := a[NRECORD]
     ENDIF
		ELSEIF a[CSCOPE] == "Record"
     nRecord := a[NRECORD]
		END
END

lTemporary  := a[LTEMPORARY]
cOrderName  := a[CTAG]
ckey        := TRIM(a[CKEY])
bkey        := COMPILAR(cKey)
lUnique     := a[LUNIQUE]
lAdditive   := .T.
 //            1   2   3    4    5     6      7    8     9    10    11   12   13      14     15    16     17    18
(cAlias)->(ordCondSet( cFor , bFor , lAll , bWhile , bEval , nInterval , nStart , nNext  , nRecord , lRest , lDescend , , lAdditive , lCurrent , lCustom , lNoOptimize , cWhile , lTemporary , , .F.))
(cAlias)->(ordCreate(cOrderBagName , cOrderName , ckey , bkey , lUnique))

a[NCOUNT] := (cAlias)->(OrdKeyCount(a[CTAG]))
CursorArrow()
sysrefresh()
RETURN

*************************************************************************************
PROC DelTag(oBrow)
*************************
LOCAL Self    := oDbfWnd
LOCAL oBrwAct := ::oBrowse
LOCAL oCol
LOCAL nOrder := (oBrwAct:cAlias)->(IndexOrd())
LOCAL nAt := oBrow:nArrayAt
LOCAL i
IF ! (nAt == LEN(oBrow:aArraydata) .AND. EMPTY(oBrow:aRow[CTAG]))
	(oBrwAct:cAlias)->(OrdDestroy(nAt))
	IF ! EMPTY(oBrow:aRow[CTAG])
		FOR EACH oCol IN oBrwAct:aCols
			i := Hb_EnumIndex()
			IF oCol:cSortOrder <> nil .AND. oCol:cSortOrder == oBrow:aRow[CTAG]
				oCol:cSortOrder := nil
			END
		NEXT
	END
END
aDel(oBrow:aArrayData,nAt,.T.)
oBrow:nLen := LEN(oBrow:aArrayData)
oBrow:Keycount()
oBrow:nArrayAt := MIN(oBrow:nArrayAt , LEN(oBrow:aArrayData))
SetIndOrd(oBrow,oBrwAct)
oBrow:Refresh(.T.)
EVAL(::oWnd:oMsgBar:aItems[MSGTAG]:bMsg)
RETURN
*******************************************************************************************************
STATIC PROC MoveDlg(oDlg)
*************************
LOCAL x := oDlg:nBottom - WndMain():nBottom
LOCAL nHt := oDlg:nTop , nWd := oDlg:nLeft
IF x > 0
	oDlg:Move(nHt - x	 , nWd ,	, , .T.)
END
RETURN

********************************************************************************************************
STATIC PROC SetIndOrd(oBrow,oBrw)
**********************************
LOCAL oCol
(oBrw:cAlias)->(OrdSetFocus(oBrow:aRow[CTAG]))
oBrow:Refresh()
FOR EACH oCol IN oBrw:aCols
	IF oCol:cSortOrder <> nil .AND. oCol:cSortOrder = UPPER(oBrow:aRow[CTAG])
		AEVAL(oBrw:aCols,{|o|o:cOrder := nil})
		oCol:cOrder := "A"
		oBrw:Refresh()
	END
NEXT
SysRefresh()
RETURN

*********************************************************************************************************
STATIC FUNC TestProd(o,lRegular,oBrw)
*************************************
local Self := oDbfWnd
local cTmpFile

IF ! lRegular
   cTmpFile := GetEnv("TEMP") + "\" + DTOS(DATE()) + "." +;
               CharOnly("0123456789",Time()) + (::cAlias)->(OrdBagExt())
   o[LTEMPORARY]:Varput(.T.)
   o[LTEMPORARY]:Refresh()
ELSE
   cTmpFile := cIndFileName()
END
o[CFILENAME]:Varput(cTmpFile)
o[CFILENAME]:Refresh()
RETURN .T.

**********************************************************************************************************
STATIC PROC Relations()
********************
local self := oDbfWnd
local oWnd, oBar, oBrw, oMsgBar , oBut[5] , aRelation[0] , i
LOCAL oBrwAct    := ::oBrowse
LOCAL cAlias     := ::cAlias
local cPath, cFileName, cExtension
local aInto[0] , el
local lBuild := .F.

FOR EACH el IN aGetWorkAreas()
 IF UPPER(el) <> UPPER(cAlias)
		(el)->(Hb_fNameSplit(DbInfo(DBI_FULLPATH),@cPath,@cFileName,@cExtension))
  AADD(aInto,el)
	END
NEXT

Hb_fNameSplit((cAlias)->(DbInfo(DBI_FULLPATH)),@cPath,@cFileName,@cExtension)

aRelation := ::aRelations
DbSelectArea(cAlias)
FOR i := LEN(aRelation) + 1 TO MIN(LEN(aInto),8)
    AADD(aRelation , {SPACE(80) , SPACE(10)  , .F. , SPACE(10)} )
NEXT

DEFINE WINDOW oWnd TITLE "Relations of " + cAlias MDICHILD  ;
	 FROM 1 , 1 TO 25 , 72

	 DEFINE BUTTONBAR oBar OF oWnd 2010 SIZE 70, 70

	 DEFINE BUTTON oBut[1] OF oBar PROMPT "Add" RESOURCE "add"									;
   WHEN ! EMPTY(ATAIL(aRelation)[1]) .AND. LEN(aRelation) < LEN(aGetWorkAreas()) - 1;
   ACTION ( AADD(aRelation , {SPACE(80) , SPACE(10) , .F. , SPACE(10)  } )       ,;
							 oBrw:nArrayAt := LEN(aRelation)															 ,;
							 (cAlias)->(RelBuilder(oBrw,oBrwAct,aInto,@lBuild))						 ,;
							 oBrw:SetFocus())

	 DEFINE BUTTON oBut[2] OF oBar PROMPT "Edit" RESOURCE "edit32" ;
			ACTION ( (cAlias)->(RelBuilder(oBrw,oBrwAct,aInto,@lBuild)),;
								oBrw:SetFocus())

	 DEFINE BUTTON oBut[3] OF oBar PROMPT "Del" RESOURCE "del32" ;
   ACTION (oBrw:aArrayData[oBrw:nArrayAt] := {SPACE(80),Space(10),.F.,SPACE(10)} ,;
       oBrw:Refresh() , (cAlias)->(BuildAllRel(oBrw , @lBuild )) )

	 DEFINE BUTTON oBut[4] OF oBar PROMPT "Set Relations" RESOURCE "buildall" GROUP ;
			WHEN (lBuild);
   ACTION ( (cAlias)->(BuildAllRel(oBrw , @lBuild )) , oWnd:end() )

	 DEFINE BUTTON oBut[5] OF oBar PROMPT "Clear relations" RESOURCE "goto";
			ACTION ( (cAlias)->(ClearRel(oBrw)) )
		 //GROUP


	 DEFINE BUTTON OF oBar PROMPT "Report" RESOURCE "report" ;
			ACTION oBrw:Report() GROUP

	 DEFINE BUTTON OF oBar PROMPT "Exit" RESOURCE "exit" ;
			ACTION oWnd:End() GROUP

	 @ 0, 0 XBROWSE oBrw OF oWnd ARRAY aRelation AUTOCOLS LINES ;
  HEADERS "Rel", "Expression (TO)", "Child Alias (INTO)", "Scoped","Index tag (INTO)" ;
  COLUMNS {||oBrw:nArrayAt},1,2,3,4;
  COLSIZES 30, 220, 100 , 45 , 100
	 WITH OBJECT oBrw

			:nMarqueeStyle = MARQSTYLE_HIGHLROW
			:bkeyDown		:= { | nkey | IIF(nkey==13 , EVAL(oBut[2]:bAction)	,;
																							 IIF(nkey==VK_DELETE .AND. EVAL(oBut[3]:bWhen) ,;
																									 EVAL(oBut[3]:bAction)	,	 )	)}
			:bLDblClick := {||EVAL(oBut[2]:bAction) }
			:bPastEof		:= {||IIF(EVAL(oBut[1]:bWhen) , EVAL(oBut[1]:bAction) , )}


			:bChange		:= {||SetButText(oBut,oBrw)}

			:bClrStd := { || If( oBrw:KeyNo() % 2 == 0, ;
														{ CLR_BLACK, RGB( 198, 255, 198 ) }, ;
														{ CLR_BLACK, RGB( 232, 255, 232 ) } ) }
			:bClrSel = :bClrSelFocus := { || { CLR_WHITE, RGB( 0x33, 0x66, 0xCC ) } }
			:SetColor( CLR_BLACK, RGB( 232, 255, 232 ) )
			:CreateFromCode()
			:SetFocus()
		END
	oWnd:oClient = oBrw
	DEFINE MSGBAR oMsgBar 2010
	ACTIVATE WINDOW oWnd ON INIT DlgMove(oWnd,oBrwAct,2);
  VALID (cAlias)->(BuildAllRel(oBrw , @lBuild , .T.) , .T.)    
  /*
  VALID ( IIF(lBuild , ;
         IIF(MsgYesNo("Relations are set or changed. Set this (new) relations ?") ,;
          (cAlias)->(BuildAllRel(oBrw , @lBuild)) , );
          , ) , .T. )
  */
return

**************************************************************************************
STATIC PROC RelBuilder(oBrw,oBrwAct,aInto,lBuild)
*************************************************
	 local oDlg
	 local nAt := oBrw:nArrayAt
  local nRow := oBrw:nRowSel * oBrw:nRowHeight  + oBrw:HeaderHeight() //- 3
	 local nCol
	 local aPoint		:= ClientToScreen( oBrw:hWnd, { nRow, nCol } )
	 local nRw := 5 , nSt := 15
	 local nTo
  local Obj[4] , Inp := aClone(oBrw:aRow) 
	 local i
  local aOrd := {SPACE(10)} , cInto  // See combobox    

  nRow   := aPoint[ 1 ]
	 nCol		 := aPoint[ 2 ]
	 nTo		 := nRow+120

  IF EMPTY(Inp[1]) .AND. EMPTY(Inp[2])
     IF LEN(aInto) == 1
        cInto  := aInto[1]
        Inp[2] := cInto
        aOrd := aTags(cInto)
        Inp[4] := aOrd[1]
     END
  ELSE
    cInto  := Inp[2]
    aOrd := aTags(cInto)
  END
	 DEFINE DIALOG oDlg OF oBrw:oWnd FROM nRow +2, nCol TO nTo , nCol + oBrw:nWidth;
												 PIXEL TITLE "Relation builder " + LTRIM(STR(nAt))

	 @ nRw +2 , 7 SAY "To Expression :" OF oDlg SIZE 40, 8 PIXEL RIGHT
  @ nRw , 50  GET Obj[1] VAR Inp[1] OF oDlg SIZE 220, 12 PIXEL;
													ACTION ExpBuilder( Inp[1] ,"RELATION TO expression") ;
			VALID ! Empty( Inp[1] ) .AND. CheckExpression( Inp[1] , .F. )

	 nRw += nSt
	 @ nRw + 2 , 7 SAY "InTo (alias) :" OF oDlg SIZE 40, 8 PIXEL RIGHT
  @ nRw , 50 COMBOBOX Obj[2] VAR Inp[2] OF oDlg ITEMS aInto PIXEL SIZE 50, 12 ;
      PICTURE "@K!";
      WHEN LEN(aInto) > 1;
      VALID (Obj[4]:SetItems(aTags(Inp[2])) , Obj[4]:Select(1) , Obj[4]:Refresh() , .T.) 

  @ nRw - 4 , 129 CHECKBOX Inp[3] OF oDlg PROMPT "Scoped" PIXEL
  
  @ nRw + 2 , 185 SAY "Index tag : " OF oDlg SIZE 40, 8 PIXEL
  
  @ nRw , 220 COMBOBOX Obj[4] VAR Inp[4] OF oDlg ITEMS aOrd SIZE 50 , 12 PIXEL;
      PICTURE "@K!"

	 nRw += nSt*1.5
  @ nRw , 60 BUTTON "Save" OF oDlg SIZE 45, 13 PIXEL;
				WHEN ! EMPTY(Inp[1]) .AND. ! EMPTY(Inp[2])								 ;
    ACTION (i := 1 ,;
								AEVAL(Inp , {|a|oBrw:aRow[i++] := a} )						,;
								oBrw:Refresh()																		,;
								lBuild := .T.																			,;
								oDlg:end() )

	 @ nRw , 175 BUTTON "&Cancel" OF oDlg SIZE 45, 13 ACTION oDlg:End() CANCEL PIXEL


	 ACTIVATE DIALOG oDlg ON INIT (MoveDlg(oDlg) )
	 oBrw:oWnd:oBar:AevalWhen()
return

*******************************************************************************************
STATIC FUNC BuildAllRel(oBrw , lBuild , lFromWndValid  ) //, lIconize)
********************************************************
local self := oDbfWnd
local cAlias := alias() , i , aRow
local Arr
DEFAULT lFromWndValid := .F.
IF PCOUNT() > 1
   IF ! lBuild
      RETURN .T.
   END
   IF lFromWndValid
      IF ! MsgYesNo("Relations are set or changed. Set this (new) relations ?")
         RETURN .T.
      END
   END
END
IF VALTYPE(oBrw) == "A"
   Arr := oBrw
   Self := nil
ELSE
   Arr := oBrw:aArraydata
   //oBrw:oWnd:end()
ENDIF 
(cAlias)->(DbClearRelation())

lBuild := .F.

FOR i := 1 TO LEN(Arr)
    aRow := Arr[i]
    IF ! Empty(aRow[1]) .AND. Select(aRow[2]) > 0
       (cAlias)->(dbSetRelation( aRow[2] , COMPILAR(aRow[1]) , aRow[1] , aRow[3] ))
    END
NEXT
IF VALTYPE(self) == "O" .AND. __ObjHasData(Self,"aRelations")
   ::aRelations := Arr
   oBrw:oWnd:end()
END

RETURN .T.

*********************************************************************************************
STATIC PROC ClearRel(oBrw)
**************************
local cAlias := Alias() , i , aRow
g[cAlias]:aRelations := {}
(cAlias)->(DbClearRelation())
FOR i := 1 TO LEN(oBrw:aArrayData)
 oBrw:aArrayData[i] := {Space(80),Space(10),.F.,Space(10)}
NEXT
oBrw:Refresh()
oBrw:oWnd:Iconize()
RETURN

**************************************************************************************
FUNC DlgDisEnable(lMOde)
************************
LOCAL aDlg[0]
DEFAULT lMode := .F. // Disable
IF ! lMode
	WndMain():oMenu:Disable()
ELSE
	WndMain():oMenu:Enable()
END
RETURN .T.

//----------------------------------------------------------------------------//
// from fivedbu
function ExpBuilder( cExp , cTitle , cType)

	 local oDlg, oBrw, aFields := DBStruct()
	 local oExp, cFunction, nLen := Len( cExp )
	 local Obj
   LOCAL aFunc := { "AllTrim()", "Left()", "Right()", "SubStr()" }
	 DEFAULT cTitle := "Expression builder"
   
   IF cTitle = "Column expression"
      AINS(aFunc , 1 , "FieldBlock()"  , .T.)
      AADD(aFunc , "FieldwBlock()")   
   END
   
   IF VALTYPE(cExp) == "O"
      Obj  := cExp
      cExp := Obj:Varget()
	 END
	 cExp = RTrim( cExp )

	 DEFINE DIALOG oDlg TITLE cTitle SIZE 480, 450

	 @ 0.2, 1.5 SAY "Expression:" SIZE 80, 11 OF oDlg

	 @ 1.1, 1 GET oExp VAR cExp MEMO SIZE 221, 27

	 @ 3, 1.5 SAY "Fields" OF oDlg SIZE 40, 10

	 @ 4, 1 XBROWSE oBrw OF oDlg ARRAY aFields AUTOCOLS LINES SIZE 120, 120;
			HEADERS "Name", "Type", "Len", "Dec" ;
			COLSIZES 95, 30, 30, 30

	 oBrw:nMarqueeStyle := MARQSTYLE_HIGHLROW
	 oBrw:bClrStd = { || If( oBrw:KeyNo() % 2 == 0, ;
												 { CLR_BLACK, RGB( 198, 255, 198 ) }, ;
												 { CLR_BLACK, RGB( 232, 255, 232 ) } ) }
	 oBrw:bClrSel = { || { CLR_WHITE, RGB( 0x33, 0x66, 0xCC ) } }
	 oBrw:SetColor( CLR_BLACK, RGB( 232, 255, 232 ) )

	 oBrw:CreateFromCode()
	 oBrw:bLDblClick = { || cExp += oBrw:aRow[ 1 ], oExp:Refresh() }
	 @ 3, 23.1 SAY "Operators" OF oDlg SIZE 40, 10

	 @ 3.1, 23 BUTTON "=" OF oDlg SIZE 15, 15 ACTION ( cExp += " = ", oExp:Refresh() )

	 @ 3.1, 26.2 BUTTON "<>" OF oDlg SIZE 15, 15 ACTION ( cExp += " <> ", oExp:Refresh() )

	 @ 3.1, 29.4 BUTTON "+" OF oDlg SIZE 15, 15 ACTION ( cExp += " + ", oExp:Refresh() )

	 @ 3.1, 32.6 BUTTON "(" OF oDlg SIZE 15, 15 ACTION ( cExp += " ( ", oExp:Refresh() )

	 @ 3.1, 35.8 BUTTON ".T." OF oDlg SIZE 15, 15 ACTION ( cExp += " .T. ", oExp:Refresh() )

	 @ 4.1, 23 BUTTON "<" OF oDlg SIZE 15, 15 ACTION ( cExp += " < ", oExp:Refresh() )

	 @ 4.1, 26.2 BUTTON ">" OF oDlg SIZE 15, 15 ACTION ( cExp += " > ", oExp:Refresh() )

	 @ 4.1, 29.4 BUTTON "-" OF oDlg SIZE 15, 15 ACTION ( cExp += " - ", oExp:Refresh() )

	 @ 4.1, 32.6 BUTTON ")" OF oDlg SIZE 15, 15 ACTION ( cExp += " )", oExp:Refresh() )

	 @ 4.1, 35.8 BUTTON ".F." OF oDlg SIZE 15, 15 ACTION ( cExp += " .F. ", oExp:Refresh() )

	 @ 5.1, 23 BUTTON "<=" OF oDlg SIZE 15, 15 ACTION ( cExp += " <= ", oExp:Refresh() )

	 @ 5.1, 26.2 BUTTON ">=" OF oDlg SIZE 15, 15 ACTION ( cExp += " >= ", oExp:Refresh() )

	 @ 5.1, 29.4 BUTTON "*" OF oDlg SIZE 15, 15 ACTION ( cExp += " * ", oExp:Refresh() )

	 @ 5.1, 32.6 BUTTON "/" OF oDlg SIZE 15, 15 ACTION ( cExp += " / ", oExp:Refresh() )

	 @ 5.1, 35.8 BUTTON "$" OF oDlg SIZE 15, 15 ACTION ( cExp += " $ ", oExp:Refresh() )

	 @ 6.1, 23 BUTTON '"' OF oDlg SIZE 15, 15 ACTION ( cExp += '"', oExp:Refresh() )

	 @ 6.1, 26.2 BUTTON "!" OF oDlg SIZE 15, 15 ACTION ( cExp += " ! ", oExp:Refresh() )

	 @ 6.1, 29.4 BUTTON "SP" OF oDlg SIZE 15, 15 ACTION ( cExp += " ", oExp:Refresh() )

	 @ 6.1, 32.6 BUTTON "," OF oDlg SIZE 15, 15 ACTION ( cExp += ", ", oExp:Refresh() )

	 @ 6.1, 35.8 BUTTON ":" OF oDlg SIZE 15, 15 ACTION ( cExp += " : ", oExp:Refresh() )

	 @ 7.1, 23 BUTTON "AND" OF oDlg SIZE 27, 15 ACTION ( cExp += " .and. ", oExp:Refresh() )

	 @ 7.1, 28.4 BUTTON "OR" OF oDlg SIZE 27, 15 ACTION ( cExp += " .or. ", oExp:Refresh() )

	 @ 7.1, 33.7 BUTTON "NOT" OF oDlg SIZE 27, 15 ACTION ( cExp += " ! ", oExp:Refresh() )

	 @ 10.3, 23.2 SAY "Functions" OF oDlg SIZE 84, 11

   @ 11.9, 17.3 COMBOBOX cFunction ITEMS aFunc ;
			OF oDlg SIZE 92, 80 ON CHANGE ( cExp += Left( cFunction, Len( cFunction ) - 1 ) + " ",;
																			oExp:Refresh() )
	 @ 11, 13 BUTTON "&Ok" OF oDlg SIZE 45, 13 ;
			ACTION If( ! Empty( cExp ), If( ChKExpr( cExp , , cType), oDlg:End(),), oDlg:End() )

	 @ 11, 24 BUTTON "&Cancel" OF oDlg SIZE 45, 13 ACTION oDlg:End() CANCEL

	 ACTIVATE DIALOG oDlg CENTERED

	 if Empty( cExp )
     cExp = Space( nLen )
	 endif

	 IF !(Obj==nil)
     Obj:Varput(cExp)
     Obj:Refresh()
	 END

return cExp

//----------------------------------------------------------------------------//

function CheckExpression( cExpression , xRet )

	 local bCode := GENBLOCK( cExpression ), lResult := .F., oError

	 TRY
     xRet := Eval( bCode )
     lResult = .T.
	 CATCH oError
     MsgAlert( oError:Description + If( ! Empty( oError:Operation ),;
								CRLF + oError:Operation, "" ) + CRLF + ArgsList( oError ),;
								"Expression error" )
	 END

return lResult

//----------------------------------------------------------------------------//

static function ArgsList( oError )

	 local cArgs := "", n

	 if ValType( oError:Args ) == "A"
     cArgs += "Args:" + CRLF
     for n = 1 to Len( oError:Args )
        cArgs += "  [" + Str( n, 4 ) + "] = " + ValType( oError:Args[ n ] ) + ;
									"		" + cValToChar( oError:Args[ n ] ) + CRLF
     next
	 elseif ValType( oError:Args ) == "C"
     cArgs += "Args:" + oError:Args + CRLF
	 endif

return cArgs

*************************************************
STATIC FUNC IndexRecno(Recno)
***********************************
local Self := HB_QSelf()
local i
IF ::nDataType <> 2
   RETURN (::cAlias)->(Recno())
END
IF PCOUNT() == 0
	RETURN ATAIL(::aRow)
END
i := 0
IF VALTYPE(RecNo)=="N"
   i := ASCAN(::aArrayData,{|a|ATAIL(a)==RecNo})
END
RETURN i
*****************************************************
STATIC FUNC BrwFitSize( lReSize ) //CLASS TXBrowse
********************************  
  local Self := HB_QSelf()
	 local oRect, nX, nY
	 local nWidth			 := ::nWidth
	 local nHeight		 := ::nHeight
//# ifdef FRANKDEMONT
	 local nMaxRows := ::RowCount()
	 IF ! __ObjHasData(Self,"nMaxRows")
     __ObjAddData(Self,"nMaxRows")
	 END
	 IF ::nMaxRows == nil
     ::nMaxRows := ::RowCount()
	 END
	 nMaxRows := ::nMaxRows
//# endif
	 if ::lAdjusted

			DEFAULT lReSize		:= .f., nMaxRows := ::RowCount()

			oRect		 := ::GetCliRect()
			nX						 := nWidth	- oRect:nWidth
			nY						 := nHeight - oRect:nHeight

			nWidth				 := ::GetDisplayColsWidth() + 1 + nX
			nHeight				 := Max( 3, Min( nMaxRows, ::KeyCount() ) ) * ::nRowHeight + ;
												If( ::lHeader, ::nHeaderHeight, 0 ) + ;
												If( ::lFooter, ::nFooterHeight, 0 ) + 1 + nY

			if lReSize
				 oRect := ::oWnd:GetCliRect()
				 ::nWidth		 := Min( nWidth, oRect:nWidth - IfNil( ::nRightMargin, 0 ) * 2 )
				 ::nHeight	 := nHeight
				 if ! Empty( ::nRightMargin )
						::nLeft	 := oRect:nRight - ::nRightMargin - nWidth + 1
				 endif
				 if ! Empty( ::nBottomMargin )
						::nTop	 := oRect:nBottom - ::nBottomMargin - nHeight + 1
				 endif
			endif

	 endif

return { nWidth, nHeight }

**************************************************************************************

STATIC FUNC MsgItemColor( nClrText, nClrPane ) //CLASS TMsgItem
***************************************
	 local self := HB_QSelf()
	 local MemColor := {::nClrText, ::nClrPane }
	 if PCOUNT() == 1 .AND. Valtype(nClrText) == "A"
		IF LEN(nClrText) == 2
			nClrPane := nClrText[2]
			nClrText := nClrText[1]
		END
	 END
	 if ValType( nClrText ) == "N"
			::nClrText = nClrText
	 endif

	 if ValType( nClrPane ) == "N"
			::nClrPane = nClrPane
	 endif

	 if ValType( nClrText ) == "C"
			::nClrText = nGetForeRGB( nClrText )
			::nClrPane = nGetBackRGB( nClrPane )
	 endif

	 ::oMsgBar:Refresh()

return MemColor

****************************************************************************************
STATIC FUNC MsgItemBitMap(cBmp) //CLASS TMsgItem
***********************
local self := HB_QSelf()
if File( cBmp )
	::hBitmap1	= ReadBitmap( 0, cBmp )
	::hPalette1 = 0
else
	::hBitmap1	= LoadBitmap( GetResources(), cBmp )
	::hPalette1 = 0
endif
::Refresh()
::oMsgBar:Refresh()

RETURN self

*****************************************************************************************

PROC dbg(...)
*************
local arr := HB_aParams()
DBG Arr
RETURN

******************************************************************************************
FUNC CheckProcList(cProc)
*************************
LOCAL ok := .F. , i := 0 , hlp
DO WHIL ! ok .AND. ! EMPTY(hlp := PROCNAME(i++))
	ok := (UPPER(cproc) IN hlp)
END
RETU ok

*******************************************************************************************
PROC InsertDbf()
****************
LOCAL oBrwAct			 := oDbfWnd:oBrowse
LOCAL cAlias			 := oBrwAct:cAlias
LOCAL nInsert := oBrwAct:nArrayAt
local cTmpDbf1 , cTmpDbf2 , cTmpDbf3
local cPath,cFileName,cExtension
LOCAL cExt := (cAlias)->(DbInfo( DBI_MEMOEXT)) //(cAlias)->(RddInfo( RDDI_MEMOEXT)) //set(_SET_MFILEEXT)
local lOk , lMemo
local cRdd := (cAlias)->(RddName())

DbSelectArea(cAlias)
nInsert := Recno()
lMemo := lMemo()
Hb_fNameSplit(DbInfo(DBI_FULLPATH),@cPath,@cFileName,@cExtension)
IF EMPTY(cPath)
	cPath := CurDrive()+":\"+CurDir()
END
IF Right(cPath,1) <> "\"
	cPath += "\"
END
cTmpDbf1 := cPath + cFileName + "_"
cTmpDbf2 := GetEnv("TEMP") + "__" + cFilename
IF File(cTmpDbf1 + ".dbf")
	IF ! MsgYesNo(cTmpDbf1 + ".dbf must be erased. Ok ? ")
		RETURN
	END
	IF fErase(cTmpDbf1 + ".dbf") == -1
		? cTmpDbf1 + " can't be erased. Record NOT inserted"
		RETURN
	END
	IF lMemo .AND. File(cTmpDbf1 + cExt)
		IF fErase(cTmpDbf1 + cExt) == -1
			? cTmpDbf1 + cExt + " can't be erased. Record NOT inserted"
			RETURN
		END
	END
END
IF File(cTmpDbf2 + ".dbf")
	IF fErase(cTmpDbf2 + ".dbf") == -1
		? cTmpDbf2 + " can't be erased. Record NOT inserted"
		RETURN
	END
	IF lMemo .AND. File(cTmpDbf2 + cExt)
		IF fErase(cTmpDbf2 + cExt) == -1
			? cTmpDbf2 + cExt + " can't be erased. Record NOT inserted"
			RETURN
		END
	END
END
GO TOP
COPY TO (cTmpDbf1) NEXT nInsert - 1
SKIP
COPY TO (cTmpDbf2) REST
oDbfWnd:oWnd:end()
TRY
	dbUseArea( .F., "DBFCDX", cTmpDbf1 , , .F., .f. )
CATCH
	MsgInfo( cTmpDbf1 + CRLF + 'can not be opened exclusively. Record NOT inserted' )
	return
END
APPEND BLANK
APPEND FROM (cTmpDbf2)
CLOSE
lOk := .T.
IF fErase(cPath + cFileName + ".dbf") == -1
	? cPath + cFileName + ".dbf" + " can't be erased, " + cTmpDbf1 + " can not be renamed but has the inserted record"
	lOk := .F.
END
IF lOk .AND. lMemo .AND. File(cPath + cFileName + cExt)
	IF fErase(cPath + cFileName +	 cExt) == -1
		? cPath + cFileName +	 cExt + " can't be erased. The " + cExt + "- file will be corupted"
		lOk := .F.
	END
END
IF lOk
	IF fRename(cTmpDbf1+".dbf" , cPath + cFileName + ".dbf") == - 1
		? cTmpDbf1 + " can not be renamed to " + cPath + cFileName + ".dbf but has the inserted record"
		lOk := .F.
	END
	IF lOk .AND. lMemo
		IF fRename(cTmpDbf1 + cExt , cPath + cFileName + cExt) == - 1
			? cTmpDbf1 + cExt + " can not be renamed to " + cPath + cFileName + cExt + ". The memo file will be corupted"
			lOk := .F.
		END
	END
END
IF lOk
	File2Brw( cPath + cFileName + ".dbf" , .T.)
END
RETURN

*************************************************************************************************
PROC ModiStruct(cAlias)
***********************
LOCAL oDlg
local cPath, cFileName, cExtension
local cBackup , cText
local cTitle
local oBrw , oSay , oGet[2] , oCheck , oBut[6] , lDelete := .F.
local aStruct , aOld
local x , lNew := .F. , lChanged := .F. , bNew := {||.T.} , nNew
local oClip := TClipBoard():New()
local oFont
local aOrdKey[0] , i , y

DEFINE FONT oFont NAME 'TAHOMA' SIZE 0,-10

if oClip:Open()
	oClip:Clear()
endif
oClip:end()

IF cAlias == nil
	lNew := .T.
END
IF ! lNew
	DbSelectArea(cAlias)
	Hb_fNameSplit(DbInfo(DBI_FULLPATH),@cPath,@cFileName,@cExtension)
	IF EMPTY(cPath)
		cPath := CurDrive()+":\"+CurDir()
	END
	IF Right(cPath,1) <> "\"
		cPath += "\"
	END
	cTitle := "Modify Structure from " + cFileName
	i := 1
	DO WHIL ! EMPTY(x := (cAlias)->(IndexKey(i++)))
		aAdd(aOrdKey,UPPER(x))
	END
	aStruct := (cAlias)->(DbStruct())
	AEVAL(aStruct,{|a|a[1] := PAD(UPPER(a[1]),9)})
	AEVAL(aStruct,{|a|y := AllTrim(a[1]) , aAdd(a,aScan(aOrdKey,{|x|y$x})>0) })		 // 5-the element .T. if the field is used in the key from this tag
ELSE
	aStruct := {{SPACE(9),"C",10,0}}
ENDIF
aOld		:= aClone(aStruct)
DEFINE DIALOG oDlg FONT WndMain():oFont() TITLE cTitle;
	 FROM 0 , 0 TO 345 , 560 PIXEL

@ 5,5 XBROWSE oBrw OF oDlg ;
	SIZE 145 , 160;
	ARRAY aStruct;
	COLUMNS {{||oBrw:nArrayAt},1,2,3,4};
	HEADERS "Pos","Fieldname","Type","Length","Dec";
	COLSIZES 30,80,45,45,30;
	PIXEL AUTOCOLS LINES;
	JUSTIFY AL_RIGHT , AL_LEFT , AL_CENTER , AL_RIGHT , AL_RIGHT

WITH OBJECT oBrw
	:lEnterKey2Edit := .T.
	:lFastEdit			:= .T.
	:lhScroll				:= .F.
	:nMarqueeStyle	:= MARQSTYLE_HIGHLCELL
	:bChange				:= {||oBut[1]:SetText("Insert Record At " + LTRIM(STR(oBrw:nArrayAt))) , oBut[1]:Refresh() ,;
												oBut[3]:SetText("Delete Record "		+ LTRIM(STR(oBrw:nArrayAt))) , oBut[3]:Refresh() ,;
												oBut[5]:SetText("Copy Record "		+ LTRIM(STR(oBrw:nArrayAt))) , oBut[5]:Refresh() ,;
												oBrw:nColSel := 2 , oDlg:AevalWhen() }
	:bClrSel										 := { || { CLR_WHITE, CLR_BLUE } }
	:bClrSelFocus								 := {||{ CLR_WHITE, CLR_HBLUE } }
	:bClrStd										 := { || { CLR_BLACK, CLR_WHITE }}
	:oCol("FieldName"):cEditPicture:= "@K!"
	:oCol("Type"):cEditPicture	 := "!"
	:oCol("Length"):cEditPicture := "999"
	:oCol("Dec"):cEditPicture		 := "99"
	AEVAL(oBrw:aCols , {|oCol|oCol:nEditType:=1})
	:oCol("Pos"):nEditType			 := 0
	:oCol("FieldName"):bEditValid := {|oGet,oCol|IIF(Empty(oGet:Varget()) ,;
																							 .F. , lDupl(oBrw,oGet:Varget()) )}
	:oCol("FieldName"):bEditWhen := {|oGet,oCol|lNew .OR. ! oBrw:aRow[5]}
	:oCol("Type"):nEditType			 := EDIT_GET_LISTBOX
	:oCol("Type"):aEditListTxt	 := {"Numeric","Character","Logical","Date","Memo"}
	:oCol("Type"):aEditListBound := {"N","C","L","D","M"}
	:oCol("Type"):bEditWhen			 := {|oGet|ASCAN(aOld,{|a|a[1]==oBrw:aRow[1]})==0 }
	:oCol("Dec"):bEditWhen			 := {|oGet|oBrw:aRow[2]=="N"}
	:oCol("Type"):bOnPostEdit		 := {|o,x,n|IIF(ASCAN(aOld,{|a|a[1]==oBrw:aRow[1]})==0,;
																				 (o:Value := x , SetLenDec(x,oBrw)) , )}
	FOR x := 2 TO 5
		:aCols[x]:bOnChange = { || lChanged := .T. , oDlg:Aevalwhen() }
	NEXT

END

oBrw:CreateFromCode()

IF ! lNew

	cText := " will be renamed to a backup file."
	cText += " After creating the new structure data from the backup file will be appended."
	@	 5 , 155 SAY cFilename + cText OF oDlg SIZE 115 , 30 PIXEL													 // aControl[2]

	@ 35 , 195 SAY "Backup file : " OF oDlg SIZE 50 , 10	 PIXEL													 // aControl[3]
	cBackup := PAD(cPath + cFileName + "_",50)
	@ 45 , 155 GET oGet VAR cBackup OF oDlg SIZE 120 , 10 PICTURE "@K!S20"	PIXEL					 // aControl[4]

	lDelete := .F.
	@ 57 , 195 CHECKBOX oCheck VAR lDelete PROMPT "Delete backup" OF oDlg SIZE 50 , 10 PIXEL	// aControl[5]
	oCheck:cTooltip := "If yes the backup file will be deleted when the dbf is succesfull created."

ELSE

	cPath := CurDrive()+":\"+CurDir()
	IF Right(cPath,1) <> "\"
		cPath += "\"
	END
	@ 10 , 153	GROUP	 TO 44 , 276 LABEL "DBF path and name" PIXEL OF oDlg
	cFileName := SPACE(20)
	cPath := PAD(cPath,60)
	@ 20 , 155 GET oGet[1] VAR cPath OF oDlg SIZE 120 , 10 PICTURE "@K!S25" PIXEL
	@ 32 , 155 GET oGet[2] VAR cFileName OF oDlg SIZE 120 , 10 PICTURE "@K!" PIXEL;
						 VALID CheckDbfName(oGet,oBut[4],oBrw)

ENDIF
x := Space(25)
@ 67 , 157	SAY oSay VAR x OF oDlg SIZE 120,8 PIXEL FONT oFont
@ 75 , 155	BUTTON oBut[5] PROMPT "Copy Record";
						OF oDlg SIZE 55,15 PIXEL;
						ACTION (oBrw:nMarqueeStyle := 4 , oBrw:Copy() ,			;
										oBrw:nMarqueeStyle := MARQSTYLE_HIGHLCELL , ;
										ShowClip(@oSay,oBrw:aRow) , oBrw:Setfocus() )

@ 75 , 215	BUTTON oBut[6] PROMPT "Paste Record";
						OF oDlg SIZE 55,15 PIXEL;
						WHEN ! EMPTY(ClipText()) .AND. EMPTY(oBrw:aRow[1]) ;
						ACTION (PastField(oBrw , oSay) , oBrw:Setfocus() )

@ 95 , 155	BUTTON oBut[1] PROMPT "Insert Record At ";
						OF oDlg SIZE 55,15 PIXEL;
						WHEN EVAL(bNew) ;
						ACTION (aIns(aStruct,oBrw:nArrayAt,{SPACE(9),"C",10,0,.F.},.T.) ,;
										oBrw:nColSel := 2 , oBrw:Refresh() , oBrw:SetFocus()		,;
										nNew := oBrw:nArrayAt , bNew := {||! EMPTY(oBrw:aArrayData[nNew,1])},;
										lChanged := .T.)

@ 95 , 215	BUTTON oBut[2] PROMPT "Append Record";
						OF oDlg SIZE 55,15 PIXEL;
						WHEN EVAL(bNew);
						ACTION (aAdd(aStruct,{SPACE(9),"C",10,0,.F.}) , oBrw:nColSel := 2 ,;
										EVAL(oBrw:bGoBottom) , oBrw:Refresh() , oBrw:SetFocus(),;
										nNew := oBrw:nArrayAt , bNew := {||! EMPTY(oBrw:aArrayData[nNew,1])},;
										lChanged := .T. )

@ 115 , 185	 BUTTON oBut[3] PROMPT "Delete Record";
						OF oDlg SIZE 55,15 PIXEL;
						WHEN EVAL(bNew) .AND. (lNew .OR. ! oBrw:aRow[5]);						 //arow[5] if .T. this field is used in a indexkey
						ACTION (aDel(aStruct,oBrw:nArrayAt,.T.) , oBrw:nColSel := 2 ,;
										oBrw:Refresh() , oBrw:SetFocus() , lChanged := .T. )


@ 135 , 180 BUTTON oBut[4];
						PROMPT IIF(lNew ,"Create DBF " , "Modify Structure") + CRLF + cFileName;
						OF oDlg SIZE 60,25 PIXEL;
						WHEN EVAL(bNew) .AND. lChanged .AND. (! lNew .OR. ! Empty(cFileName));
						ACTION (cAlias)->(DbfCreate(aStruct,(cAlias)->(DbStruct()),;
																				oDlg, cPath, cFileName, lNew))
						oBut[4]:nStyle	:= NOR( oBut[4]:nStyle, BS_MULTILINE )

ACTIVATE DIALOG oDlg ON INIT (EVAL(oBrw:bChange) , IIF(lNew,oGet[2]:SetFocus(),)) CENTER
oFont:end()
RETURN

*********************************
STATIC FUNC SetLenDec(cType,oBrw)
*********************************
LOCAL i := AT(cType,"LDM") , aLen := {1,8,10}

IF i == 0
   RETURN .T.
END

oBrw:aRow[4] := 0
oBrw:aRow[3] := aLen[i]
oBrw:RefreshCurrent()
oBrw:nColsel := 4
RETURN .T.

****************************
STATIC FUNC lDupl(oBrw,cVar)
****************************
local nAt := oBrw:nArrayAt , lOk := .T.
IF cVar==oBrw:aRow[1]
   RETURN lOk
END
RETURN aScan(oBrw:aArrayData , {|a|cVar==a[1]} ) == 0

****************************************************************************************
STATIC FUNC CheckDbfName(oGet,oBut,oBrw)
***********************************
local cPath := AllTrim(oGet[1]:Varget()) , cFileName := oGet[2]:Varget() , cExt
local cDbf
local oDlg , cTitle
local oRad	, n := 1
local lOk := .F.

IF EMPTY(cFileName)
	RETURN .F.
END
cFileName := cFileNoExt(cFileName)

IF ! Empty(cPath) .AND. Right(cPath,1) <> "\"
   cPath += "\"
END

IF File(cDbf := cPath + cFileName + ".dbf")
   cTitle := cDbf
   DEFINE DIALOG oDlg FONT WndMain():oFont() TITLE cTitle;
      FROM 0 , 0 TO 200 , 560 PIXEL
   @  2 ,10 SAY "1. Erase " + cdbf + " : " SIZE 150,10 OF oDLg PIXEL
   @ 11 ,10 SAY "  existing file is erased , a new file is created " SIZE 150,10 OF oDLg PIXEL
   @ 30 ,10 SAY "2. New File name" SIZE 150,10 OF oDLg PIXEL
   @ 41 ,10 SAY "  File name must be changed in a non existing file" SIZE 150,10 OF oDLg PIXEL
   @ 15 ,155 RADIO oRad VAR n ITEMS "Erase " + cPath + cFileName + ".dbf" , "New File name" OF oDlg PIXEL
   @ 60 ,10 SAY "File name : " SIZE 40 , 10 OF oDlg PIXEL
   cDbf := PAD(cDbf , 80)
   @ 60 ,50 GET cDbf SIZE 215 , 10 OF oDlg PIXEL WHEN n == 2;
						VALID ! File(cDbf)
   @ 80 ,50 BUTTON "OK"   SIZE 40,15 OF oDlg PIXEL ACTION (lOk := .T. , oDlg:end())
   @ 80 ,150 BUTTON "Cancel" SIZE 40,15 OF oDlg PIXEL ACTION oDlg:end()
   ACTIVATE DIALOG oDlg CENTER
ELSE
   lOk := .T.
   n := 0
END
IF lOk
   IF n == 1
      IF fErase(cPath + cFileName + ".dbf") == -1
         ? cDbf + " can't be erased"
         RETURN .F.
      END
   ELSEIF n == 2
      cDbf := AllTrim(cDbf)
      HB_FNameSplit( cDbf , @cPath , @cFileName , @cExt )
      oGet[1]:Varput(cPath)
      oGet[2]:Varput(cFileName)
      Aeval(oGet,{|o|o:refresh()})
   END
ELSE
   RETURN .F.
END
oBut:SetText("Create DBF " + CRLF + TRIM(cFileName))
oBut:Refresh()
oBrw:Setfocus()
RETURN .T.

****************************************************************************************
STATIC PROC PastField(oBrw,oSay)
********************************
local oClip := TClipBoard():New()
local cText , n , i

if oClip:Open()
	cText := oClip:GetText
	oClip:Clear()
endif
oClip:end()
oSay:Varput(Space(25))
oSay:Refresh()

oBrw:aRow[1] := PAD(token(cText,CHR(9),2),9)
FOR i := 2 TO 4
   IF i <= 2
      oBrw:aRow[i] := token(cText,CHR(9),i+1)
   ELSE
      oBrw:aRow[i] := VAL(token(cText,CHR(9),i+1))
   END
NEXT
oBrw:RefreshCurrent()

cText := oBrw:aRow[1]
i := 0
DO While .T.
   i++
   n := 0
   Aeval(oBrw:aArrayData,{|a| n += IIF(a[1]==cText, 1 , 0 ) })
   IF n <= 1 .OR. i == 4 // only 3 attempts
      EXIT
   END
   MsgGet("Duplicate fieldname at " + LTRIM(STR(oBrw:nArrayAt)) , "New Fieldname : " , @cText)
   oBrw:aRow[1] := cText
END
oBrw:aRow[1] := cText
oBrw:RefreshCurrent()
RETURN

****************************************************************************************
PROC DbfCreate(NewStruct , OldStruct , oDlg , cPath , cFileName , lNew)
***********************************************************************
LOCAL lChanged := .F.
LOCAL i , j
local cBackup
local cAlias := Alias()
LOCAL cExt := IIF(lNew , g:MemoExt , (cAlias)->(DbInfo( DBI_MEMOEXT)))
local lDelete
local lShared := .F.
local cRdd := g:cDefRdd
cPath			:= AllTrim(cPath)
cFileName := AllTrim(cFileName)
IF ! lNew
	cRdd := (cAlias)->(RddName())
	cBackup		:= oDlg:aControls[4]:Varget()
	lDelete		:= oDlg:aControls[5]:Varget()
	cBackup := AllTrim(cBackup)
END
IF LEN(NewStruct) <> LEN(OldStruct)
	lChanged := .T.
ELSE
	lChanged := .F.
	FOR i := 1 TO LEN(NewStruct)
		FOR j := 1 TO 4
			IF NewStruct[i,j] <> OldStruct[i,j]
				lChanged := .T.
				EXIT
			END
		NEXT
		IF lChanged
			EXIT
		END
	NEXT
END
IF ! lChanged
	RETURN
END
IF ! CheckFields(OldStruct,NewStruct)
	RETURN
END
IF ! lNew
	IF	FILE(cBackup + '.DBF')
		IF fErase(cBackup + '.DBF') == -1
			? cBackup + ".DBF can't be erased"
			RETURN
		END
	ENDIF
	IF	FILE(cBackup + cExt)
		IF fErase(cBackup + cExt) == -1
			? cBackup + cExt + "can't be erased"
			RETURN
		END
	ENDIF

	IF (cAlias)->(DbInfo(DBI_SHARED))
		lShared := .T.
		IF ! MsgYesNo(cFileName + " must be opened exclusively. Open exclusively ?" )
			RETURN
		END
		SELECT (cAlias)
		oDbfWnd:oWnd:end()
		USE
		TRY
			dbUseArea( .F., cRdd , cFileName , cAlias, .F., .f. )
		CATCH
			MsgInfo( cFileName + CRLF + 'can not be opened exclusively' )
			File2Brw( cPath + cFileName + ".dbf" , .T.)
			return
		END
	END
	USE
	IF lMemo(OldStruct)			// Dbf has memo
		IF ! FILE(cPath + cFileName + cExt)
			? 'Memo file ' + cPath + cFileName + cExt + ' missing.'
			File2Brw( cPath + cFileName + ".dbf" , .T. )
			RETURN
		ELSE
			IF fRename(cPath + cFileName + cExt , cBackup+cExt) == -1
				? cBackup + cExt + "can't be created"
				File2Brw( cPath + cFileName + ".dbf" , .T.)
				RETURN
			END
		ENDIF
	END

	IF fRename(cPath + cFileName +".DBF" , cBackup+".DBF") == -1
		? cBackup + ".DBF can't be created"
		File2Brw( cPath + cFileName + ".dbf" , .T.)
		RETURN
	ENDIF
END
DBCREATE(cPath + cFileName + ".dbf" , NewStruct , cRdd )
USE
IF ! lNew // Modify existing structure
	TRY
		dbUseArea( .F., "DBFCDX", cFileName , cAlias, .F., .f. )
	CATCH
		MsgInfo( cFileName + CRLF + 'can not be opened exclusively' )
		return
	END
	APPEND FROM (cBackup+".dbf")
	USE
	IF lDelete
		IF	FILE(cBackup + '.DBF')
			IF fErase(cBackup + '.DBF') == -1
				? cBackup + ".DBF can't be erased"
			END
		ENDIF
		IF	FILE(cBackup + cExt)
			IF fErase(cBackup + cExt) == -1
				? cBackup + cExt + "can't be erased"
			END
		ENDIF
	END
END
File2Brw( cPath + cFileName + ".dbf" , .T. )
oDlg:end()
RETURN

*************************************************************************************
STATIC FUNC CheckFields(Old , New)
**********************************
LOCAL i , j , k , lOk := .T.
FOR i := 1 TO LEN(New)
	k := ASCAN(Old , {|a|a[1]==new[i,1]})
	IF k > 0
		IF Old[k,2]<>New[i,2]
			? alias() + " , " + Old[k,1] + " : Field type changed from " + Old[k,2] + " in " + New[i,2] + ". Change this inputfield !"
			RETURN .F.
		END
	END
NEXT
RETURN .T.
***************************************************************************************
STATIC FUNC lMemo(aStruct)
*******************
LOCAL lMemo := .F.
LOCAL el
DEFAULT aStruct := (Alias())->(DbStruct())
FOR EACH el IN aStruct
	IF el[2]="M"
		lMemo := .T.
		EXIT
	END
NEXT
RETURN lMemo

*****************************************************************************************
STATIC PROC ShowClip(oSay,aRow)
******************************
local cText := ""
cText := PAD(aRow[1],10) + PAD(aRow[2],3) + STR(aRow[3] , 5) + STR(aRow[4] , 3)
oSay:Varput(cText)
oSay:Refresh()
RETURN

*****************************************************************************************
STATIC FUNC ClipText()
**********************
local oClip := TClipBoard():New()
local cText
if oClip:Open()
	cText := oClip:GetText
endif
oClip:end()
RETURN cText

*****************************************************************************************

PROC QQuit()
*************
CLOS ALL
PostQuitMessage( 0 )
__quit() //Quit
RETURN

*******************************************************************************************

function Preferences()
**********************
	 local oDlg	 , oSay
	 local oCombo , aDateFormat[8] , cDateFormat
	 local i , oFnt
   //local lDbfArray := (g:nDbfArray==1)
	 aDateFormat[1] := "AMERICAN mm/dd/yy"
	 aDateFormat[2] := "ANSI		 yy.mm.dd"
	 aDateFormat[3] := "BRITISH	 dd/mm/yy"
	 aDateFormat[4] := "FRENCH	 dd/mm/yy"
	 //g:DateFormat := aDateFormat[4] := "FRENCH	 dd/mm/yy"
	 aDateFormat[5] := "GERMAN	 dd.mm.yy"
	 aDateFormat[6] := "ITALIAN	 dd-mm-yy"
	 aDateFormat[7] := "JAPAN		 yy/mm/dd"
	 aDateFormat[8] := "USA			 mm-dd-yy"

	 DEFINE FONT oFnt NAME "Courier New" SIZE 0, -12

	 DEFINE DIALOG oDlg TITLE "Preferences" SIZE 400, 200

	 @ 15	 , 10 SAY oSay PROMPT "Default RDD: "	 OF oDlg PIXEL

	 @ 14 , 46	COMBOBOX g:cDefRdd ITEMS { "DBFNTX", "DBFCDX"} ;//, "RDDADS" } ;
			OF oDlg SIZE 35, 30 PIXEL

	 @ 30 , 10 CHECKBOX g:lShared	 PROMPT "Open in shared mode" OF oDlg SIZE 90, 11 PIXEL

	 @ 42 , 10 CHECKBOX g:lAutopen PROMPT "Autopen index file" OF oDlg SIZE 90, 11 PIXEL

  @ 54 , 10 CHECKBOX g:lDefault   PROMPT "Open dbf with default's (no dialog)" OF oDlg SIZE 90, 11 PIXEL

	 @ 66 , 10 CHECKBOX g:lLoadSaveBrw PROMPT "Load,save previous DBF configuration" OF oDlg SIZE 100, 11 PIXEL


	 cDateFormat := g:DateFormat
	 i := ASCAN(aDateFormat,{|a|cDateFormat=RIGHT(a,8)})
	 IF i > 0
		cDateFormat := aDateFormat[i]
	 END
	 @ 5	, 90 GROUP TO 55 , 190 PROMPT "Date Format : "	OF oDlg PIXEL
	 @ 15	 , 100 COMBOBOX oCombo VAR cDateFormat ITEMS aDateFormat STYLE CBS_DROPDOWN PICTURE "@!"	;
   OF oDlg SIZE 80, 60 FONT oFnt PIXEL 

	 oCombo:oGet:bKeyDown = { | nKey | SearchComboItem( nKey, oCombo ) }

	 @ 30	 , 116 SAY	"Set Epoch : "	OF oDlg PIXEL
	 @ 29	 , 146 GET g:Epoch OF oDlg PIXEL PICTURE "9999"
	 @ 42	 , 120 CHECKBOX g:lCent PROMPT "Set Century on" OF oDlg SIZE 90, 11 PIXEL


	 @ 60 , 125 BUTTON "&Ok" OF oDlg SIZE 45, 13 PIXEL;
      ACTION ( g:DateFormat := RIGHT(cDateFormat,8)  ,  SavePreferences(), oDlg:End() )

	 @ 80 , 125 BUTTON "&Cancel" OF oDlg SIZE 45, 13 PIXEL;
			ACTION oDlg:End()

	 ACTIVATE DIALOG oDlg CENTERED

	 oFnt:end()
	 oFnt := nil

return nil
**************************************
function SearchComboItem( nKey, oCbx )
**************************************
	 local nAt

	 if Len( AllTrim( oCbx:oGet:GetText() ) ) == 1
     if ( nAt := AScan( oCbx:aItems, { | c | Left( c, 1 ) == AllTrim( oCbx:oGet:GetText() ) } ) ) != 0
        oCbx:oGet:SetText( oCbx:aItems[ nAt ] )
        return 0
     endif
	 endif

return nKey
//----------------------------------------------------------------------------//

function LoadPreferences(aParams)

	 local oIni
	 local cIniFile , cPath , cFilName , cExtension
  local a , c , h , i , j , f , aKeys
  local aDir[0] , HlpArr[0]
  
  g := Hash()
	 hSetCaseMatch(g , .F.)
  g:cDefRdd    := "DBFCDX"
  g:lShared    := .T.
	 g:DateFormat := "dd/mm/yy"			 // British , French
  g:Epoch      := 1960
  g:lCent      := .T.
  g:lAutopen   := .T.           // Open asociated index file (same name as dbf).
                                // aIndex in xbr-file will overwrite (reindex) if necessary
  g:lDefault   := .T.
  g:MruDbfs    := {}
  g:MemoExt    := ".FPT"
	 g:lLoadSaveBrw := .T.
  g:aAlias     := Hash()
  
  Hb_fNameSplit(exename(),@cPath,@cFilName,@cExtension)
  cIniFile := cPath+"XbrDbu.Ini"
  HlpArr := {}
  i := 0
  AEVAL(aParams , {|a|i++,Hb_fNameSplit(a,@cPath,@cFilName,@cExtension),IIF(UPPER(cExtension)=".XINI",(j := i , AADD(HlpArr,a)) ,)})
  IF LEN(HlpArr) > 1
     MsgAlert("Only one xIni-file is allowed in the startparameters.")
     qquit()
  END
  IF LEN(HlpArr) <= 1
     IF LEN(HlpArr) == 0
        aDir := Directory("*.xini")
        IF LEN(aDir) == 1
           cIniFile := CurDrive() + ":\" + CurDir() + "\" + aDir[1,1]
        ELSEIF LEN(aDir) > 1
           FOR i := 1 TO LEN(aDir)
               aDel(aDir[i],2,.T.)
               aSize(aDir[i],3)
               h := HB_ReadIni(aDir[i,1],.F.)
               c := ""
               IF ("AALIAS" IN h)
                  FOR EACH f IN h:aAlias
                      c += f + " "
                  NEXT
                  aDir[i,3] := c
               END
           NEXT
           IF (c := MsgSelect(aDir)) <> nil
               cIniFile := c
           END
        END
     ELSE
        Hb_fNameSplit(HlpArr[1],@cPath,@cFilName,@cExtension)
        IF UPPER(cExtension) == ".XINI"
           IF EMPTY(cPath)
              cFilName := CurDrive() + ":\" + CurDir() + "\" + cFilName + cExtension
           END
           //IF File(cFilName)
           cIniFile := cFilName
           //END
           aDel(aParams,j,.T.)
        END
     END
  END
  g:cIniFile  := cIniFile
  
  if File( g:cIniFile )
     INI oIni FILE g:cIniFile
         GET g:cDefRdd    SECTION "Default" ENTRY "RDD"            DEFAULT "DBFCDX"   OF oIni
         GET g:lShared    SECTION "Default" ENTRY "Shared"         DEFAULT .T.        OF oIni
         GET g:DateFormat SECTION "Default" ENTRY "DateFormat"     DEFAULT "dd/mm/yy" OF oIni
         GET g:Epoch      SECTION "Default" ENTRY "Epoch"          DEFAULT 1960       OF oIni
         GET g:lCent      SECTION "Default" ENTRY "Cent"           DEFAULT .T.        OF oIni
         GET g:lAutopen   SECTION "Default" ENTRY "Autopen"        DEFAULT .T.        OF oIni
         GET g:lDefault   SECTION "Default" ENTRY "NoUseDialog"    DEFAULT .T.        OF oIni 
         GET g:lLoadSaveBrw SECTION "Default" ENTRY "LoadSaveBrw"  DEFAULT .T.        OF oIni
     ENDINI
     IF LEN(aParams) == 0 .AND. g:lLoadSaveBrw
        h := HB_ReadIni(cIniFile,.F.)
        IF ! ("AALIAS" IN h)
           h:aAlias := Hash()
        END
        g:aAlias := h["AALIAS"]
        aKeys := hGetKeys(g:aAlias)
        ASORT(aKeys)
        FOR  EACH i IN aKeys
            f := g:aAlias[i]
            AADD(aParams,f)
        NEXT
     END
	 endif
	 IF g:cDefRdd == "DBFNTX"
     RDDSetDefault(g:cDefRdd )
     g:MemoExt   := ".DBT"
	 ELSE
     RDDSetDefault("DBFCDX")
     g:MemoExt   := ".FPT"
	 END
	 SET DATE FORMAT TO (g:DateFormat)
	 SET EPOCH TO (g:Epoch)
	 SET CENT (g:lCent)
return nil

//----------------------------------------------------------------------------//

function SavePreferences()

	 local oIni
	 if File( g:cIniFile )
   INI oIni FILE g:cIniFile
     SET SECTION "Default" ENTRY "RDD"         OF oIni TO g:cDefRdd
     SET SECTION "Default" ENTRY "Shared"      OF oIni TO g:lShared
     SET SECTION "Default" ENTRY "DateFormat"  OF oIni TO g:DateFormat
     SET SECTION "Default" ENTRY "Epoch"       OF oIni TO g:Epoch
     SET SECTION "Default" ENTRY "Cent"        OF oIni TO g:lCent
     SET SECTION "Default" ENTRY "Autopen"     OF oIni TO g:lAutopen
     SET SECTION "Default" ENTRY "NoUseDialog" OF oIni TO g:lDefault
     SET SECTION "Default" ENTRY "LoadSaveBrw" OF oIni TO g:lLoadSaveBrw
   ENDINI
	 ENDIF
	 RDDSetDefault(g:cDefRdd )
	 IF g:cDefRdd == "DBFNTX"
     g:MemoExt   := ".DBT"
	 ELSE
     g:MemoExt   := ".FPT"
	 END
	 SET DATE FORMAT TO (g:DateFormat)
	 SET EPOCH TO (g:Epoch)
	 SET CENTURY (g:lCent)

return nil

*****************************************************
FUNC g()
RETURN g

FUNC oDbfWnd()
RETURN oDbfWnd
*****************************************************************
STATIC PROC InitAliasFromh(aIndex , aRelations )// , cFilter , aScopes)
*******************************************************************
LOCAL cFilter := ""
LOCAL cAlias := Alias()
LOCAL hIni   := g[cAlias]:hIni
LOCAL c , x , bIndKey , y , c1 , c2

aIndex := (cAlias)->(LoadhIndex())
CheckIndex(aIndex,hIni:aIndex)

IF ! EMPTY(hIni["MAIN","FILTER"])
   cFilter := hIni["MAIN","FILTER"]
   DbSetFilter(COMPILAR(cFilter),cFilter)
END
     
aRelations := {}
IF ! EMPTY(hIni:aRelations)        
   FOR EACH c IN hIni:aRelations
      AADD(aRelations,{Token(c,";",1,1),Token(c,";",2,1),Token(c,";",3,1)==".T.",Token(c,";",4,1)})    
   NEXT   

   (cAlias)->(BuildAllRel(aRelations))
END
IF ! EMPTY(hIni:SCOPES)        
   FOR EACH c IN hGetKeys(hIni:Scopes)
      x := hIni:Scopes[c]
      OrdSetFocus(c)
      bIndKey := &("{||"+IndexKey()+"}")
      y := VALTYPE(EVAL(bIndKey))
      c1 := Token(x,";",1,1)
      c2 := Token(x,";",2,1)
      IF y <> "C"
          IF y == "N"
              c1 := VAL(c1)
              c2 := VAL(c2)
          ELSEIF y == "D"
              c1 := CTOD(c1)
              c2 := CTOD(c2)
          END
      END
      OrdScope(0,c1)
      OrdScope(1,c2)
   NEXT
END   
RETURN

STATIC PROC InitColumnsFromh(aHeaders , aCols , aSizes , aPict , aExpr , aShows)
****************************************************************
LOCAL cAlias := Alias()
LOCAL hColumns := g[cAlias]:hIni["COLUMNS"]
LOCAL el , c , a , b
local i , aToken[0] , j , Arr[3]
local hRel := g[cAlias]:hIni["ARELATIONS"]
local oError  , cExpression
aHeaders := {}
aCols		 := {}
aSizes	 := {}
aPict		 := {}
aExpr		 := {}
aShows	 := {}
FOR EACH el IN hColumns //hGetKeys(hColumns)
  c := ""
  aToken := {}
  FOR i := 1 TO LEN(el)
      IF el[i]==";"
        AADD(aToken , c)
        c := ""
      ELSE
        c += el[i]
      END
  NEXT
  AADD(aToken,c)
  ASIZE(aToken,5)
  FOR i := 3 TO 5      
      IF aToken[i] == nil
        aToken[i] := ""
      END
  END
  j := ASCAN(aToken,{|a|ASCAN({".T.",".F.",UPPER(cYesLogic),UPPER(cNoLogic)},UPPER(a))>0},3)
  IF j > 2 .AND. j < 5 .AND.;
           ASCAN({".T.",".F.",UPPER(cYesLogic),UPPER(cNoLogic)},UPPER(aToken[5]),,,.T.)==0
    c := aToken[j] 
    aDel(aToken,j,.T.)
    AADD(aToken,c)
  END
  c := aToken[3]
  IF ! EMPTY(c) .AND. CharOnly("1234567809",c) <> ALLTRIM(c)
    c := ""
  END
  c := aToken[4]
  IF ! EMPTY(c) .AND. (! EMPTY(CharRem(" @BCDELXYZ(!AN9#$*.,",c)) .OR. ("@"$c .AND. "R"$c))
    c := ""
  END
  AADD(aHeaders,ALLTRIM(aToken[1]))
  c := aToken[2]
     TRY
        b := &(c)
        IF VALTYPE(b) == "B"
           Eval(b)
        END
     CATCH oError
     MsgAlert( "bEditValue : " + c + CRLF + oError:Description + If( ! Empty( oError:Operation ),;
        CRLF + oError:Operation, "" ) + CRLF + ArgsList( oError ),;
        cAlias + " Col : " + aToken[1] )
        c := "'"+c+"'"
     END
  b := &(c)
  IF VALTYPE(b) <> "B"
     c := "{||"+c+"}"
     b := &(c)
  END
  AADD(aExpr , c)
  AADD(aCols ,b)
  c := aToken[3]
  IF EMPTY(c) .OR. VAL(c) = 0
     c := nil
  ELSE
     c := VAL(c)
  END
  AADD(aSizes ,c)
  c := aToken[4]
  IF EMPTY(c)
     c := nil
  END
  AADD(aPict,c)
  c := aToken[5]
  IF EMPTY(c)
     c := .T.
  ELSE
     c := (ALLTRIM(c)$".T."+cYesLogic)
  END
  AADD(aShows,c)
NEXT
RETURN
*******************************************************************
STATIC PROC SaveTohIni(oDbf_Wnd) //aBrowCols,hIni)
*******************************************
local self := oDbf_Wnd
LOCAL a , o , c , i , j
LOCAL cKey , hTxt
LOCAL hIni := g[::cAlias]:hIni
LOCAL aColBrw := aClone(::oBrowse:aCols)
hDel(hIni,"COLUMNS")
hIni:Columns := Hash()
  
  IF ::lArray
     a := aColBrw[1]
     IF VALTYPE(a) == "O" .AND. a:ClassName=="TXBRCOLCODE"
        IF (i := ASCAN(aColBrw,{|o|UPPER(o:cHeader)="RECNO"})) > 0
           aDel(aColBrw,i,.T.)
        END
     END
  END


FOR EACH a IN aColBrw
		cKey := LTRIM(STR(Hb_EnumIndex()))
		IF VALTYPE(a) == "O" .AND. a:ClassName=="TXBRCOLCODE"//"TXBrwColumn"
     o := a
     a := {o:cHeader , o:cExpr , o:nWidth , o:cEditPicture , !o:lHide}
		END
  hTxt := a[1] + ";" + a[2] + ";"
  c := a[3]
		IF VALTYPE(c) == "N" .AND. c<>0
     c := LTRIM(STR(c))
		ELSE
     c := ""
		END
  hTxt += c + ";" + IIF(a[4]=nil,"",TRIM(a[4])) + ";" + IIF(a[5],".T.",".F.")
		hIni:Columns[cKey] := hTxt
NEXT

  hIni["MAIN","FILTER"] := ::cFilter

  hDel(hIni,"ARELATIONS")
  hIni:aRelations := Hash()
  IF LEN(::aRelations) > 0
     FOR i := 1 TO LEN(::aRelations)
         c := LTRIM(STR(i))
         hIni:aRelations[c] := ALLTRIM(::aRelations[i,1]) + ";" + ALLTRIM(::aRelations[i,2]) + ";" + IIF(::aRelations[i,3] , ".T.;" , ".F.;") + ALLTRIM(::aRelations[i,4])
     NEXT
  END
  hDel(hIni,"SCOPES")
  hDel(hIni,"AINDEX")
  hIni["SCOPES"] := Hash()
  hIni["AINDEX"] := Hash()
  FOR i := 1 TO LEN(::aIndex)
      OrdSetFocus(::aIndex[i,CTAG])
      c := ""
      IF OrdScope(0) <> nil .OR. OrdScope(1) <> nil
         c += IIF(OrdScope(0) <> nil , TRIM(cValToChar(OrdScope(0))) , "" ) + ";"
         c += IIF(OrdScope(1) <> nil , TRIM(cValToChar(OrdScope(1))) , "" )
         hIni:SCOPES[OrdName()] := c            
      END
      c := ""
      
      IF UPPER(TRIM(::aIndex[i,2])) = UPPER(Getenv("TEMP"))
         ::aIndex[i,2] := ""  // no need to write the name
      END

      FOR j := 1 TO LEN(::aIndex[i])
          a := ::aIndex[i,j]
          IF VALTYPE(a) == "C"
             c += ALLTRIM(a)
          ELSEIF VALTYPE(a) == "L"
             c += IIF(a,".T.",".F.")
          ELSEIF VALTYPE(a) ==  "N"
             c += LTRIM(STR(a))
          END
          IF j < LEN(::aIndex[i])
             c += ";"
          END
      NEXT
      cKey := LTRIM(STR(i))
      hIni:AINDEX[cKey] := c
  NEXT
RETURN

********************************************************************
FUNC cHeader(c)
***************
IF VALTYPE(c) <> "C"
 RETURN c
END
c := Lower(c)
c[1] := UPPER(c[1])
RETURN c
************************************************************************
STATIC FUNC bExpr(c)
********************
local b
local lResult := .F., oError
IF EMPTY(c) .OR.VALTYPE(c) <> "C"
  MsgAlert( "bExpr receives wrong parameter")
  RETURN nil
END
b := &(c)
IF VALTYPE(b)<>"B"
  b := &("{||"+c+"}")
ENDIF
return (b)

*******************************************************************************************************

STATIC PROC DbfToArray(lMode,oBtn)
*****************************
local self := oDbfWnd
local oBrw:= ::oBrowse
local aArrayData
local aCols[0] , oCol
local cAlias := ::cAlias
local i , aHeaders[0] , aPict[0] , aSizes[0] , aExpr[0] , aShows[0]
local oBrwCols
local aItem := ::oWnd:oMsgBar:aItems 
local c
local Recno
DEFAULT lMode := .T.
IF lMode
    oBtn:SetText("Dbf Browse")
    oBtn:bAction := {||DbfToArray(.F.,oBtn)}
    oBtn:Refresh()
    Recno := (cAlias)->(Recno())
    ::lArray := .T.
    i := AT(",", ::oWnd:cCaption)
    ::oWnd:cTitle(LEFT(::oWnd:cCaption  , i+1) + "ARRAY BROWSE")
    
    IF oBrw:oCol("Recno") == nil
       oCol := oBrw:AddCol() //umn("Recno",{||recno()})
       oCol:bEditValue := {||Recno()}
       oCol:cHeader := "Recno"
       oCol:cExpr   := "Recno()"
       oCol:Adjust()
    END
    AEVAL(oBrw:aCols,{|o|AADD(aCols,o:bEditValue) , AADD(aHeaders,o:cHeader) ,;
                         AADD(aPict,o:cEditPicture) , AADD(aSizes,o:nWidth)  ,;
                         AADD(aExpr,o:cExpr) , AADD(aShows,o:lHide)})
    
    WITH OBJECT oBrw
         :bLock     := { || (cAlias )->( DbrLock() ) }
         :bUnlock   := { || (cAlias )->( DbrUnlock() ) }
         :lEditMode := .T.
         :bChange := {||(cAlias)->(DbGoto(MAX(1,oBrw:oCol("Recno"):Value))) ,;
                        EVAL(aItem[MSGRECNO]:bMsg),EVAL(aItem[MSGDELETE]:bMsg),;
                        ::oWnd:oMsgBar:Refresh(),(cAlias)->(SetRowEditType( oBrw ))}
    END
    aArrayData := (cAlias)->(ReadDbf(aCols))
    IF LEN(aArrayData)==0
       MsgStop("Empty database can not be opened as array")
       RETURN 
    END
    oBrw:aCols := nil
    oBrw:Setarray(aArrayData,.T.)
    FOR EACH oCol IN oBrw:aCols
        i := Hb_EnumIndex()
        oCol:cHeader      := aHeaders[i]
        oCol:cEditPicture := aPict[i]
        oCol:nWidth       := aSizes[i]
        oCol:cExpr        := aExpr[i]
        oCol:lHide        := aShows[i]

        oCol:bOnPostEdit  := { |o,x,n|  If( n != VK_ESCAPE .and. Eval( o:oBrw:bLock ),;
                                      ( o:Value := x ,  EVAL(bExpr(o:cExpr),x)  , Eval( o:oBrw:bunLock )     ), ) }

        
        oCol:bLClickHeader := {||EVAL(::oWnd:oMsgBar:aItems[MSGTAG]:bMsg)}
        oCol:Adjust()
    NEXT
      
    oBrw:nArrayAt := oBrw:IndexRecNo(Recno)
    oBrw:Refresh()
    aItem[MSGTAG]:bMsg := {||i := MAX(1,ASCAN(oBrw:aCols,{|o|o:cOrder$"AD"})) ,;
                                             aItem[MSGTAG]:SetText("Ordered by: " + oBrw:aCols[i]:cHeader ) }
    EVAL(aItem[MSGTAG]:bMsg)
    aItem[MSGTAG]:bAction := {||MySetOrder() , EVAL(aItem[MSGTAG]:bMsg) }
ELSE
    oBtn:SetText("Array Browse")
    oBtn:bAction := {||DbfToArray(.T.,oBtn)}
    oBtn:Refresh()
    ::lArray := .F.
    i := AT(",", ::oWnd:cCaption)
    ::oWnd:cTitle(LEFT(::oWnd:cCaption  , i+1) + " , Alias : " + cAlias)   
    Recno := ArrayRecno()
    AEVAL(oBrw:aCols,{|o|AADD(aCols,o:bEditValue) , AADD(aHeaders,o:cHeader) ,;
                         AADD(aPict,o:cEditPicture) , AADD(aSizes,o:nWidth)  ,;
                         AADD(aExpr,o:cExpr) , AADD(aShows,o:lHide)})    
    oBrw:aArrayData := nil
    oBrw:SetRdd(,.T.)
    WITH OBJECT oBrw
         :bChange := {||EVAL(aItem[MSGRECNO]:bMsg),EVAL(aItem[MSGDELETE]:bMsg),;
                        ::oWnd:oMsgBar:Refresh(),(cAlias)->(SetRowEditType( oBrw ))}
    END
    oBrw:aCols := {}
    FOR i := 1 TO LEN(aCols) 
        IF !(UPPER(aExpr[i]) = "RECNO()")
           oCol := oBrw:AddCol()
           oCol:cHeader      := aHeaders[i]
           oCol:cEditPicture := aPict[i]
           oCol:nWidth       := aSizes[i]
           oCol:cExpr        := aExpr[i]
           oCol:lHide        := aShows[i]
           oCol:bEditValue   := bExpr(aExpr[i])
           oCol:bOnPostEdit  := { |o,x,n|  If( n != VK_ESCAPE .and. Eval( o:oBrw:bLock ),;
                                      ( o:Value := x  , Eval( o:oBrw:bunLock )     ), ) }

        
           oCol:bLClickHeader := {||EVAL(aItem[MSGTAG]:bMsg)}
           oCol:Adjust()
        END
    NEXT
    SetTagColumns(oBrw)
    (cAlias)->(DbGoto(Recno))
    oBrw:Refresh()
    aItem[MSGTAG]:bMsg := {||c := "Ordered by: "+IIF(! Empty( (cAlias)->( OrdName() )) ,;
                                                      (cAlias)->( OrdName() ),;
                                                       "Natural order" ),;
                                   c += STR((cAlias)->(IndexOrd()),2) +"/" + STR((cAlias)->(OrdCount()),2) ,;
                                   aItem[MSGTAG]:SetText(c) , ::oWnd:oMsgBar:Refresh()}

    EVAL(aItem[MSGTAG]:bMsg)
END
EVAL(oBrw:bChange)
RETURN
************************************************************************************************************
STATIC FUNC ArrayRecno()
*************************
local self := oDbfWnd
local recno := (::cAlias)->(Recno())
local i
IF ::lArray
   i := ASCAN(::oBrowse:aCols,{|o|UPPER(o:cHeader)="RECNO"})
   IF i > 0
      recno := ::oBrowse:aRow[i]
   END   
END
RETURN recno
**************************************************************************************************************
STATIC PROC ShowState(cFile)
****************************
IF ! File(cFile)
   RETURN
END

MemEdit(Memoread(cFile),"VIEW " + cFile+" (Changes have no effect)" , 400 , 600) //, nTop , nLeft , nBottom , nRight) //(ShowState(cIniFile))                
RETURN
***********************************************************************************************
STATIC FUNC SaveaAlias()
************************
LOCAL h , i , a , cKey
IF g:lLoadSaveBrw
   h := Hb_ReadIni(g:cIniFile,.F.)
   hDel(h,"AALIAS")
   h["AALIAS"] := Hash()  
   FOR EACH cKey IN hGetKeys(g)
       IF VALTYPE(g[cKey]) == "H" .AND. ("hIni" IN g[cKey])
          //i := LTRIM(STR(Hb_EnumIndex())) 
          DbSelectArea(cKey)
          i := LTRIM(STR(Select(cKey))) 
          h["AALIAS",i] := DbInfo(DBI_FULLPATH)          
       END
   NEXT
   Hb_WriteIni(g:cIniFile,h)
END
RETURN .T.
*********************************************************************************************
STATIC FUNC aTags(cAlias)
************************
LOCAL i := 1 , a
DEFAULT cAlias := Alias()
a := ARRAY((cAlias)->(OrdCount()))
AEVAL(a , {||a[i] := (cAlias)->(OrdName(i)),i++})
RETURN a
******************************************************************************

STATIC proc MemEdit( cText, cTitle, nH, nW )

   local oFont, oDlg, oMemo, oBtnCancel
   local nLeft , nTop
   DEFAULT nH    := 200
   DEFAULT nW    := 300
   DEFAULT cTitle := "MemoEdit"
   nLeft := GetSysMetrics(0)/2 - nW/2
   nTop  := GetSysMetrics(1)/2 - nH/2

   DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0, -10

   DEFINE DIALOG oDlg FROM nTop, nLeft TO nTop + nH , nLeft + nW ;
      PIXEL;
      TITLE cTitle FONT oFont

   @ 4, 3 GET oMemo VAR cText MEMO OF oDlg PIXEL SIZE 100, 100 FONT oFont
     oMemo:bGotFocus = { || oMemo:SetSel( 0, 0 ) }


   ACTIVATE DIALOG oDlg CENTERED ;
      ON INIT ( oMemo:SetSize( oDlg:nWidth() - 12, oDlg:nHeight() - 40 ),;
                oMemo:SetSel( 0,0 ) )
   oFont:End()


return

******************************************************************************
FUNC DB_SEEK(cSeek,cAlias,xTag)
*******************************
local cTag , lOk
IF cAlias==nil .OR. xTag == nil
   RETURN .F.
END
IF VALTYPE(cAlias) == "C" .AND. Select(cAlias)=0
  RETURN .F.
ELSEIF VALTYPE(cAlias) == "N"
  IF EMPTY(Alias(cAlias))
     RETURN .F.
  END
  cAlias := Alias(cAlias)
END
IF VALTYPE(xTag) == "C" .AND. ASCAN(aTags(cAlias),{|c|UPPER(c)=UPPER(xTag)})==0
  RETURN .F.
END
IF VALTYPE(xTag) == "N" .AND. ! ( xTag > 0 .AND. xTag <= (cAlias)->(OrdCount()) )
  RETURN .F.
END 
cTag := (cAlias)->(OrdSetFocus(xTag))
lOk := (cAlias)->(DbSeek(cSeek))
(cAlias)->(OrdSetFocus(cTag))
RETURN lOk             
//----------------------------------------------------------------//

STATIC func MsgSelect( aItems, cValue, cTitle )
LOCAL j := 1
DEFAULT cTitle := "Please, select xIni-file"
IF cValue <> nil
   j := ASCAN(aItems,cValue)
END
XBROWSER aItems TITLE cTitle ;
  SETUP fSetup(oBrw,3,j);
  SELECT (cValue := oBrw:aCols[1]:Value)
return cValue

//----------------------------------------------------------------//
